commit d6263bec89bcd1565fb0f56a9840cd6f7761097f
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Apr 10 17:34:41 2008 -0700

    Increment cairo version to 1.6.0

 configure.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 709805c26f567b7fa90d04e701ccbf1cccc34da7
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Apr 10 17:33:51 2008 -0700

    NEWS: Add notes for 1.6.0 release

 NEWS | 198 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 190 insertions(+), 8 deletions(-)

commit aadbaf7d990d0d5cd7c25cc856dbcfcc357b44f1
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 02:45:56 2008 -0700

    Increment version to 1.5.20

 configure.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8f123d035af0c02dc0a668a073410756edafbdd6
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 02:45:31 2008 -0700

    NEWS: Add notes for 1.5.20 snapshot

 NEWS | 47 +++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 47 insertions(+)

commit f7dea9a8d3da7f57286db4b1b6300726483a0d76
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 02:28:52 2008 -0700

    Fix distcheck by renaming large-source-ref.c to large-source-ref.png (oops!)

 test/{large-source-ref.c => large-source-ref.png} | Bin
 1 file changed, 0 insertions(+), 0 deletions(-)

commit c26a7de9707e26d0552b0fedcd4bf2e0ba6542b2
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 01:54:27 2008 -0700

    Prevent potentially infinite wandering through memeory in _cairo_hull_prev_valid
    
    It is possible for _cairo_hull_prev_valid to be called just once
    right before the calling loop is going to terminate. In this
    case we really don't want to walk off the beginning of the
    array and start wandering.
    
    Thanks to Jonathan Watt for noticing this problem:
    
            https://bugzilla.mozilla.org/show_bug.cgi?id=306649#c21

 src/cairo-hull.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit c19133eb9ab31bbdc7e82573033e513e9eb867f2
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 01:34:37 2008 -0700

    Revert "[test] Repeat tests using cairo_push_group()."
    
    This reverts commit 07122e64fa9529e7ba9323988a5af1d1e7c2c55f.
    
    The extra testing did find a pdf bug, and that should be fixed,
    but the extra maintenance burden of running another iteration
    of all tests does not seem justfied at all---particularly since
    it looks like dozens of new reference images would be needed
    for the svg backend.
    
    Also, the new "failures" of the image backend with this new
    testing look like a misunderstanding of exactly what the new
    testing is actually drawing.

 test/cairo-test.c | 119 ++++++++----------------------------------------------
 1 file changed, 16 insertions(+), 103 deletions(-)

commit c1f7655f2fd5373a74d3fbf5977ebbd84e401e25
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 8 00:40:58 2008 -0700

    Check surface->status and finished in cairo_surface_write_to_png
    
    Without these checks, a user could hit an assertion failure
    by passing a finished surface to cairo_surface_write_to_png.
    Now we return a nice CAIRO_STATUS_SURFACE_FINISHED error in
    that case instead.

 src/cairo-png.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 33c54ed240b319acb28ef370eef5188ad42a5737
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 22:14:04 2008 +0100

    [test] Add large-source to exercise handling of massive images.
    
    This test exercises https://bugzilla.mozilla.org/show_bug.cgi?id=424333.
    
    The test is expected to fail due to issues with pixman, but cairo
    should fail gracefully and neither crash nor cause XErrors.

 test/.gitignore         |   1 +
 test/Makefile.am        |   3 ++
 test/large-source-ref.c | Bin 0 -> 137 bytes
 test/large-source.c     | 109 ++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 113 insertions(+)

commit 4924d4d928666981f3e64bec685e8f90e524e62e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 23:48:36 2008 +0100

    [cairo-xlib] Do not create surface with mismatching Visual and PictFormat.
    
    As identified by Vladimir Vukicevic,
    _cairo_xlib_surface_create_similar_with_format() was erroneously passing
    down the source Visual when creating a surface with a different
    XRenderPictFormat.

 src/cairo-xlib-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9aac5916bcb4a3e62194315b12961d97f193a585
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 23:42:47 2008 +0100

    [test/xlib-surface] Check for mismatching Visuals and XRenderPictFormats
    
    Vladimir Vukicevic reported that surfaces were being created with
    mismatching Visuals and XRenderPictFormats - and demonstated here.

 test/xlib-surface.c | 63 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 63 insertions(+)

commit f6afba8f5453b8e3af9101fa2cde4c05a67f6d4b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 23:25:57 2008 +0100

    [cairo-xlib] Create Pixmap using depth from xrender_format.
    
    Use the depth as specified by the xrender_format when creating the
    pixmap (as opposed to a guess based on the cairo_format_t).

 src/cairo-xlib-surface.c | 21 ++-------------------
 1 file changed, 2 insertions(+), 19 deletions(-)

commit 922fefdde4af28f9fc1e42fcba1b315980b01dc7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 23:06:18 2008 +0100

    [cairo-xlib] Handle missing RENDER during similar surface creation
    
    If the xserver doesn't support the RENDER extension or simply doesn't
    have the matching PictFormat then xrender_format might be NULL. Check
    and fallback in this case.

 src/cairo-xlib-surface.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 07122e64fa9529e7ba9323988a5af1d1e7c2c55f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 22:00:51 2008 +0100

    [test] Repeat tests using cairo_push_group().
    
    Test surfaces using similar surfaces with both CONTENT_COLOR and
    CONTENT_COLOR_ALPHA, if applicable. This seems justified by the apparent
    bugs in the pdf backend when going from an ARGB32 similar surface to
    a destination RGB24 surface as well as isolated bugs in the image
    backend.
    
    The original goal was to try and trick the test suite into producing
    a xlib surface with mismatching Visual/XRenderPictFormat. This succeeds,
    although with a little bit of brute force in the xlib backend, but the
    search to reproduce a BadMatch error fruitless.

 test/cairo-test.c | 119 ++++++++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 103 insertions(+), 16 deletions(-)

commit e04e4262386b8735d2ceabbc187405cace89dc80
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 10:56:38 2008 +0100

    [test/get-xrender-format] Free static data on exit.
    
    Free the internal caches so that valgrind reports zero leaks.

 test/get-xrender-format.c | 3 +++
 1 file changed, 3 insertions(+)

commit e57ef66fab7cb05b84175b3cfb5c032150cfa682
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 10:51:27 2008 +0100

    [test/xlib-surface] Zero pixel buffers before use.
    
    As we only use RGB24 surface data the alpha channel is undefined, so
    zero it to prevent valgrind warnings.

 test/xlib-surface.c | 24 ++++++++++++++++++++----
 1 file changed, 20 insertions(+), 4 deletions(-)

commit d0672e85ef120a4e3cd0dfcbdb717afbf9526f17
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 10:42:57 2008 +0100

    [test/surface-source] Skip tests if we cannot create the source surface.
    
    Check that the test environment supports the desired source and avoid
    triggering asserts in the test routines.

 test/glitz-surface-source.c | 15 ++++++++++-----
 test/surface-source.c       |  8 ++++++++
 2 files changed, 18 insertions(+), 5 deletions(-)

commit 056d3c853e6660db31ee4a50d0e990a6013aa703
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Apr 7 10:35:04 2008 +0100

    [test/stroke-image] Fix memleak.
    
    Release the temporary image surface after setting it as the source.

 test/stroke-image.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit e460e586d7d093c1e03052efa3bfb45a2d5cf6ef
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 22:02:44 2008 -0700

    Update several pdf-specific reference images
    
    I don't know if we made minor changes to the pdf backend, or
    if this was due to a poppler change, (we recently bumped the
    poppler required for testing up to 0.8.0), but any way around
    it these test results look just as good as the reference images
    they are replacing.

 test/Makefile.am                               |   2 ++
 test/clip-operator-pdf-argb32-ref.png          | Bin 11429 -> 11145 bytes
 test/ft-text-vertical-layout-type1-pdf-ref.png | Bin 0 -> 3604 bytes
 test/ft-text-vertical-layout-type3-pdf-ref.png | Bin 0 -> 3634 bytes
 test/push-group-pdf-ref.png                    | Bin 2694 -> 2807 bytes
 test/push-group-pdf-rgb24-ref.png              | Bin 2611 -> 2714 bytes
 6 files changed, 2 insertions(+)

commit fdcd1445846b59d2ffd1780dd0f6d70169036ad4
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 13:30:59 2008 -0700

    Add filter-bilinear-extents to the XFAIL list
    
    This test case does show a bug, and we have lots of ideas on how
    to fix the bug, but we want to wait until after the 1.6 release
    before we fix it. See:
    
            http://bugs.freedesktop.org/show_bug.cgi?id=15349

 test/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 36246c51ba720713ebf93573da29b098e87f0bd0
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 12:10:24 2008 -0700

    Revert "_cairo_pattern_get_extents: Fix to allow for expansion based on filter"
    
    This reverts commit 731e121c802a7b1c3429d1bde7a93bc471d70880.
    
    This commit introduced various problems, (some likely noticeable
    in the test suite, and others perhaps not). For some details, see
    the latest comments in the original bug report leading to the
    fix now being reverted:
    
            http://bugs.freedesktop.org/show_bug.cgi?id=15349

 src/cairo-pattern.c | 22 ----------------------
 1 file changed, 22 deletions(-)

commit c88adb6aee650c8c544b212f539bd5da9ed88734
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 16:09:03 2008 -0700

    Add svg-specific reference images for smask and smask-mask
    
    The most recent change for the mask_id allocation fixes these
    two test, (it fixes mask-image-mask as well, but it didn't need
    a new reference image).

 test/Makefile.am            |   2 ++
 test/smask-mask-svg-ref.png | Bin 0 -> 2529 bytes
 test/smask-svg-ref.png      | Bin 0 -> 3634 bytes
 3 files changed, 2 insertions(+)

commit 164e9c195c16fbed08539b859a06cc6f042fb5d9
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 15:50:22 2008 -0700

    SVG: Fix generation of mask_id identifiers
    
    In tests such as smask-mask (and others) the cairo_mask operation
    is used in the construction of a mask. In this case, the single
    document->mask_id value was being incremented at inappropriate
    times.
    
    We fix this by adding a new _cairo_svg_document_allocate_mask_id
    that returns the current value and increments it. That way,
    callers can hold onto this reliable value for the desired lifetime
    that the code needs the identifier.

 src/cairo-svg-surface.c | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 8aa306ec08dcf0ae8803cdb1bda0fb31658f9e83
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 14:17:40 2008 -0700

    Add svg-specific reference images for smask-fill, smask-paint, and smask-text tests

 test/Makefile.am             |   3 +++
 test/smask-fill-svg-ref.png  | Bin 0 -> 1166 bytes
 test/smask-paint-svg-ref.png | Bin 0 -> 2612 bytes
 test/smask-text-svg-ref.png  | Bin 0 -> 1886 bytes
 4 files changed, 3 insertions(+)

commit 3d86023281d7d18ad72be85ad8b53c29f20dfc7e
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 14:09:32 2008 -0700

    Add ps-specific reference images for smask and smask-text tests

 test/Makefile.am           |   2 ++
 test/smask-ps-ref.png      | Bin 0 -> 3669 bytes
 test/smask-text-ps-ref.png | Bin 0 -> 2023 bytes
 3 files changed, 2 insertions(+)

commit f2a94c84a160f205ee72cc0c538a556d7d611e7b
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Apr 7 13:03:58 2008 -0700

    Add underscore prefix to private _cairo_pdf_surface_set_size_internal

 src/cairo-pdf-surface.c | 48 ++++++++++++++++++++++++------------------------
 1 file changed, 24 insertions(+), 24 deletions(-)

commit 3d22902fa37623a56dee9e4a20d0dc215deabd72
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Apr 6 19:29:25 2008 +0930

    Add PDF ref images for the smask tests
    
    These tests render correctly in acroread 8.1.

 test/Makefile.am                  |   7 +++++++
 test/smask-fill-pdf-ref.png       | Bin 0 -> 1075 bytes
 test/smask-image-mask-pdf-ref.png | Bin 0 -> 421 bytes
 test/smask-mask-pdf-ref.png       | Bin 0 -> 3731 bytes
 test/smask-paint-pdf-ref.png      | Bin 0 -> 3800 bytes
 test/smask-pdf-ref.png            | Bin 0 -> 3800 bytes
 test/smask-stroke-pdf-ref.png     | Bin 0 -> 449 bytes
 test/smask-text-pdf-ref.png       | Bin 0 -> 1806 bytes
 8 files changed, 7 insertions(+)

commit 688fbc24c38119a505e54a8a2fd0e71e988bf969
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Apr 6 19:04:27 2008 +0930

    PDF: Add a function for changing the surface size
    
    The smask-fill test was failing for PDF output because in some places
    where the surface size is changed (eg when emitting patterns or
    smasks) the cairo_to_pdf matrix was not updated.
    
    Fix this by adding a function to handle the surface size change and
    replace all the duplicated code for changing surface size with a call
    to this function.

 src/cairo-pdf-surface.c | 69 +++++++++++++++++++++++--------------------------
 1 file changed, 33 insertions(+), 36 deletions(-)

commit 6e5e852f739b63f0325927c70e4d4456c60d0ba9
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 03:25:58 2008 -0700

    Increment cairo version to 1.5.19 after the 1.5.18 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6d6c8aa643603c2b5fd7baedc897d4698ba8bafb
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 03:11:04 2008 -0700

    Increment cairo version to 1.5.18 and library versioning to 19:1:17

 configure.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 44cd51ada62f831e4fddd363797b3ad4568fb443
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 03:10:07 2008 -0700

    NEWS: Add notes for 1.5.18 snapshot

 NEWS | 111 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 111 insertions(+)

commit 3f5ce00e99bcbb17594441301ad0845007d0aedf
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 03:09:45 2008 -0700

    Add missing parens() to function name in gtk-doc comment

 src/cairo.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c08e2ba974ad7f5d9343d0d815a00a8e9ad51f81
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 02:56:19 2008 -0700

    Document default opaque black source pattern.

 src/cairo.c | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit e07e1b7bbbac59ae2ea25ed762c017b477e22cc4
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 02:47:32 2008 -0700

    Document many more defaults
    
    Including: fallback_resolution, fill_rule, line_cap, line_join,
    miter_limit, font_face, font_size, and operator.

 src/cairo-surface.c |  3 +++
 src/cairo.c         | 30 ++++++++++++++++++++++++++----
 src/cairo.h         | 10 +++++++++-
 3 files changed, 38 insertions(+), 5 deletions(-)

commit a55669c325c341fa6175a193cb0d6fa30b8247c9
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 02:17:33 2008 -0700

    Document toy nature of cairo_select_font_face

 src/cairo.c | 32 ++++++++++++++++++++++++++------
 1 file changed, 26 insertions(+), 6 deletions(-)

commit d1fe0084405a49f33d4ab6d80e9398e281483900
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 02:17:09 2008 -0700

    Document default extend modes

 src/cairo-pattern.c | 3 +++
 src/cairo.h         | 9 +++++++--
 2 files changed, 10 insertions(+), 2 deletions(-)

commit abe6f9541eb1fe10c063540dbffe3499ec8a9d3e
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 02:01:04 2008 -0700

    Document EXTEND_REFLECT and EXTEND_PAD as implemented for surfaces since 1.6

 src/cairo.h | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 657b348e0172f3b5f2c91a406c2eca039a790ca1
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 01:57:45 2008 -0700

    README: Update dependencies

 README | 139 +++++++++++++++++++++++++++++++++++++++++------------------------
 1 file changed, 89 insertions(+), 50 deletions(-)

commit c642a401959c183de2afa3fba2c4206aa0fdbc0c
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 01:13:17 2008 -0700

    Revert "[README] Remove the Dependencies section as it falls out of date easily"
    
    This reverts commit 5f38e215ed4ec930492ee373db37a767d85a6ee8.
    
    It's true that the dependencies can fall out of date, but it's really
    unkind to not provide users with this information. I think we can
    compromise by committing to update this information before major
    releases.

 README | 89 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 89 insertions(+)

commit b61d1b01e94b3d8daa288b8d5d183f093d989582
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 01:07:32 2008 -0700

    Change default filter from BEST to GOOD
    
    Right now the two filters are implemented identically, so there's
    no real change for now. But in the future, it's conceivable that an
    X server could implement some crazy, high-quality filter for BEST
    without regard to performance, (since that's what BEST means).
    
    Meanwhile, GOOD actually captures what we want by default which is
    a good mix of both quality and performance.

 src/cairoint.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 14b056945cef7e016ec07c87725348f3f0649d9f
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Apr 6 00:34:59 2008 -0700

    Update smask-text reference image
    
    It appears the reference image wasn't generated on a gold-standard
    machine, (and yes, the gold standard is, *ahem* whatever happens
    to match what Carl's machine does---eventually we'll make the test-
    based tests less picky about system configuration like this).

 test/smask-text-ref.png | Bin 1796 -> 1739 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 3a89bf4a1dd37852ca603c2ba472de73959dc69a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 5 22:01:24 2008 +0100

    [test] Remove some redundant evals from the summary.
    
    In a couple of places we used eval to execute a simple assignment -
    complete overkill.

 test/Makefile.am | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit fc0a2988cdcbc54292377b00fe9a82b4a7407918
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 5 21:58:10 2008 +0100

    [test] Disable jobserver with make check.
    
    make -j check has the unfortunate side-effect of performing the summary
    before the TESTS have completed, both hiding in the stream of test
    output and making it useless. Forcibly disable the jobserver so that the
    summary is always last at the expense of not compiling the tests in parallel.

 test/Makefile.am | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit ae6fbe9e6e153a917f3ae8d733e88303e2816b2b
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Apr 6 01:08:31 2008 +1030

    scaled-font-subsets: Special case .notdef in a new subset
    
    If the .notdef glyph is the first glyph in the subset to be mapped in
    scaled font, we do not know if the subset will scaled or unscaled. We
    can put it in the unscaled subset as Type1-fallback will embded an
    empty glyph if it can not get the path.

 src/cairo-scaled-font-subsets.c | 20 +++++++++++++++-----
 1 file changed, 15 insertions(+), 5 deletions(-)

commit 0d5902b7167f8cb4bfc96fd813003cd220441151
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Apr 5 23:33:29 2008 +1030

    Type1-fallback: Use correct glyph metrics for .notdef glyph
    
    Bug 15348 references the following PDF that was printing incorrectly
    when running through poppler and cairo to generate PostScript.
    
    http://launchpadlibrarian.net/12921700/UbuntuDesktop.pdf
    
    The PostScript output had too much space between each word causing
    strings of glyphs printed with the TJ operator to overlap.
    
    The original PDF file contains an CFF font with CID Identity-H
    encoding. The PDF file is using character code 0 (glyph 0 due to
    Identity-H encoding) as a space character. The CFF specification
    defines glyph 0 to be the .notdef glyph.
    
    The PS backend subsets CFF fonts as a Type1-fallback
    font. Type1-fallback creates it's own empty .notdef glyph with an
    arbitrary glyph advance of 500. The problem here is the TJ operator
    used to output the glyphs depends on the glyph advance being
    correct. pdf-operators.c uses the glyph advance returned by
    _scaled_glyph_init(). However the PostScript interpreter sees the
    glyph advance of 500 for .notdef. This problem does not occur when
    generating PDF as the PDF font dictionary contains an list of glyph
    advances that override the font metrics.
    
    Fix this by making Type1-fallback not treat .notdef as special and to
    create it the path and metrics obtained from _scaled_glyph_init(). As
    a special case, make it not fail if _scaled_glyph_init() is unable to
    return a path for .notdef. This was probably the reason Type1-fallback
    previously created it's own .notdef glyph as calling
    _scaled_glyph_init(_GLYPH_INFO_PATH) for glyph 0 returns
    CAIRO_INT_STATUS_UNSUPPORTED for some fonts.
    
    This ensures the Type1-fallback font metrics match the metrics used
    by pdf-operators.c to position the glyphs. This also results in the
    removal of some duplicated code.

 src/cairo-type1-fallback.c | 92 +++++++++++++++-------------------------------
 1 file changed, 29 insertions(+), 63 deletions(-)

commit 03d2b098ff245ff6724b1d83a121f5ce9dcd0b51
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Apr 5 21:15:15 2008 +1030

    Type1-fallback: Use correct glyph advance in Type 1 charstrings
    
    5050c55f93af fixed type1-fallback to use the glyph advance instead of
    glyph width in the stored glyph metrics in the font. However it did
    not fix the same bug in Type 2 charstrings (used by CFF fallback in
    PDF). This problem was not noticed since the glyph widths in the PDF
    font dictionary overrides these values.
    
    Fix this in case any software reading cairo PDFs uses these values.

 src/cairo-type1-fallback.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 40cee8c57879d37d77c5a93de8f7bdef28851923
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Apr 5 20:53:39 2008 +1030

    Add assert to scaled_glyph_lookup in scaled-font-subsets
    
    If _cairo_scaled_glyph_lookup() returns CAIRO_INT_STATUS_UNSUPPORTED
    it will be caught by the ASSERT_NOT_REACHED in
    _emit_unscaled_font_subset in PS/PDF. It is more useful to catch this
    closer to the source.

 src/cairo-scaled-font-subsets.c | 1 +
 1 file changed, 1 insertion(+)

commit 93536bf3ac251d17c4d8630cad93c37b0d4a8326
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Sat Apr 5 09:31:22 2008 +0100

    [test] Summarise failures per backend.
    
    Enhance the test failure summary to list the tests that failed per
    backend.

 test/Makefile.am | 12 ++++++++++--
 1 file changed, 10 insertions(+), 2 deletions(-)

commit 731e121c802a7b1c3429d1bde7a93bc471d70880
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Apr 4 19:00:28 2008 -0700

    _cairo_pattern_get_extents: Fix to allow for expansion based on filter
    
    This fixes the filter-bilinear-extents test case and the
    related bug entry:
    
            bad clipping with EXTEND_NONE
            http://bugs.freedesktop.org/show_bug.cgi?id=15349
    
    Though there are still differences in the PDF and PostScript
    backends, (primarily because we can't capture cairo's filter
    modes in those file formats).

 src/cairo-pattern.c | 22 ++++++++++++++++++++++
 1 file changed, 22 insertions(+)

commit 04608952e2efb9bffaa131ab39780c3e1a7430ba
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Apr 4 18:56:38 2008 -0700

    Replace open-coded transformation with a call to _cairo_matrix_transform_bounding_box
    
    It's a wonderful feeiling to remove duplicate code.

 src/cairo-pattern.c | 61 ++++++++++++++++++++++++-----------------------------
 1 file changed, 27 insertions(+), 34 deletions(-)

commit 89567f9278c002ac5e4e25ddccec88b1b1eea420
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Apr 4 18:28:23 2008 -0700

    Add new filter-bilinear-extents test
    
    This test exercises code that computes the extents of a surface
    pattern with CAIRO_FILTER_BILINEAR, (where the filtering
    effectively increases the extents of the pattern).
    
    The original bug was reported by Owen Taylor here:
    
        bad clipping with EXTEND_NONE
        http://bugs.freedesktop.org/show_bug.cgi?id=15349

 test/.gitignore                      |   1 +
 test/Makefile.am                     |   2 +
 test/filter-bilinear-extents-ref.png | Bin 0 -> 1340 bytes
 test/filter-bilinear-extents.c       |  91 +++++++++++++++++++++++++++++++++++
 4 files changed, 94 insertions(+)

commit 80f7aa03b35921a96683a0442f885c4b8335f3d9
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Apr 4 11:29:47 2008 -0700

    Enable buggy_repeat workaround for X.Org servers < 1.4
    
    This covers the known-to-broken 1.3 servers such as appeared
    in Fedora 8. It also leaves the workaround off, (since it's
    a severe slowdown), for the known-to-be-working 1.4.99.901
    server as appears in Fedora 9 Betas.

 src/cairo-xlib-display.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 2c8ead12a64d0deff4dc9e32c60f2815fe7c4a63
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 17:46:54 2008 +0100

    [xlib] Avoiding sending glyphs > XMaxRequestSize.
    
    XRenderAddGlyph() does not split its image data across multiple requests
    and so the glyph surface must be smaller than XMaxRequestSize or else
    the server will disconnect the client, causing "Fatal IO error 104".
    As this will require an extension to the XRender spec, we can work
    around the issue by using our fallbacks if we detect that the glyph will
    be too large for a single request.
    
    See bugs https://bugs.freedesktop.org/show_bug.cgi?id=4339 and
    http://bugs.freedesktop.org/show_bug.cgi?id=13266 for examples.

 src/cairo-xlib-surface.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit a4f94624b2f4a85bafbc2dc01b08788a7a88deba
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 15:56:22 2008 +0100

    [test] Add bilevel image test case.
    
    Add a simple test to exercise the embedding of an image with a bilevel
    alpha channel into a postscript level 3 document.

 test/.gitignore            |   1 +
 test/Makefile.am           |   2 ++
 test/bilevel-image-ref.png | Bin 0 -> 131 bytes
 test/bilevel-image.c       |  68 +++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 71 insertions(+)

commit f72799a2520feb7ed04fd14e53db59fe697a58d1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 14:15:58 2008 +0100

    [configure.in] Add a link to the LTP homepage.
    
    If ./configure --enable-gcov fails due to a missing LTP package, then
    include a link to LTP homepage in the error message.

 configure.in | 15 ++++++++-------
 1 file changed, 8 insertions(+), 7 deletions(-)

commit c0593d16c7f2ca9c1ba4d05b6cbf3cf9c2f0524b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 12:53:13 2008 +0100

    [pdf] Copy the glyphs for use within an smask group.
    
    When constructing an smask group using PDF_SHOW_GLYPHS, we need a copy
    of the glyphs else they'll be freed be we use them (in _show_page()).

 src/cairo-pdf-surface.c | 9 ++++++++-
 1 file changed, 8 insertions(+), 1 deletion(-)

commit a74db7e7bc092533d244123ea2ae272edf3f5d8f
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 12:34:40 2008 +0100

    [test] Exercise "soft" masks.
    
    PDF has a concept of "soft" masks, for which it is able to construct a
    mask out of PDF drawing operations. These tests exercise constructing
    various masks using the high level drawing operations.

 test/.gitignore               |   7 +++
 test/Makefile.am              |  14 +++++
 test/smask-fill-ref.png       | Bin 0 -> 1223 bytes
 test/smask-fill.c             |  83 +++++++++++++++++++++++++++
 test/smask-image-mask-ref.png | Bin 0 -> 643 bytes
 test/smask-image-mask.c       |  92 ++++++++++++++++++++++++++++++
 test/smask-mask-ref.png       | Bin 0 -> 2523 bytes
 test/smask-mask.c             | 107 ++++++++++++++++++++++++++++++++++
 test/smask-paint-ref.png      | Bin 0 -> 2639 bytes
 test/smask-paint.c            |  90 +++++++++++++++++++++++++++++
 test/smask-ref.png            | Bin 0 -> 3587 bytes
 test/smask-stroke-ref.png     | Bin 0 -> 1845 bytes
 test/smask-stroke.c           |  83 +++++++++++++++++++++++++++
 test/smask-text-ref.png       | Bin 0 -> 1796 bytes
 test/smask-text.c             |  92 ++++++++++++++++++++++++++++++
 test/smask.c                  | 130 ++++++++++++++++++++++++++++++++++++++++++
 16 files changed, 698 insertions(+)

commit 2d42f5ac27494f2bfd75e7bba42fd36783e053eb
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Apr 4 20:29:12 2008 +1030

    TrueType: Fix buffer check
    
    bb76eb50 added some checks to ensure we do not read past the end of
    the buffer for the loaded glyph. However the checks assumed
    tt_composite_glyph_t has a fixed size. tt_composite_glyph_t has a
    variable size that depends on the values with the struct.

 src/cairo-truetype-subset.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 7dbb2dec33bb91b3d89a8072283297025817d0c6
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Apr 4 19:48:55 2008 +1030

    TrueType: Remove assert
    
    If the status is UNSUPPORTED we should let type1-fallback subset it.

 src/cairo-truetype-subset.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 6192001816053403b8e51fc2aa44cf6d0a9baece
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Apr 4 19:26:00 2008 +1030

    Add PS reference image for ft-show-glyphs-table

 test/Makefile.am                     |   1 +
 test/ft-show-glyphs-table-ps-ref.png | Bin 0 -> 5687 bytes
 2 files changed, 1 insertion(+)

commit e50324d3cc66df83120f908845657382e0020868
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Apr 4 19:21:40 2008 +1030

    PS: Fix emulation of 'Td' pdf operator

 src/cairo-ps-surface.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 759793cad1459c2b70daa6adb3deb7af5fe705aa
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Apr 4 09:43:32 2008 +0100

    Add links to the font specifications.
    
    Add links to specifications for the Type1, CFF, and TrueType font file
    formats, provided by Adrian Johnson.

 src/cairo-cff-subset.c      | 5 +++++
 src/cairo-truetype-subset.c | 6 ++++++
 src/cairo-type1-subset.c    | 5 +++++
 3 files changed, 16 insertions(+)

commit 8a78760f15c29c72e6a945b2157fd214e8045e1e
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Apr 3 17:12:14 2008 -0700

    Add new ft-show-glyphs-table test to exercise recent glyph positioning bug fix
    
    Interestingly, this test case does demonstrate that cairo-pdf
    is fixed, (where without commit f6509933a4e0 the Y positions
    of the glyphs were inverted); however, cairo-ps is failing
    with this test, (all the glyphs are ending up on top of each
    other).

 test/.gitignore                   |   1 +
 test/Makefile.am                  |   2 +
 test/ft-show-glyphs-table-ref.png | Bin 0 -> 11439 bytes
 test/ft-show-glyphs-table.c       | 116 ++++++++++++++++++++++++++++++++++++++
 4 files changed, 119 insertions(+)

commit f6509933a4e0abde3b7bca861f65e433b7e8dcf0
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Apr 4 08:41:08 2008 +1030

    PDF: Fix glyph positioning bug

 src/cairo-pdf-operators.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bb76eb508b2d97a4455393a12540ceb7427bc271
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 18:36:16 2008 +0100

    [cairo-truetype-subset] Check reads are within valid data.
    
    Check cairo_truetype_font_remap_composite_glyph() does not read beyond
    the end of the buffer loaded for the glyf.

 src/cairo-truetype-subset.c | 16 ++++++++++++----
 1 file changed, 12 insertions(+), 4 deletions(-)

commit a5e2a2ad2d03c217b9b27c537ee6a945bdc98a44
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 18:24:00 2008 +0100

    [cairo-truetype-subset] Prevent accesses beyond the end of the glyph array.
    
    Reject the font if we try to remap a composite glyph that exists outside
    the known set of glyphs.

 src/cairo-truetype-subset.c | 43 ++++++++++++++++++++++++++++++-------------
 1 file changed, 30 insertions(+), 13 deletions(-)

commit 13cdfed894d48b30e28296c3a27c8361bf5506fb
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 17:43:37 2008 +0100

    [cairo-truetype-subset] Perform a quick sanity check that glyf end >= begin.
    
    Check for a bogus glyf position and prevent an integer overflow.

 src/cairo-truetype-subset.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit cfff3c3bd04df5257176d9e43add52fc6daba329
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 17:23:48 2008 +0100

    [cairo-array] Guard against integer overflow whilst growing the array.
    
    Sanity check the arguments to _cairo_array_grow_by() such that the
    array size does not overflow, similar to the defensive checking of
    parameters to malloc.

 src/cairo-array.c | 12 ++++++++----
 src/cairoint.h    |  2 +-
 2 files changed, 9 insertions(+), 5 deletions(-)

commit 6101dc3e93b20294c75734d7f29e55694ed58e74
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 14:53:17 2008 +0100

    [cairo-pdf-surface] Do not bitswap big-endian A1 masks.
    
    Pixman stores the bits A1 surfaces in native byte order, PDF stores
    A1 masks in MSb - so only perform swapping for little-endian machines.
    
    Note this also removes the extraneous packing as per the PDF spec 4.8.2:
    "Byte boundaries are ignored, except that each row of sample data must
    begin on a byte boundary. If the number of data bits per row is not a
    multiple of 8, the end of the row is padded with extra bits to fill out
    the last byte."

 src/cairo-pdf-surface.c | 30 +++++++-----------------------
 1 file changed, 7 insertions(+), 23 deletions(-)

commit 7901eb29efb04e469f4bf94e2da6fd6b79b140b0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 12:12:25 2008 +0100

    [test] Add a1-mask.
    
    Add a variant of the a8-mask test case that exercises the FORMAT_A1 code
    paths instead.

 test/.gitignore      |   1 +
 test/Makefile.am     |   2 +
 test/a1-mask-ref.png | Bin 0 -> 131 bytes
 test/a1-mask.c       | 198 +++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 201 insertions(+)

commit 5aa5aeb1f56493cf7a6bafd22c6921d8415db64e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 12:09:03 2008 +0100

    [cairo-font-face] Cleanup up the font_face on the error path.
    
    A missing _cairo_toy_font_face_fini() was leaking the strdup(family).

 src/cairo-font-face.c | 1 +
 1 file changed, 1 insertion(+)

commit 048160d44c564b0265b2e740b13d6ed3b367661d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Apr 3 12:11:44 2008 +0100

    [.gitignore] Add test/stroke-image

 test/.gitignore | 1 +
 1 file changed, 1 insertion(+)

commit 9e749d0a287b8038d8a8524ed74626b2d3071538
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Apr 2 23:37:24 2008 -0700

    [cgfont] typo fix

 src/cairo-quartz-font.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3f9b1ceac78976f34a18b551eec376c07db40775
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Apr 2 16:13:53 2008 -0700

    [cgfont] Implement missing scaled font metrics

 src/cairo-quartz-font.c | 74 +++++++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 71 insertions(+), 3 deletions(-)

commit eb3eb0252b13b3d2a3b6acfd13306ff3c6b0506e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 2 14:53:25 2008 +0100

    [cairo-xlib-surface] Avoid writing to the error surface.
    
    Insert status checks during construction of temporary glyph surfaces
    to avoid potentially writing to the inert error object.

 src/cairo-xlib-surface.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit c1062bf20ab60f6335be0814de245616a8d24bd2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 2 10:43:39 2008 +0100

    [cairo-xlib-surface] Preserve Visuals for non-TrueColor similar surfaces.
    
    Previously, given a valid XRenderFormat the Visual was discarded
    when creating similar surfaces. However the original Visual is
    required to support reading back from non-TrueColor surfaces.

 src/cairo-xlib-surface.c | 32 ++++++++++++++++++++------------
 1 file changed, 20 insertions(+), 12 deletions(-)

commit b3a70629f8d1f5d7c23f4369d3395af73318eb28
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Apr 2 09:19:11 2008 +0100

    [test/text-transform] Fix pattern leak.
    
    Add missing cairo_pattern_destroy.

 test/text-transform.c | 10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 37c69c0d54c4b77c96497db4d6633558d4e1300d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 21:49:34 2008 +0100

    [cairo-xlib] Handle malloc failures for cairo_xlib_visual_info_t.
    
    Tidy the error paths whilst handling visuals, in particular avoiding a
    couple of potential NULL deferences, missed status checks and fresh
    leaks.

 src/cairo-xlib-private.h | 15 ++++++++++----
 src/cairo-xlib-screen.c  | 52 +++++++++++++++++++++++++++++++++---------------
 src/cairo-xlib-surface.c | 30 +++++++++++++++++++---------
 src/cairo-xlib-visual.c  | 19 ++++++++++++++----
 4 files changed, 83 insertions(+), 33 deletions(-)

commit 0cd42c25a6f4be1ff27ed3a9ba7fa9a91d076e0d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 19:15:48 2008 +0100

    [cairo-svg-surface] Check surface status before extracting the svg target.
    
    We need to check and report the existent status, else we may try to
    modify the inert error object.

 src/cairo-svg-surface.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 013bbda6373d84d39e080c5e0b305581a2c6919c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 19:15:16 2008 +0100

    [cairo-ps-surface] Check surface status before extracting the ps target.
    
    We need to check and report the existent status, else we may try to
    modify the inert error object.

 src/cairo-ps-surface.c | 5 +++++
 1 file changed, 5 insertions(+)

commit cebb1eef431a38c7c3a96ae60a5bee188f41dc0b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 19:09:21 2008 +0100

    [cairo-svg-surface] Missing status check.
    
    Check and, if necessary, propagate the error status - do not allow the
    status to be overwritten, potentially masking the original error.

 src/cairo-svg-surface.c | 3 +++
 1 file changed, 3 insertions(+)

commit 94db91b65ef42228c963f2d6d82da085f9148895
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 15:47:45 2008 +0100

    [cairo-pdf-surface] Do not mask error during cleanup.
    
    Be careful to preserve the original error status whilst on the common
    cleanup path for _cairo_pdf_surface_emit_meta_surface().

 src/cairo-pdf-surface.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 3580b99a8f99db207b54529f5ac7d0e4325cc123
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 14:25:17 2008 +0100

    [cairo-pdf-surface] Check surface status before extracting the pdf target.
    
    We need to check and report the existent status, else we may try to
    modify the inert error object.

 src/cairo-pdf-surface.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 34d734365bdc1c02cf1880804ab15af48c8d03e1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 11:27:10 2008 +0100

    [cairo-svg-surface] Release acquired surface on error path.
    
    Ensure the surface returned from _cairo_pattern_acquire_surface() is
    released on the error path.

 src/cairo-svg-surface.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit ba2e82d138eecb451c3d0bf53d9c349fb560f039
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Mar 31 10:55:39 2008 +0100

    [cairo-ps-surface] Check error status before potential illegal dereference.
    
    After acquiring the source image, check for the error status to ensure
    that we do not attempt to deference an invalid surface.

 src/cairo-ps-surface.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 767add1ee356660075aaf02283f62a23ef9bcb24
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 28 11:51:13 2008 +0000

    [cairo-pdf-operators] Destroy stream on error.
    
    We cannot guarantee that a newly created error stream is a static error
    object, so we need to always destroy the stream on the error path. (One
    day this may change with the global pool of error objects...)

 src/cairo-pdf-operators.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 2f06284ad6154d1f5fac1a195edbcbc9ed3432cb
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 16:07:22 2008 -0700

    Increment cairo version to 1.5.17 after 1.5.16 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5366c8f483dc7bd40b5d0a184c9b16826007c032
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 15:52:41 2008 -0700

    Increment version to 1.5.16 and library versioning to 19:0:17

 configure.in | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit eb6721f4ccc6ac861e16ec21c7b420645c4f572b
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 15:51:57 2008 -0700

    NEWS: Add notes for the cairo 1.5.16 snapshot

 NEWS | 109 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 109 insertions(+)

commit 8707892b218cb79ef544ba396d4501827b900c32
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 15:40:54 2008 -0700

    Doc SGML template churn

 doc/public/tmpl/cairo-ft.sgml   | 7 +++++++
 doc/public/tmpl/cairo-xlib.sgml | 7 +++++++
 2 files changed, 14 insertions(+)

commit 5d0b2ede52eb6d05a7d5579e6bcd1d4d1850300c
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 15:24:48 2008 -0700

    Mark cairo-quartz as officially supported
    
    An especial thanks to Vladimir Vukicevic and the Mozilla
    Foundation for a tremendous amount of work on cairo-quartz
    while it has been marked as "experimental"

 configure.in | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 07130a9061b012bb5c206dc547b4cc0cc69dcbf1
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 15:20:42 2008 -0700

    Include cairoint.h first to satisfy the test suite
    
    Forgetting to include cairoint.h (or not including it first) can
    cause some subtle bugs due to specific feature flags not being
    set, etc.

 src/cairo-quartz-font.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 46ea00d829bc50ab5316d2257e0d1ed1d8e3f4b6
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 14:53:55 2008 -0700

    More quieting of subtle potentially-uninitialized warnings
    
    The compiler isn't clever enough to notice that these
    variables are always initialized (in either the TrueColor
    or ! TrueColor conditions corresponding to the later
    identical conditions in which the variables are used).

 src/cairo-xlib-surface.c | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 1489e66d250c070c46cb42a1db9ea9f447f464b9
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 14:49:03 2008 -0700

    Quiet a more subtle potentially-uninitialized warning
    
    The compiler isn't clever enough to notice that these
    variables are always initialized.

 src/cairo-rectangle.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit afc6e3b69dcadc63b1dd26a6d67a7da20d7397fe
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Apr 1 14:40:18 2008 -0700

    Quiet some trivial unused and potentially-uninitialized compiler warnings

 src/cairo-gstate.c      | 2 +-
 src/cairo-hull.c        | 2 +-
 src/cairo-ps-surface.c  | 2 +-
 src/cairo-xlib-visual.c | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit d09b0394d59b50ffd3ea8e58f9f57ea4717de754
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 31 16:50:24 2008 -0700

    Add some reference images that were missing from the distribution list

 test/Makefile.am | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 56800e6ea0f7153e44f0cba14c89c4239067a60e
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Apr 1 13:28:03 2008 -0700

    [quartz] Remove cairo-atsui-font.c

 src/cairo-atsui-font.c | 1028 ------------------------------------------------
 1 file changed, 1028 deletions(-)

commit 8ddae11b544c35057a96ca0bdea34b4f473ee261
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Apr 1 13:26:00 2008 -0700

    [quartz] Update documentation

 doc/public/tmpl/cairo-ft.sgml           |  8 --------
 doc/public/tmpl/cairo-quartz-fonts.sgml | 25 +++++++++++++++++++++++++
 doc/public/tmpl/cairo-quartz.sgml       | 25 +++++++------------------
 doc/public/tmpl/cairo-xlib.sgml         |  8 --------
 src/cairo-quartz-font.c                 | 14 ++++++++++++--
 src/cairo-quartz-surface.c              | 18 ++++++++----------
 6 files changed, 52 insertions(+), 46 deletions(-)

commit 9a7162cfdf48f47bb8ee0a7c24c55c061e4fbc90
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Apr 1 13:17:14 2008 -0700

    [doc] Add some Quartz/CGFont documentation templates

 doc/public/cairo-docs.xml               |  1 +
 doc/public/cairo-sections.txt           | 14 ++++++++++++++
 doc/public/tmpl/cairo-quartz-fonts.sgml | 23 +++++++++++++++++++++++
 3 files changed, 38 insertions(+)

commit 56cabc352e44ee7cb2989dd81688f6c37c33fc21
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Apr 1 13:01:41 2008 -0700

    [quartz] Update Quartz test reference images

 test/Makefile.am                               |   3 +++
 test/clip-operator-quartz-ref.png              | Bin 9364 -> 9539 bytes
 test/clip-operator-quartz-rgb24-ref.png        | Bin 4359 -> 4412 bytes
 test/font-matrix-translation-quartz-ref.png    | Bin 1041 -> 1090 bytes
 test/glyph-cache-pressure-quartz-ref.png       | Bin 3491 -> 3654 bytes
 test/linear-gradient-reflect-quartz-ref.png    | Bin 0 -> 878 bytes
 test/operator-clear-quartz-ref.png             | Bin 1368 -> 1459 bytes
 test/operator-clear-quartz-rgb24-ref.png       | Bin 1201 -> 1293 bytes
 test/operator-source-quartz-ref.png            | Bin 4572 -> 4637 bytes
 test/operator-source-quartz-rgb24-ref.png      | Bin 3452 -> 3533 bytes
 test/select-font-face-quartz-ref.png           | Bin 2958 -> 2970 bytes
 test/show-text-current-point-quartz-ref.png    | Bin 3198 -> 3093 bytes
 test/surface-pattern-scale-down-quartz-ref.png | Bin 0 -> 3188 bytes
 test/text-antialias-gray-quartz-ref.png        | Bin 1039 -> 1041 bytes
 test/text-antialias-none-quartz-ref.png        | Bin 304 -> 300 bytes
 test/text-antialias-subpixel-quartz-ref.png    | Bin 1100 -> 1065 bytes
 test/text-pattern-quartz-ref.png               | Bin 0 -> 2158 bytes
 test/text-pattern-quartz-rgb24-ref.png         | Bin 1867 -> 1874 bytes
 test/text-rotate-quartz-ref.png                | Bin 17405 -> 17820 bytes
 test/unbounded-operator-quartz-ref.png         | Bin 4325 -> 4066 bytes
 test/unbounded-operator-quartz-rgb24-ref.png   | Bin 1972 -> 1918 bytes
 21 files changed, 3 insertions(+)

commit 94b67d13f38d860f1a768f9a088e3b6f5d188f7b
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Apr 1 12:44:32 2008 -0700

    [quartz] Handle further 10.4 vs. 10.5 differences; fix text AA handling

 src/cairo-quartz-surface.c | 74 +++++++++++++++++++++++++++-------------------
 1 file changed, 43 insertions(+), 31 deletions(-)

commit a1d1be4234f7787c078ff096b4101e300494e7d1
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 27 23:46:53 2008 -0700

    [cgfont] Round surface rectangle outwards to ensure whole-pixel dimensions

 src/cairo-quartz-font.c | 60 +++++++++++++++++++++++++++++++++++++++----------
 1 file changed, 48 insertions(+), 12 deletions(-)

commit c064ad1b56d11950786a3fd0363e543f5aec1761
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 27 11:42:53 2008 -0700

    [cgfont] Fix whitespace errors

 src/cairo-quartz-font.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 2be3e67db24ac34f772b5fc1182dfb9b730dce11
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Mar 25 22:44:39 2008 -0700

    [cgfont] Add CGFont backend to replace deprecated ATSUI backend
    
    Create a new font backend that uses the CGFont API on MacOS X
    10.4 and beyond.

 src/cairo-quartz-font.c | 124 +++++++++++++++++++++++++++++++++++++++++-------
 1 file changed, 107 insertions(+), 17 deletions(-)

commit 30f7fae6475c36549badf1fcc11ae39d1d79b532
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 20 13:24:48 2008 -0700

    [cgfont] Add start of CGFont font backend to replace ATSUI

 configure.in               |  10 +-
 src/Makefile.am            |   3 +-
 src/cairo-atsui-font.c     |   2 +-
 src/cairo-quartz-font.c    | 590 +++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-quartz-private.h |   5 +
 src/cairo-quartz-surface.c |   1 -
 src/cairo-quartz.h         |   5 +-
 src/cairoint.h             |   4 +-
 8 files changed, 611 insertions(+), 9 deletions(-)

commit 9e6d6798700cf629abbd921cf744babeb49215a1
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Tue Apr 1 16:48:04 2008 +0200

    [SVG] Fix stroke-image test failure.
    
    The pattern transform inherit the object transform matrix, and that was not
    taken into account.

 src/cairo-svg-surface.c | 96 ++++++++++++++++++++++++++++++-------------------
 1 file changed, 60 insertions(+), 36 deletions(-)

commit a571cc56a3e708e37fe112212fbd41ae9071a16b
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 31 12:17:39 2008 -0700

    Update pixman dependency to recent 0.10.0 release

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e9adba9a57177a1b5755734db25d08513a30c0b7
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 31 12:15:06 2008 -0700

    Update ps-specifc reference image for ft-text-vertical-layout-type1
    
    Presumably this minor change happened due to a recent fix in
    cairo-ps glyph positioning.

 test/ft-text-vertical-layout-type1-ps-ref.png | Bin 1911 -> 1910 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit a30ed53a1ce37f68f2ee8abf0f631bcc180e0e57
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Mar 30 00:13:35 2008 +1030

    Add stroke-image PS/PDF ref images

 test/stroke-image-pdf-ref.png | Bin 0 -> 1554 bytes
 test/stroke-image-ps-ref.png  | Bin 0 -> 1786 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit a729f27f3c5770277d691257d2355ffb97e3172f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Mar 30 00:07:05 2008 +1030

    Add clip-operator PS/PDF rgb24 ref images

 test/clip-operator-pdf-rgb24-ref.png | Bin 0 -> 6530 bytes
 test/clip-operator-ps-rgb24-ref.png  | Bin 0 -> 4620 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 9058b9260acce8839263fccf451a982bcb1c54f3
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 29 23:49:51 2008 +1030

    Add operator-source PDF ref images
    
    Required due to gradient rendering differences between poppler and
    cairo.

 test/operator-source-pdf-argb32-ref.png | Bin 0 -> 4694 bytes
 test/operator-source-pdf-rgb24-ref.png  | Bin 0 -> 3848 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 47981226db1650799ddb5efba01df2564aa1a3b5
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 29 23:45:31 2008 +1030

    Fix PDF analysis of OPERATOR_SOURCE surface patterns

 src/cairo-pdf-surface.c | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 53d1a4b0dcb3a1fa62face9d2b5b086d74b6e397
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 29 23:03:02 2008 +1030

    Update operator-source PS ref images

 test/operator-source-ps-argb32-ref.png | Bin 3893 -> 3890 bytes
 test/operator-source-ps-rgb24-ref.png  | Bin 3241 -> 3181 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit b3b3e3810d6ea9e75d5accd8e0d2ad00f664b4a5
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 29 19:14:18 2008 +1030

    PS: Clear pattern background to when using OPERATOR_SOURCE
    
    Set pattern background to white if surface content is COLOR_ALPHA or
    black if surface content is COLOR when operator is SOURCE.

 src/cairo-ps-surface.c | 43 +++++++++++++++++++++++++++----------------
 1 file changed, 27 insertions(+), 16 deletions(-)

commit 5b8b3a9765d292d554b50df0981652d3bb4ec56f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 29 01:07:30 2008 +1030

    PS/PDF: Save/Restore surface clip when emitting a meta-surface pattern

 src/cairo-pdf-surface.c | 6 ++++++
 src/cairo-ps-surface.c  | 6 ++++++
 src/cairo-surface.c     | 6 ++++++
 src/cairoint.h          | 3 +++
 4 files changed, 21 insertions(+)

commit e4fd9b4ea2e8cc378471c4f536236faa73467977
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Thu Mar 27 09:06:11 2008 +1030

    Bump poppler version required for testing to 0.8.0
    
    The poppler specific reference images are created from the latest
    version of poppler in git. The main reason has been for support for
    knockout groups that had not yet been available in a stable release.
    
    Poppler 0.8.0 is the first stable release to include the support for
    knockout groups.

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit af8928fa8bb8905515f36b4ddc51e665b4b8da56
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 26 14:21:58 2008 -0700

    Add svg-specific reference image for ft-show-glyphs-positioning test
    
    There was no failure here, just minor rasterization differences.

 test/ft-show-glyphs-positioning-svg-ref.png | Bin 0 -> 6590 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit fbab4bbb06d875313e9cd0dc38673b79b8460edb
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 26 13:47:06 2008 -0700

    Update clip-operator and operator-clear reference images
    
    There were legitimate bugs in the ps and pdf backends for these
    tests, (particularly with the row of glyphs), but these bugs
    were recently fixed with:
    
    commit d89edde84de9cec9ce6f76f4f2c44dd9c1220528
    Author: Vladimir Vukicevic <vladimir@pobox.com>
    Date:   Tue Mar 4 00:15:46 2008 -0800
    
        [meta] always copy glyph array before passing to _cairo_surface_show_glyphs
    
    and we just failed to notice the fix at the time.

 test/clip-operator-pdf-argb32-ref.png | Bin 11005 -> 11429 bytes
 test/clip-operator-ps-argb32-ref.png  | Bin 9084 -> 9102 bytes
 test/operator-clear-ps-argb32-ref.png | Bin 1400 -> 1435 bytes
 3 files changed, 0 insertions(+), 0 deletions(-)

commit 75972167a277687b1434c52e791ffe9c18fa2a7a
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 26 11:31:04 2008 -0700

    Use floating-point offsets for color stops
    
    Previously we were using the cairo_fixed_t type which meant we've
    historically only been using 16 bits of precision for these offsets,
    and recently only 8 bits. Meanwhile, all manipulatons of offsets
    have been in floating-point anyway, so we might as well store them
    that way.
    
    This change also prevents a rendering regression introduced with the
    24.8->16.16 change betwen snapshots 1.5.10 and 1.5.12 .
    
    This change affected gradient-rendering details for the clip-operator
    and operator-source tests, so the corresponding reference images are
    updated here.

 src/cairo-glitz-surface.c          |   2 +-
 src/cairo-pattern.c                |  10 ++++------
 src/cairo-pdf-surface.c            |   6 +++---
 src/cairo-ps-surface.c             |   6 +++---
 src/cairo-quartz-surface.c         |   6 +++---
 src/cairo-svg-surface.c            |  31 ++++++++++++++-----------------
 src/cairo-win32-printing-surface.c |   2 +-
 src/cairoint.h                     |   2 +-
 test/clip-operator-ref.png         | Bin 8263 -> 8271 bytes
 test/operator-source-ref.png       | Bin 4422 -> 4420 bytes
 10 files changed, 30 insertions(+), 35 deletions(-)

commit 80dc1714c87c3902e70fa94e4911945986cc7920
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 26 10:31:36 2008 -0700

    Remove unused variable

 src/cairo-image-surface.c | 1 -
 1 file changed, 1 deletion(-)

commit f676f18050383ecf26c36cdbba4ac81d2d45b042
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 26 08:43:23 2008 +0000

    [cairo] Fixup make check.
    
    make check demands that all function references in the docs are suffixed
    with ().

 src/cairo.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 452a1de2a06b57a3ed1b149e152487505dbc04f8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 25 16:50:33 2008 +0000

    [cairo-gstate] Remove dead code.
    
    Eliminate _cairo_gstate_recursive_apply_clip_path, as its last caller
    was removed over 2 years ago.

 src/cairo-gstate.c | 21 ---------------------
 1 file changed, 21 deletions(-)

commit ed42916028e4f51949210de6ecf4ebc5095aa45c
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Mar 26 23:04:35 2008 +1030

    Win32: Fix bug in cairo_win32_font_face_create_for_hfont()
    
    Use GetObjectW for LOGFONTW.

 src/cairo-win32-font.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6dc75ab0f8370154aae7719ed805c5a8bdf1c9f4
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 10:21:50 2008 -0700

    Quiet compiler warnings about unhandled PIXMAN_yuy2 and PIXMAN_yv12
    
    We still don't handle these format codes of course, (they're meaningless
    for the context in which they're used here).
    
    Note that we previously avoided adding these to avoid people being forced
    to upgrade pixman just to get two enum values that cairo doesn't really
    care about. But now we're depending on a new pixman anyway, (for the
    pixman_format_code_to_masks function), so we'll go ahead and do this now.

 src/cairo-image-surface.c | 3 +++
 1 file changed, 3 insertions(+)

commit 1675713aff7311461e26d7badccb9942573f2bca
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 16:45:21 2008 -0700

    Depend on pixman 0.9.7 for new pixman_format_supported_destination function
    
    This allows us to do a much more general and complete implementation of
    _pixman_format_from_masks and _pixman_format_to_masks so that we'll
    even pick up new pixman formats as they get added.

 configure.in              |   2 +-
 src/cairo-image-surface.c | 200 ++++++++++++++++++++--------------------------
 2 files changed, 86 insertions(+), 116 deletions(-)

commit d7e5f6b6a00912e22cb5ca837d0a56d30cf59124
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 16:32:24 2008 -0700

    Rename _popcount to _cairo_popcount and make it available for internal use
    
    Both cairo-image-surface.c and cairo-xlib-surface.c want to
    use this function now.

 src/cairo-xlib-surface.c | 25 ++-----------------------
 src/cairoint.h           | 21 +++++++++++++++++++++
 2 files changed, 23 insertions(+), 23 deletions(-)

commit 90cf7c2faf167b4b86443eb340af23cf853b146a
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 10:40:01 2008 -0700

    Quiet warning about signed vs. unsigned comparison

 src/cairo-surface-fallback.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 770633c05acf12b911cdbdaa94b20ccf34ce742a
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 10:27:36 2008 -0700

    Quiet warnings about unhandled enum values in _cairo_surface_create_in_error

 src/cairo-surface.c | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit d15c7c94bdfc714845bd88f9e3ed5317afcfce72
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Mar 25 12:12:40 2008 -0700

    Document performance advantage of cairo_path_extents
    
    The cairo_path_extents function can perform better than either
    cairo_stroke_extents or cairo_fill_extents, so provide that
    pointer from the documentation of the other two functions.

 src/cairo.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit 8aba5b802946530ef481f1461f9894529498cd8a
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Mar 25 11:53:52 2008 -0700

    [win32] Prevent crash in create_similar if win32_surface_create fails

 src/cairo-win32-surface.c | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 49a140b04bda85c03f824dcf565f1fcdd70b8965
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Mar 25 11:22:43 2008 -0700

    [osx] additional fix to configure for multi-arch OSX builds

 configure.in | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ae143d779ba5765f55754cb89af87b065d84ef04
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Mar 25 11:17:57 2008 -0700

    [quartz] When stroking with an image source, use the right CTM for the image
    
    Since the CTM was modified for the stroke transform, we need to reset
    it before calling ConcatCTM for the source transform.

 src/cairo-quartz-surface.c       |   9 ++++-
 test/Makefile.am                 |   3 ++
 test/stroke-image-quartz-ref.png | Bin 0 -> 1802 bytes
 test/stroke-image-ref.png        | Bin 0 -> 1866 bytes
 test/stroke-image.c              |  77 +++++++++++++++++++++++++++++++++++++++
 5 files changed, 88 insertions(+), 1 deletion(-)

commit e9906ae2021904c8c3d3a4083786475c102196f7
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 25 21:56:19 2008 +1030

    Win32-Printing: Fix fallback resolution when DC ctm is not identity
    
    And also move the _cairo_surface_set_resolution() into
    _cairo_win32_printing_surface_start_page as the DC ctm may be changed
    between pages.
    
    This bug was found in Inkscape now that they are using the cairo
    win32-printing surface for printing on Windows.

 src/cairo-win32-printing-surface.c | 19 ++++++++++++++-----
 1 file changed, 14 insertions(+), 5 deletions(-)

commit ee3981fb92ee5fa9b049dae32421cc0015fd4bf6
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Mar 24 16:24:36 2008 -0700

    Add new text-transform test
    
    Previously, the test suite wasn't supplying any coverage of transformed
    text rendering.

 test/.gitignore                 |   1 +
 test/Makefile.am                |   1 +
 test/README                     |   1 +
 test/text-transform-pdf-ref.png | Bin 0 -> 3796 bytes
 test/text-transform-ps-ref.png  | Bin 0 -> 4154 bytes
 test/text-transform-ref.png     | Bin 0 -> 6200 bytes
 test/text-transform.c           | 113 ++++++++++++++++++++++++++++++++++++++++
 7 files changed, 116 insertions(+)

commit 184d9cbf9c8967b741209b9d891848c9bd37dd60
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 24 12:36:37 2008 +1030

    Update REFERENCE_IMAGES with PS ref images
    
    for finer finer-grained-fallbacks.

 test/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 2ad39157975d71735da936977dd10e66d055ece7
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 24 12:32:07 2008 +1030

    Add PS reference images for finer-grained-fallbacks test

 test/finer-grained-fallbacks-ps-argb32-ref.png | Bin 0 -> 1047 bytes
 test/finer-grained-fallbacks-ps-rgb24-ref.png  | Bin 0 -> 819 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit ae9635bf33cb989f5c525800b82b81daad699e01
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 24 12:16:20 2008 +1030

    Fix assertion in PS/PDF/Win32-print when fallback image is off the page
    
    If during analysis the bounding box of an operation or the number of
    traps is 0, the operation is marked as natively supported. The problem
    here is if the operation is unsupported by the backend, we get an
    assertion when the operation is replayed during
    CAIRO_PAGINATED_MODE_RENDER.
    
    This bug was found in Inkscape when printing to the
    win32_printing_surface a page that has been layed out as landscape but
    landscape paper had not been selected in the print dialog.
    
    Fix this by being careful not to mark unsupported operations as
    supported during analysis even they may not be visible on the page.

 src/cairo-analysis-surface.c | 73 +++++++++++++++++++++++++++++++++-----------
 1 file changed, 55 insertions(+), 18 deletions(-)

commit 179ab7d2860b8ff94fe491896c50505fde7cf6af
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 24 11:43:29 2008 +1030

    Add finer-grained-fallbacks test
    
    This reproduces the bug in PS/PDF/Win32-printing where an unsupported
    operation that is off the page causes an unsupported operation
    assertion in the backend.

 test/.gitignore                            |   1 +
 test/Makefile.am                           |   3 +
 test/finer-grained-fallbacks-ref.png       | Bin 0 -> 796 bytes
 test/finer-grained-fallbacks-rgb24-ref.png | Bin 0 -> 590 bytes
 test/finer-grained-fallbacks.c             | 111 +++++++++++++++++++++++++++++
 5 files changed, 115 insertions(+)

commit 9a1f7bbc357ecce351b459f883b4ebeaa6640b65
Author: Benjamin Otte <otte@gnome.org>
Date:   Sun Mar 23 15:31:24 2008 +0100

    [API] unbreak CAIRO_FONT_TYPE_ATSUI
    
    commit 9d61f7db8082baf3a223c4ea41a53de372676e40 broke API by making the
    CAIRO_FONT_TYPE_ATSUI symbol not work anymore. However, this symbol was part of
    Cairo's public API and should continue working this way.

 src/cairo-deprecated.h | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 104c2825ea66d7d5f405cc8d690d90b45e752c46
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Mar 21 09:11:48 2008 +0000

    [cairo-png] Set bKGD gray value.
    
    For PNG_COLOR_TYPE_GRAY images the bKGD value is read from white.gray
    which was uninitialized, triggering the "PNG warning = Ignoring attempt
    to write bKGD chunk out-of-range for bit_depth" reported by Emmanuel
    Pacaud. This patch sets the background gray value to white, the same as
    for RGB images.

 src/cairo-png.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit c4599324820cfb46700bf2f059c46e9245f98ea5
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 21 18:12:03 2008 +1030

    Update PS reference images
    
    Some of the text tests require new PS specific reference images as a
    result of the PS glyph positioning fix.

 test/font-matrix-translation-ps-argb32-ref.png | Bin 749 -> 748 bytes
 test/font-matrix-translation-ps-rgb24-ref.png  | Bin 749 -> 748 bytes
 test/glyph-cache-pressure-ps-ref.png           | Bin 1413 -> 1454 bytes
 test/select-font-face-ps-ref.png               | Bin 1079 -> 959 bytes
 test/show-text-current-point-ps-ref.png        | Bin 1454 -> 1356 bytes
 test/text-pattern-ps-argb32-ref.png            | Bin 984 -> 966 bytes
 test/text-pattern-ps-rgb24-ref.png             | Bin 936 -> 924 bytes
 7 files changed, 0 insertions(+), 0 deletions(-)

commit f3a5f7570104c8d48c99a2b6bd34f4142e52f099
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 21 16:34:01 2008 +1030

    Add PS/PDF ref images for ft-show-glyphs-positioning

 test/Makefile.am                            |   2 ++
 test/ft-show-glyphs-positioning-pdf-ref.png | Bin 0 -> 3114 bytes
 test/ft-show-glyphs-positioning-ps-ref.png  | Bin 0 -> 2269 bytes
 3 files changed, 2 insertions(+)

commit 4f56a6324f16fa58c21180cc362ee18520a59179
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 21 16:30:53 2008 +1030

    Finish the PDF text operator decimal reduction commit
    
    Commit 158b32b60bc7e0f6488383c1d4f83203ffe97c98 reduced excess
    decimals emitted for the TJ operator. However it only fixed the first
    of the two locations in pdf-operators where the TJ position
    adjustments are emitted.

 src/cairo-pdf-operators.c | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 13e05bffd5cae5690fada24c7a7e2457c39e4dbf
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 21 15:41:31 2008 +1030

    Fix PS glyph positioning bug in PDF operator emulation
    
    The emulation of the PDF 'TJ' operator in the PS prolog was
    incorrectly updating the glyph position between strings. The glyph
    position values are a negative x offset that are in 1/1000 unit of
    text space. We were incorrectly multiplying the number by -0.0001
    instead of -0.001. We also need to transform this to device space
    before calling rmoveto.

 src/cairo-ps-surface.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 83486684520f3fd27d1118aa23462d013def83df
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 21 16:06:12 2008 +1030

    Add ft-show-glyphs-positioning test
    
    This demonstrates the glyph positioning bug in the PS backend.

 test/.gitignore                         |   1 +
 test/Makefile.am                        |   2 +
 test/ft-show-glyphs-positioning-ref.png | Bin 0 -> 3444 bytes
 test/ft-show-glyphs-positioning.c       | 167 ++++++++++++++++++++++++++++++++
 4 files changed, 170 insertions(+)

commit 37fedd108e3defc10f2f749a3a9971287e41706c
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 17:02:01 2008 -0700

    Increment cairo version to 1.5.15 after the 1.5.14 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f4d4d7b3d0bd62af6ffd50ba9cd8df0b9a12be71
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 16:13:28 2008 -0700

    Cleanup up png-test.png file in 'make clean'

 test/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 4ad5937648b27cd7a73a6a245ed875de92fa1c07
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 15:55:28 2008 -0700

    Enable PLT avoidance for cairo_image_surface_get_data/stride

 src/cairo-image-surface.c | 2 ++
 src/cairoint.h            | 2 ++
 2 files changed, 4 insertions(+)

commit 5d9eefccd6ff4d51e16caa8f3092d3acc33b5549
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 15:37:04 2008 -0700

    Disable enum_regexp test in check-doc-syntax.h
    
    It's returning false positives on non-gtk-doc comments with non-public
    enum values. Ick.

 src/check-doc-syntax.sh | 29 +++++++++++++++++++----------
 1 file changed, 19 insertions(+), 10 deletions(-)

commit 0c17ca52aa63a9c77cff47c4ae42bc16e5220552
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 15:33:37 2008 -0700

    Mark new cairo_xlib_visual_info functions as private.

 src/cairo-xlib-private.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit f32f81fa1badce15403d922002f4fc59fe8b563a
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 13:49:29 2008 -0700

    Increment cairo version to 1.5.14 and libtool versioning to 18:1:16

 configure.in | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit ffa50c31d38c761b4bf247d3ac27933974b819d3
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 13:49:19 2008 -0700

    Doc template churn

 doc/public/tmpl/cairo-font-face.sgml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3bb0474ea7d453793199d3ce7674fbe1ee8a324d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 13:48:29 2008 -0700

    NEWS: Add notes for 1.5.14 snapshot

 NEWS | 129 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 128 insertions(+), 1 deletion(-)

commit 191440101e815fe9be23bb6fbb36114de65d8c2d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 12:33:17 2008 -0700

    Fix the REFERENCE_IMAGES list, (like always before a snapshot)

 test/Makefile.am | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 46bbead898186349094ae69d2b16f88b80cb820e
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 12:18:39 2008 -0700

    RELEASING: Clarify steps for verifying no unpushed modifications

 RELEASING | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit c91a2a2e80f2172a4174cfc3b5e821cb49633da5
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Mar 20 11:51:31 2008 -0700

    Track minor change in pixman filtering sample location
    
    This change in reference image was triggered by the following commit
    in the pixman library:
    
            commit f2d8a5caa63596739b4dc47c00daaaafd9f522e2
            Author: Søren Sandmann <sandmann@redhat.com>
            Date:   Mon Mar 10 23:41:52 2008 -0400
    
            Add rounding epsilon for NEAREST filter after transformation, not before.
    
    This hasn't appeared in a pixman release yet. So for now, getting
    correct results is a matter of "use latest pixman". Soon we'll
    have a new pixman release and we'll make cairo depend on that.

 test/rotate-image-surface-paint-ref.png | Bin 209 -> 232 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit e96f382549eb3411d461162fdd8989f4ade8b448
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 19 13:00:47 2008 -0700

    Add support for 8-bit PseudoColor visuals
    
    This support involves allocating a 16-bit grayscale ramp as well
    as a 5x5x5 RGB color cube. Afterwards, the 256 colors are queried
    and an array is generated mapping from r3g3b3 colors to the closest
    available color. Both the queried colors and the reverse mapping
    are stored in a new visual-specific cairo_xlib_visual_info_t
    structure which hangs off of the cairo_xlib_screen_info_t.
    
    Both the color-cube allocation and the distance metric could be
    improved by someone sufficiently motivated, (for example, allocating
    and matching in a perceptually linear color space rather than just
    in RGB space). Also, making this work well in the face of a changing
    color map, or in the case of GrayScale, StaticGray, or DirectColor
    visuals are left entirely as exercises for the reader. StaticColor
    support should be fine as is, but is entirely untested.

 src/Makefile.am          |   1 +
 src/cairo-xlib-private.h |  15 ++++++
 src/cairo-xlib-screen.c  |  49 +++++++++++++++++
 src/cairo-xlib-surface.c | 122 +++++++++++++++++++++++++----------------
 src/cairo-xlib-visual.c  | 137 +++++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 278 insertions(+), 46 deletions(-)

commit d413c5ab21efb2ccc6a4847ff387f8e39ba2f3e1
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Mar 19 14:23:35 2008 -0700

    xlib: Add support for arbitrary TrueColor visuals
    
    This fixes the following bugs:
    
            cairo doesn't support 8-bit truecolor visuals
            https://bugs.freedesktop.org/show_bug.cgi?id=7735
    
            cairo doesn't support 655 xlib format
            https://bugs.freedesktop.org/show_bug.cgi?id=9719

 src/cairo-xlib-surface-private.h |   5 +
 src/cairo-xlib-surface.c         | 342 +++++++++++++++++++++++++++++++--------
 2 files changed, 276 insertions(+), 71 deletions(-)

commit aeaec94fd03b9098efce9d7455f813acf22ec026
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Thu Mar 20 16:05:34 2008 +0100

    [SVG] Replace the color property by stroke.
    
    Color property doesn't support URL as value. This pacth fixes
    http://bugs.freedesktop.org/show_bug.cgi?id=14556 .

 src/cairo-svg-surface.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 158b32b60bc7e0f6488383c1d4f83203ffe97c98
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 18 22:29:59 2008 +1030

    PDF: Reduce excess decimals in text position offsets
    
    The numbers output in the TJ array for adjusting the horizontal
    position of the next glyph are in 1/1000 of the text space
    units. Rounding these numbers to an integer should still provide
    sufficient precision.
    
    We use the rounded numbers to update the text position in
    pdf-operators so subsequent numbers in the TJ array will compensate
    for the rounding error.

 src/cairo-pdf-operators.c | 26 ++++++++++++++++++++++----
 1 file changed, 22 insertions(+), 4 deletions(-)

commit 222041530cd5d7f1ef6b41ea1738bf395ef1678a
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 18 22:28:37 2008 +1030

    Use %g for printing path coordinates in pdf-operators
    
    to eliminate unnecessary decimal places in the output.

 src/cairo-pdf-operators.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit d78013470b11677df88f246d893c1f019f4ae228
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 18 22:27:25 2008 +1030

    Add %g conversion specifer to output-stream for limited precision
    
    The %g conversion specifier is for printing numbers that were at some
    time stored in a cairo_fixed_t type and as a result have their
    precision limited by the size of CAIRO_FIXED_FRAC_BITS.
    
    Using %g will limit the number of digits after the decimal point to
    the minimum required to preserve the available precision.

 src/cairo-output-stream.c | 87 ++++++++++++++++++++++++++++++-----------------
 1 file changed, 56 insertions(+), 31 deletions(-)

commit f3734085a1d1d9b08004a243e28a0233f621847c
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 18 22:25:46 2008 +1030

    Make _cairo_dtostr() static
    
    It is only used in cairo-output-stream.c

 src/cairo-output-stream-private.h | 3 ---
 src/cairo-output-stream.c         | 2 +-
 2 files changed, 1 insertion(+), 4 deletions(-)

commit 4d9e5b51aa4164cf758c6a1f84c7f831becc098b
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Mar 18 22:25:18 2008 +1030

    Rescale CTM used for PS/PDF stroking to reduce rounding error
    
    The PS/PDF CTM is transformed to the user space CTM when emitting
    paths to be stroked to ensure the correct pen shape used. However this
    can result in rounding errors.
    
    For example the device space point (1.234, 3.142) when transformed to
    a user space CTM of [100 0 0 100 0 0] will be emitted as
    (0.012, 0.031).
    
    Fix this by rescaling the user space CTM so that the path coordinates
    emitted to the PDF file stay within the range the maximizes the
    precision. The line width and dashing is also rescaled to be the same
    size in the rescaled CTM.

 src/cairo-pdf-operators.c | 70 ++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 63 insertions(+), 7 deletions(-)

commit 7f4b967c020042779748021fa32fddfc3f0def28
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 14 16:51:24 2008 +0100

    Make CAIRO_FORMAT_STRIDE_FOR_WIDTH_BPP available to the cairo internals.

 src/cairo-image-surface.c | 7 ++-----
 src/cairoint.h            | 5 +++++
 2 files changed, 7 insertions(+), 5 deletions(-)

commit eb31c52febd615a92ef0c7204f9fa056ef01b536
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Mar 14 16:48:41 2008 +0100

    Make _pixman_format_to_masks accept a cairo_format_masks_t structure
    
    This makes it work similarly to _pixman_format_from_masks

 src/cairo-image-surface.c | 48 ++++++++++++++++++++++-------------------------
 src/cairo-xlib-surface.c  | 12 ++++++------
 src/cairoint.h            |  5 +----
 3 files changed, 29 insertions(+), 36 deletions(-)

commit cdb1ae97f241ec6b24d64b0fa5447d26f6bc5318
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Jan 27 10:31:58 2008 -0800

    Move assertion failure for unsupported masks up one level
    
    We're moving the assertion up from inside _pixman_format_to_mask
    to its callers. This will allow us to selectively eliminate the
    assertion from the supported xlib backend, while leaving it in
    the unsupported glitz and xcb backends for now.

 src/cairo-image-surface.c | 62 ++++++++++++++++++++++++++++-------------------
 src/cairo-xlib-surface.c  | 20 +++++++++++++--
 src/cairoint.h            |  5 ++--
 3 files changed, 58 insertions(+), 29 deletions(-)

commit b83b8c26f5d64fa07b56a747dec681c6626a0297
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 17 23:38:34 2008 +1030

    Optimize generated PostScript when EXTEND_PAD is used
    
    Allow image patterns with EXTEND_PAD to use the currentfile
    optimization.

 src/cairo-ps-surface.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 1ab804891bb71fd742ccc7a228483c53aee282a4
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 17 17:37:24 2008 -0700

    [quartz] Additional test reference images for quartz

 test/Makefile.am                             |  10 ++++++++++
 test/clip-operator-quartz-ref.png            | Bin 0 -> 9364 bytes
 test/clip-operator-quartz-rgb24-ref.png      | Bin 0 -> 4359 bytes
 test/dash-curve-quartz-ref.png               | Bin 0 -> 47965 bytes
 test/dash-state-quartz-ref.png               | Bin 0 -> 8698 bytes
 test/degenerate-path-quartz-ref.png          | Bin 0 -> 232 bytes
 test/degenerate-path-quartz-rgb24-ref.png    | Bin 0 -> 198 bytes
 test/operator-source-quartz-ref.png          | Bin 0 -> 4572 bytes
 test/operator-source-quartz-rgb24-ref.png    | Bin 0 -> 3452 bytes
 test/unbounded-operator-quartz-ref.png       | Bin 0 -> 4325 bytes
 test/unbounded-operator-quartz-rgb24-ref.png | Bin 0 -> 1972 bytes
 11 files changed, 10 insertions(+)

commit df5087992be5f0f1e42d968559c47bf43de9cfb7
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 17 17:37:22 2008 -0700

    [quartz] Fix bogus CGContextGetType warning that's printed on the console
    
    This is caused by 0x0 surfaces being special, and not having an
    associated cgContext.

 src/cairo-quartz-surface.c | 104 ++++++++++++++++++++++++++++++---------------
 1 file changed, 69 insertions(+), 35 deletions(-)

commit 9d61f7db8082baf3a223c4ea41a53de372676e40
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 17 17:37:19 2008 -0700

    [quartz] Rename ATSUI font to Quartz font

 configure.in               | 35 +++++++---------------------
 src/Makefile.am            | 17 ++++++--------
 src/cairo-atsui-font.c     | 39 +++++++++++++------------------
 src/cairo-atsui.h          | 58 ----------------------------------------------
 src/cairo-deprecated.h     |  2 ++
 src/cairo-quartz-private.h | 14 +++--------
 src/cairo-quartz-surface.c | 14 +++++------
 src/cairo-quartz.h         | 15 +++++++++++-
 src/cairo.h                |  4 ++--
 src/cairoint.h             | 10 ++++----
 10 files changed, 65 insertions(+), 143 deletions(-)

commit e4f087b8b944a26d688afeef4b9ea7a0d0a6e9ec
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Mar 16 17:29:48 2008 +1030

    Factor out common stroke code in pdf-operators

 src/cairo-pdf-operators.c | 68 ++++++++++++++++++++++-------------------------
 1 file changed, 32 insertions(+), 36 deletions(-)

commit 8238a9fd4fa672299fd99aa95f5fcec03647f7c8
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 15 22:08:52 2008 +1030

    Add stroke-ctm-caps to .gitignore

 test/.gitignore | 1 +
 1 file changed, 1 insertion(+)

commit 344af99d356203dce8cb97d3effa380cad0c9238
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 15 22:07:01 2008 +1030

    Improve the PDF operators word wrapping
    
    to correctly count the columns and avoid breaking hex strings
    immediately after the '<' and before any hex digits have been written.

 src/cairo-pdf-operators.c | 34 +++++++++++++++++++++++++---------
 1 file changed, 25 insertions(+), 9 deletions(-)

commit 0a8478ca1aa37695e84b4875e1efb3d93c7b8434
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 14 23:23:16 2008 -0700

    [quartz] don't say we forced subpixel AA when we didn't
    
    Whoops.  Net result was that this was disabling subpixel AA on
    contexts if CAIRO_ANTIALIAS_DEFAULT was being used.

 src/cairo-quartz-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 028d352286991f7ec1da168f7f91bed6449f64e4
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 14 23:22:08 2008 -0700

    [quartz] compare gradient stops as doubles, not as fixed point
    
    We use the floating-point value later, and we can end up with weirdness
    such as negative colors due to the precision mismatch of our fixed
    point vs. floating point type.  So just do everything in floating
    point.

 src/cairo-quartz-surface.c | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 112bbacea3c06f844af400f34a4a2eadf25d13dd
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 15 00:28:21 2008 +1030

    Don't use fill-stroke during analysis
    
    Instead ensure the fill and stroke are each analyzed separately.
    
    This fixes a bug in the PS output where if a fill-stroke with a
    translucent fill resulted in a fallback image with the stroke clipped
    to the fill path.

 src/cairo-meta-surface.c | 14 +++++---------
 1 file changed, 5 insertions(+), 9 deletions(-)

commit 112b43452d302eb4ac62a20bca01bdecbfdcaaf5
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Mar 15 00:18:59 2008 +1030

    Fix bug in _cairo_path_fixed_is_equal
    
    Ensure the entire path is compared.

 src/cairo-path-fixed.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 7e83d6e6fb8c4b11d5d95acac4a35df8969e0944
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 14 21:26:04 2008 +1030

    Do not use PDF fill-stroke operator with transparent fill
    
    because the PDF rendering does not match cairo. See
    PDF Reference 7.6.3.
    
    Bug report at
    https://bugs.launchpad.net/inkscape/+bug/202096

 src/cairo-pdf-surface.c | 15 +++++----------
 1 file changed, 5 insertions(+), 10 deletions(-)

commit 0aef7c1a34b2522d400b5a1a74567a79696216c9
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 10 22:19:52 2008 +1030

    PDF/PS: Optimize away the stroke ctm when not required
    
    The PDF/PS backends change the ctm to user space when emitting and
    stroking a path. When the user space ctm does not alter the pen shape
    we can avoid changing the ctm.
    
    This patch optimizes the most common case where the user ctm is
    [1 0 0 -1 0 y] due to conversion from cairo to PDF coordinates.

 src/cairo-pdf-operators.c | 36 ++++++++++++++++++++++++++++--------
 1 file changed, 28 insertions(+), 8 deletions(-)

commit 2bd15d080c562bfcbced1f6bb586cc1e3cae4555
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Mar 14 19:46:15 2008 +1030

    Add PS reference image for stroke-ctm-caps

 test/stroke-ctm-caps-ps-ref.png | Bin 0 -> 1079 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 761b4ce8dd40b8e5536a19018656c2440a61e71a
Author: Jeremy Huddleston <jeremyhu@apple.com>
Date:   Thu Mar 13 17:45:25 2008 -0700

    [mac] Correctly handle endianness in multi-architecture compiles on MacOS X

 configure.in | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 4cc93881d9603c90f1318b2eb822cf2c516ecf7d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 13 17:30:59 2008 -0700

    [test] Add testcase for previous stroker regression fix
    
    Add Adrian's original testcase for reproducing the stroker device
    vector issue.  (b4f518f917f5062537ee3c6a7a54180017b2c588)

 test/Makefile.am                    |   3 ++
 test/stroke-ctm-caps-quartz-ref.png | Bin 0 -> 1109 bytes
 test/stroke-ctm-caps-ref.png        | Bin 0 -> 1057 bytes
 test/stroke-ctm-caps.c              |  86 ++++++++++++++++++++++++++++++++++++
 4 files changed, 89 insertions(+)

commit a33351f9c677144437bef25a794b97f2ac4bb17a
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 13 15:37:26 2008 -0700

    [quartz] remove some compiler warnings

 src/cairo-atsui-font.c           | 2 +-
 src/cairo-quartz-image-surface.c | 4 ----
 2 files changed, 1 insertion(+), 5 deletions(-)

commit b4f518f917f5062537ee3c6a7a54180017b2c588
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 13 15:36:30 2008 -0700

    Correctly pass the device-space vector through to stroker
    
    Part of the earlier optimization caused the wrong slope to be used for
    some computations; this passes the correct slope vector down to
    _compute_face.

 src/cairo-path-stroke.c       |  37 +++++++++++++++++++++++--------------
 test/dash-scale-ref.png       | Bin 8035 -> 8058 bytes
 test/reflected-stroke-ref.png | Bin 4802 -> 5704 bytes
 3 files changed, 23 insertions(+), 14 deletions(-)

commit 5050c55f93afef9b0d0651a78f2c99e06e19b55a
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Thu Mar 13 21:35:12 2008 +1030

    Use the correct glyph metrics in Type1 fallback
    
    Now that the PS backend is using PDF operators, it uses the glyph
    metrics in the font to position each glyph in a string. This exposed a
    bug in Type 1 fallback where the glyph width and height was used in
    the charstrings instead of x_advance/y_advance. This was causing
    strings to print diagonally due to the no zero y_advance.

 src/cairo-type1-fallback.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit ed452713cfa16e5facca8f918ef4ee4fe2ec41c3
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Mar 12 18:33:05 2008 -0700

    [win32] Use a DIB when cloning a surface for a WIN32_PRINTING dest
    
    In some cases we were creating a 1bpp temporary surface, losing all
    color/grayscale data while printing.
    
    Ref: https://bugzilla.mozilla.org/show_bug.cgi?id=399388

 src/cairo-win32-surface.c | 16 +++++++++++++---
 1 file changed, 13 insertions(+), 3 deletions(-)

commit 6ac3eb487cf0de0d28bf6b14852de91b09fecb05
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Mar 12 18:19:59 2008 -0700

    [quartz] correctly force subpixel AA on a context, even if defaults say otherwise
    
    In some cases (in my case, having an external monitor attached to my
    MBP), Quartz seems to default to grayscale AA even when it should be
    using subpixel AA.  CGContextGetAllowsFontSmoothing returns FALSE in
    this case (pretty sure this is a Quartz bug).  We can force subpixel
    AA in this case by setting CGContextSetAllowsFontSmoothing.

 src/cairo-quartz-surface.c | 22 +++++++++++++++++++---
 1 file changed, 19 insertions(+), 3 deletions(-)

commit 5d11b937f1b769355a3dc7971ded40f60b001630
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Mar 12 18:11:57 2008 -0700

    [quartz] Apply fixup to unbounded operators to clear area outside of mask

 src/cairo-quartz-surface.c | 249 ++++++++++++++++++++++++++++++++++++++++++---
 1 file changed, 236 insertions(+), 13 deletions(-)

commit c86cbcdd644e043dc5ae2eabf5dd6afa020e2358
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 12 17:54:54 2008 +0000

    [cairoint.h] Mark _cairo_image_analyze_transparency as private.
    
    Add the required cairo_private markup for make check.

 src/cairoint.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 222eb6f1400ab7a51632cbc18b1526664e50c2e4
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Mar 12 17:52:16 2008 +0000

    Define _BSD_SOURCE to enable prototypes for strdup, snprintf.
    
    strdup() and friends require at least _BSD_SOURCE or
    _XOPEN_SOURCE >= 500 to be defined for the prototypes to be included.
    For the time being, add the define to each source file that requires one
    of the BSD functions.

 src/cairo-cff-subset.c          | 1 +
 src/cairo-font-face.c           | 1 +
 src/cairo-ft-font.c             | 1 +
 src/cairo-output-stream.c       | 1 +
 src/cairo-pdf-surface.c         | 1 +
 src/cairo-ps-surface.c          | 1 +
 src/cairo-scaled-font-subsets.c | 1 +
 src/cairo-svg-surface.c         | 3 ++-
 src/cairo-truetype-subset.c     | 1 +
 src/cairo-type1-fallback.c      | 1 +
 src/cairo-type1-subset.c        | 1 +
 11 files changed, 12 insertions(+), 1 deletion(-)

commit 2d9203c349ffba863368e85567b2e89443d51746
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 10 22:30:16 2008 +1030

    win32-printing: Don't scale the miter limit
    
    since the miter is a ratio it should not be scaled like the other
    stroke parameters when the user ctm is scaled.

 src/cairo-win32-printing-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f534fe434db38c2c24605bdfc251e0186dc7cafc
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Mar 10 17:18:07 2008 +1030

    PDF: Use cairo_image_analyse_transparency during analysis
    
    OPERATOR_SOURCE is only supported for opaque images. Check if and ARGB
    image really contains transparency before returing unsupported.

 src/cairo-pdf-surface.c | 38 +++++++++++++++++++++++++++++++++++++-
 1 file changed, 37 insertions(+), 1 deletion(-)

commit 61d45c9d1f2322c7c2ee7a58e7b3d5ccfac92db2
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 16 22:34:39 2008 +1030

    Remember the results of _cairo_image_analyze_transparency
    
    As _cairo_image_analyze_transparency() is only used on images in the
    meta surface, we can store the results of the image analysis and
    return the saved value on second and subsequent calls to analyze the
    same image.
    
    Previously each image was analyzed twice - once during
    CAIRO_PAGINATED_MODE_ANALYZE and once during
    CAIRO_PAGINATED_MODE_RENDER.

 src/cairo-image-surface.c | 21 +++++++++++++++------
 src/cairo-ps-surface.c    |  3 +++
 src/cairo-types-private.h |  3 ++-
 src/cairoint.h            |  1 +
 4 files changed, 21 insertions(+), 7 deletions(-)

commit 7eb8f497d8ac8ee76809f958170f1e5370744ba8
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 16 22:13:43 2008 +1030

    Move analyze_image_transparency in to cairo-image-surface.c

 src/cairo-image-surface.c | 29 +++++++++++++++++++++++++++++
 src/cairo-ps-surface.c    | 44 ++------------------------------------------
 src/cairo-types-private.h |  6 ++++++
 src/cairoint.h            |  3 +++
 4 files changed, 40 insertions(+), 42 deletions(-)

commit 00091d50a6187acd0fd35aef16a4fa5fab3c8aa9
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Mar 9 16:44:18 2008 +1030

    Add fallback image comment to PS output
    
    To help better understand when fallback images are used, a comment
    similiar to the following is included with each fallback image in the
    PS output.
    
    % Fallback Image: x=101, y=478, w=50, h=10 res=300dpi size=31500

 src/cairo-ps-surface.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 95acec69d8ee4fd37937f5b466c2baf612e9113a
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Mar 9 16:40:25 2008 +1030

    Round fallback image size up instead of down
    
    to ensure the fallback image completely covers the fallback region.

 src/cairo-paginated-surface.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 94e41d5565ef72a0ef6e0235545c660aaf92b825
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Mar 8 17:45:47 2008 -0800

    [quartz] Don't force interpolation off for images
    
    Creating a CGImage with interpolation set to FALSE means that
    it will never be interpolated; otherwise the interoplation
    is controlled by the destination context's interpolation
    quality setting.

 src/cairo-quartz-image-surface.c | 4 ++--
 src/cairo-quartz-surface.c       | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 08e38d3f204911a793d3aa24bf2636caf3e58e20
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Mar 8 16:06:01 2008 -0800

    [quartz] align strides to 16 bytes, as per apple docs
    
    The docs indicate that doing so can yield a peformance win, so we align
    ARGB32/RGB24 surface strides to 16 bytes.

 src/cairo-quartz-surface.c | 21 ++++++++++++++-------
 1 file changed, 14 insertions(+), 7 deletions(-)

commit 73444f16fa82b63a19aa938eb42001b5731326da
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Mar 8 15:31:15 2008 -0800

    [quartz] Don't try to call CGBitmapContextCreateImage on non-bitmap contexts

 src/cairo-quartz-surface.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 091df2c59b6dbd53a748955db359443d5d445ba4
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Mar 8 15:16:05 2008 -0800

    [quartz] properly honor text antialiasing modes in show_glyphs

 src/cairo-quartz-surface.c                  |  35 ++++++++++++++++++++++++----
 test/Makefile.am                            |   2 ++
 test/text-antialias-none-quartz-ref.png     | Bin 0 -> 304 bytes
 test/text-antialias-subpixel-quartz-ref.png | Bin 0 -> 1100 bytes
 4 files changed, 32 insertions(+), 5 deletions(-)

commit 4f7ac14b8fdafd9fa85e797fb6e4c974788f70fc
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Mar 8 19:22:13 2008 -0800

    [quartz] implement REPEAT/REFLECT for gradients
    
    Implement REPEAT/REFLECT for gradients in Quartz: for linear gradients,
    they're implemented natively (by extending the gradient region); for
    radial gradients, we generate a fallback image using pixman and render
    that.

 src/cairo-quartz-surface.c | 203 +++++++++++++++++++++++++++++++++++++++------
 1 file changed, 179 insertions(+), 24 deletions(-)

commit 869942a97e34b09a7bd5b8cfc54832ce9dbd08b6
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 16:55:47 2008 -0800

    [quartz] some more quartz ref images

 test/Makefile.am                   |   2 ++
 test/big-line-quartz-ref.png       | Bin 0 -> 1075 bytes
 test/big-line-quartz-rgb24-ref.png | Bin 0 -> 941 bytes
 3 files changed, 2 insertions(+)

commit 2e33d5f57bde82b953ebc5f9c1355327a7ac4967
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 16:46:53 2008 -0800

    [quartz] Update a bunch of reference images
    
    Generated with Bitstream Vera font family installed, using ATSUI
    font backend.

 test/Makefile.am                               |  14 ++++++++++++++
 test/font-matrix-translation-quartz-ref.png    | Bin 0 -> 1041 bytes
 test/glyph-cache-pressure-quartz-ref.png       | Bin 0 -> 3491 bytes
 test/linear-gradient-quartz-ref.png            | Bin 0 -> 1164 bytes
 test/long-dashed-lines-quartz-ref.png          | Bin 0 -> 2313 bytes
 test/mask-quartz-ref.png                       | Bin 10657 -> 10682 bytes
 test/operator-clear-quartz-ref.png             | Bin 1195 -> 1368 bytes
 test/operator-clear-quartz-rgb24-ref.png       | Bin 1244 -> 1201 bytes
 test/radial-gradient-quartz-ref.png            | Bin 0 -> 92334 bytes
 test/random-intersections-quartz-ref.png       | Bin 0 -> 197778 bytes
 test/reflected-stroke-quartz-ref.png           | Bin 0 -> 5293 bytes
 test/rotate-image-surface-paint-quartz-ref.png | Bin 257 -> 257 bytes
 test/select-font-face-quartz-ref.png           | Bin 0 -> 2958 bytes
 test/show-text-current-point-quartz-ref.png    | Bin 0 -> 3198 bytes
 test/text-antialias-gray-quartz-ref.png        | Bin 0 -> 1039 bytes
 test/text-pattern-quartz-rgb24-ref.png         | Bin 0 -> 1867 bytes
 test/text-rotate-quartz-ref.png                | Bin 0 -> 17405 bytes
 test/trap-clip-quartz-ref.png                  | Bin 6171 -> 6041 bytes
 test/unantialiased-shapes-quartz-ref.png       | Bin 0 -> 4394 bytes
 19 files changed, 14 insertions(+)

commit fb1378a24b5c6cd65b73aa611bb049ebb6f2b57a
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 16:46:15 2008 -0800

    [quartz] Correctly handle gradients with non-identity pattern transform
    
    Fixes http://bugs.freedesktop.org/show_bug.cgi?id=14248

 src/cairo-quartz-private.h |  3 +-
 src/cairo-quartz-surface.c | 68 ++++++++++++++++++++--------------------------
 2 files changed, 31 insertions(+), 40 deletions(-)

commit 6c7610067f8a131a4fbba8d2b6a88c27ef229bbe
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 15:35:31 2008 -0800

    [quartz] handle antialiasing correctly in stroke() and clip()
    
    A CoreGraphics bug was fixed so strokes are no longer incorrectly
    drawn with antialiasing disabled; we no longer have to ignore
    antialiasing for stroke().  Also, antialiasing was not being
    correctly set for clip().  This fixes both issues.

 src/cairo-quartz-surface.c | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit 21dab3c5e9fe1ff344ff809053618c2c8f0710f3
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 14:49:46 2008 -0800

    [quartz] look up the right symbol name for CGContextGetType

 src/cairo-quartz-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e52bad5e33e0b69b868525056c95ebd473fd6b10
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Mar 7 14:49:15 2008 -0800

    [quartz] split out (experimental) quartz-image into separate file

 configure.in                     | 15 ++++++++++
 src/Makefile.am                  |  5 ++++
 src/cairo-quartz-image-surface.c | 21 +++++++++-----
 src/cairo-quartz-image.h         | 59 ++++++++++++++++++++++++++++++++++++++++
 src/cairo-quartz-surface.c       | 10 +++----
 src/cairo-quartz.h               |  6 ----
 6 files changed, 97 insertions(+), 19 deletions(-)

commit b52f127c12fd7ee2b4f532954cb1e9e4eb8561b4
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Mar 6 16:52:54 2008 -0800

    [quartz] fix text rendering with gradient or image source
    
    A quirk in how CGContextShowGlyphsWithAdvances works was causing all
    non-solid glyphs to be rendered on top of eachother.  This fixes the problem.

 src/cairo-quartz-surface.c | 65 +++++++++++++++++++++++++---------------------
 1 file changed, 36 insertions(+), 29 deletions(-)

commit de515e0f9a46162dcdef3bce81702a56ac6f29bf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Mar 6 08:10:16 2008 +0000

    [cairo-png] Revert accidental chunk from FORMAT_A1 support.
    
    Whilst splitting the patches, I left in this line which would preserve
    1-bit grayscale unexpanded, but without any of the other FORMAT_A1
    support.

 src/cairo-png.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 8ba8a1192497ff89215f8a1657cbe88609083fb1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 4 13:59:57 2008 +0000

    [win32] make check doc fixup.
    
    Add the missing '%' to the macro as demanded by make check.

 src/cairo-win32-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1dd894115e03aa202941ecebe9fd3420c73645ef
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Mar 4 09:04:17 2008 +0000

    [cairo-pattern] Raise an error for _cairo_pattern_create_solid() failure.
    
    Add a missing _cairo_error() for the malloc failure in
    _cairo_pattern_create_solid().

 src/cairo-pattern.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 5efc5238d548599a90a02d922d031a899424d1c1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 17:06:30 2008 +0000

    [cairo-hull] Propagate error during hull computation.
    
    Propagate the original error status instead of returning a new NO_MEMORY
    error.

 src/cairo-hull.c | 22 ++++++++++++----------
 1 file changed, 12 insertions(+), 10 deletions(-)

commit 11a2444ec875aaaed12c1f1cfed5eb8e139c306d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 18 14:53:50 2008 +0000

    [cairo-png] Support generating CAIRO_FORMAT_RGB24 from PNGs.
    
    If the PNG does not have an alpha channel, then create an opaque image.

 src/cairo-png.c  |  69 +++++++++++++++++++-------
 test/.gitignore  |   1 +
 test/Makefile.am |   2 +
 test/png.c       | 149 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 204 insertions(+), 17 deletions(-)

commit 06b375aee999220ce294c22fa50a3040c19d5492
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:55:01 2008 +0000

    [cairo-png] Use cairo_format_stride_for_width()
    
    Use cairo_format_stride_for_width() instead of assuming the pixel size
    and manually calculating the row stride. This should make it easier to
    support loading multiple image formats in future.

 src/cairo-image-surface.c |  1 +
 src/cairo-png.c           | 16 ++++++++++------
 src/cairoint.h            |  1 +
 3 files changed, 12 insertions(+), 6 deletions(-)

commit b181f40949a855c957dc6e7a1033981a2ed7d05a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 28 16:04:08 2008 +0000

    [test/a8-mask] Check negative strides as well.
    
    Check that we also allow surfaces to be created using a negative stride.

 test/a8-mask.c | 19 ++++++++++++++++++-
 1 file changed, 18 insertions(+), 1 deletion(-)

commit b6eb1c5c92321849661198facd53510366050d45
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:49:14 2008 +0000

    [cairo-image-surface] Harden cairo_format_stride_for_width().
    
    Check the user supplied values for validity and potential overflow,
    returning -1 in such cases, and update the documentation to warn of the
    new error return.

 src/cairo-image-surface.c | 14 ++++++++++++--
 1 file changed, 12 insertions(+), 2 deletions(-)

commit c06d929325710c1a2cbecb8a64803ca8e1ffbec0
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 28 16:07:57 2008 +0000

    [cairo-png] Further hardening against malloc failures.
    
    On some OOM paths, libpng raises a warning as opposed to an error,
    these were not being propagated back to the caller. We were also not
    checking that we did not overwrite a pre-existing error status when
    raising an error whilst performing I/O.

 src/cairo-png.c | 38 +++++++++++++++++++++++++++++---------
 1 file changed, 29 insertions(+), 9 deletions(-)

commit c985096e6d7c04a780c055387e17ec4bb9334db3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:16:39 2008 +0000

    [cairo-xlib] Tidy usage of _cairo_error().
    
    Avoid a duplicate call to _cairo_error() and add a missing one.

 src/cairo-xlib-display.c |  1 +
 src/cairo-xlib-surface.c | 12 ++++++------
 2 files changed, 7 insertions(+), 6 deletions(-)

commit 914f4a3ec5a310c823558c27e500a23be808b9fe
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:15:26 2008 +0000

    [cairo-pattern] Tidy usage of _cairo_error().
    
    Remove the duplicate calls to _cairo_error() along the constructor
    error paths and a missing call to _cairo_error().

 src/cairo-pattern.c | 20 +++++---------------
 1 file changed, 5 insertions(+), 15 deletions(-)

commit d9fb4d4bc55eae42f6348b142e667be454064e2c
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:12:57 2008 +0000

    [cairo-ft-font] Simplify return of the nil font face during construction.
    
    Simply return the nil font face from the internal constructor rather
    than returning NULL and repeating the same fixup in the callers.

 src/cairo-ft-font.c | 12 +++---------
 1 file changed, 3 insertions(+), 9 deletions(-)

commit fd7d5d6e1dbad6c44a607d91ee59361ee19d32f9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:11:47 2008 +0000

    [cairo-clip] Raise _cairo_error() at original error site.
    
    In a couple of places where we detect an error and return an error
    object to the user, we did not throw a _cairo_error().

 src/cairo-clip.c | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 1654510a349d99167247d1004a481a95388cf0be
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 11:10:34 2008 +0000

    [cairo-cff-subset] Propagate error status.
    
    Remove duplicate _cairo_error() by ensuring that the error status is
    always propagated from the original error site. Note that in one case
    this eliminates a potential _cairo_error(CAIRO_INT_STATUS_UNSUPPORTED)!

 src/cairo-cff-subset.c | 47 +++++++++++++++++++++++++----------------------
 1 file changed, 25 insertions(+), 22 deletions(-)

commit 3b93d90edde7c065c6484e03e056b8605af85c4d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 10:16:05 2008 +0000

    [cairo-type1-fallback] Propagate original error status.
    
    _cairo_error() has already been called at the originating error site, so
    remove the duplicate (hard-coded!) call at the return statement.

 src/cairo-type1-fallback.c | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 141c54cd276ae86f6677fa8f66a118264d4287bf
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 29 08:54:33 2008 +0000

    [cairo-truetype-subset] Remove duplicate _cairo_error().
    
    _cairo_error() has already been called at the originating error site, so
    remove the duplicate call at the return statement.

 src/cairo-truetype-subset.c | 7 ++-----
 1 file changed, 2 insertions(+), 5 deletions(-)

commit d89edde84de9cec9ce6f76f4f2c44dd9c1220528
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Mar 4 00:15:46 2008 -0800

    [meta] always copy glyph array before passing to _cairo_surface_show_glyphs
    
    _cairo_surface_show_glyphs is allowed to mutate the glyph array; if it's
    handed the internal array that the meta surface holds, then any subsequent
    playback (such as for fine-grained fallbacks) will result in incorrect
    glyph rendering.
    
    Ref: https://bugzilla.mozilla.org/show_bug.cgi?id=419917
    (I was unable to create a simple cairo testcase to demonstrate the problem.)

 src/cairo-meta-surface.c | 24 +++++++++++++++---------
 1 file changed, 15 insertions(+), 9 deletions(-)

commit 4a1f65b63e891436f5896b1ccb0af26dd4b9cfe1
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 3 21:16:12 2008 -0800

    Fix msvc compilation issue in cairo-compiler-private.h
    
    __WIN32__ is not a standard define set by MSVC; we have to check for
    __WIN32__ (for mingw/gcc) and for _MSC_VER, for MSVC.

 src/cairo-compiler-private.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4588b016d389bb678ab55f7dbbf2bf8cdf597bc1
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 3 20:00:08 2008 -0800

    [quartz] compilation fix
    
    I'm an idiot and forgot to stg refresh, apparently.

 src/cairo-quartz-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2f9350424fd7eb03ecbdbdee2831944d4e9c35af
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 3 17:43:41 2008 -0800

    [win32] Treat all incoming HDCs as RGB24, regardless of depth
    
    Assuming A8/A1 doesn't really make sense in any case, and doing
    this allows for rendering to 8bpp displays.

 src/cairo-win32-surface.c | 28 ++++++----------------------
 1 file changed, 6 insertions(+), 22 deletions(-)

commit 9dd55f6fe854ec2365a5c1d264e39ca03f6eceb5
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Mar 3 17:40:21 2008 -0800

    [quartz] use CGContextGetType API if available
    
    We need to have a way to figure out if a context is a bitmap context;
    the current method works, but it prints a warning to the system console
    if called on a non-bitmap context.  There's a private CGContextGetType
    API that seems to let us get this information.

 src/cairo-quartz-surface.c | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit 5b334b274778f588c997d674c111a8bbf91be1df
Author: Antoine Azar <cairo@antoineazar.com>
Date:   Fri Feb 29 03:49:55 2008 -0500

    fixed compilation typo on win32

 src/cairo-win32-surface.c | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit 39d18ecbfda6b3c1234c5ef4a4723099990b3502
Author: Claudio Ciccani <klan@directfb.org>
Date:   Sat Mar 1 11:07:47 2008 +0100

    [cairo-directfb] Fixed bug in clone_similar() (src_x added twice).

 src/cairo-directfb-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6295c46569de13a96816ed8e30dcefd73af1eb18
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 17:08:40 2008 -0800

    INSTALL: Add notes on running autogen.sh if there is no configure script

 INSTALL | 71 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 65 insertions(+), 6 deletions(-)

commit e7e4a03dd387d264226105dc29c8541f0528fd2c
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 16:39:42 2008 -0800

    get-path-extents: Fix APPROX_EQUALS to round values on both sides of the comparison

 test/get-path-extents.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 602489b150e879bc5cab6b1ad37c107799bf05ae
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 16:33:51 2008 -0800

    get-path-extents: Use APPROX_EQUALS instead of EQUALS for text path tests
    
    This is done grudgingly due to freetype rounding the coordinates
    of the extents when hinting is enabled.

 test/get-path-extents.c | 12 +++++++++---
 1 file changed, 9 insertions(+), 3 deletions(-)

commit 50a6fe1a2aa88e1f5ba40eda21142319f98f3d0d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 16:32:55 2008 -0800

    Remove unnecessary cairo_set_tolerance call from get-path-extents test

 test/get-path-extents.c | 1 -
 1 file changed, 1 deletion(-)

commit 4a73471087f42baf07988e0f2de323ed3b18dac9
Merge: 54a61911f 523c7dbf6
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 16:21:11 2008 -0800

    Merge branch 'master' of git.cairographics.org:/git/cairo

commit 54a61911f26b46b6d9b7335ac7dda746081261d9
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 16:20:56 2008 -0800

    Increment version to 1.5.13 after the 1.5.12 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 523c7dbf6db85e75624ae111179dedb570212bb2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Feb 28 18:53:08 2008 -0500

    [cairo-scaled-font] Pedantic check for zero-area glyphs

 src/cairo-scaled-font.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 3ec4b9a4fc96572f099d0e9679fec9e5eb97a32e
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:46:22 2008 -0800

    Increment cairo version to 1.5.12 and libtool versioning to 18:0:16

 configure.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit bf99e355d9d24a4820dc93b49321b15318501b61
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:45:11 2008 -0800

    Clarify that 16-bit limit still exists in pixman

 NEWS | 21 +++++++++++----------
 1 file changed, 11 insertions(+), 10 deletions(-)

commit 4cc174f72f635e885b5f5fdc3d67789d3952cd2e
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:41:36 2008 -0800

    Mark the big-line test as XFAIL

 test/Makefile.am | 1 +
 test/big-line.c  | 3 ++-
 2 files changed, 3 insertions(+), 1 deletion(-)

commit 5d0bc97b2000a7b7e40a7a3918f09d90bdf5376a
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:35:46 2008 -0800

    Fix incorrect reference images for big-line test
    
    I mistakenly generated the original reference images with
    a 16.16 version of cairo, (which manifests a different
    buggy behavior than does the current 24.8 cairo).

 test/big-line-ps-ref.png       | Bin 1161 -> 1148 bytes
 test/big-line-ps-rgb24-ref.png | Bin 809 -> 830 bytes
 test/big-line-ref.png          | Bin 1421 -> 1486 bytes
 test/big-line-rgb24-ref.png    | Bin 1231 -> 1308 bytes
 4 files changed, 0 insertions(+), 0 deletions(-)

commit 4c7784e91eb953b905f187dda2a76dc102d73d01
Author: Jody Goldberg <jody@gnome.org>
Date:   Thu Feb 28 15:23:53 2008 -0800

    Fix PDF ouput when cross-compiling with mingw
    
    Need to use __WIN32__ instead of _MSC_VER to select _snprintf in
    place of snprintf when cross compiling. Otherwise all all %ld
    arguments get misprinted resulting in broken PDF output.

 src/cairo-compiler-private.h | 5 ++++-
 src/cairo-output-stream.c    | 5 +----
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 3d9db511c6990481add24f14225e36ea4d3f62d5
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:07:50 2008 -0800

    Remove references to PIXMAN_yuy2 and PIXMAN_yv12 enum values
    
    These were added in cb5ea8abfdf2c92241d4dea8bb827648697fd8e9 to
    quiet a compiler warning. We're reverting them now to avoid
    gratuitously requiring a new pixman version just to pick up two
    enum values that we aren't actually using.

 src/cairo-image-surface.c | 3 ---
 1 file changed, 3 deletions(-)

commit a8e5c6b924447bb1303589cc31792a6c4bcc27ec
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 15:05:12 2008 -0800

    Fix typo in comment

 src/cairo-fixed-private.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 307a7448ea89c5cf2805bc3a8da31c5ea77e4542
Author: Larry Ewing <lewing@novell.com>
Date:   Thu Feb 28 15:02:23 2008 -0800

    Add big-line test showing a 24.8 failure

 test/.gitignore                |   1 +
 test/Makefile.am               |   5 +++
 test/big-line-ps-ref.png       | Bin 0 -> 1161 bytes
 test/big-line-ps-rgb24-ref.png | Bin 0 -> 809 bytes
 test/big-line-ref.png          | Bin 0 -> 1421 bytes
 test/big-line-rgb24-ref.png    | Bin 0 -> 1231 bytes
 test/big-line.c                |  69 +++++++++++++++++++++++++++++++++++++++++
 7 files changed, 75 insertions(+)

commit 81175110ab44e74fe04f2bc8ed3c9983e23a82c6
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 14:36:47 2008 -0800

    NEWS: Add notes for cairo 1.5.12

 NEWS | 94 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 94 insertions(+)

commit fbd29a4025fc3bca3812d205230151e8c6e80f49
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 14:36:32 2008 -0800

    Fix 'make doc-publish' for when run twice on the same day

 Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 8d515344c4ecded58566b704a740766f85359876
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 14:35:57 2008 -0800

    Add cairo-quartz to the manual

 doc/public/Makefile.am             |  1 -
 doc/public/cairo-docs.xml          |  2 +-
 doc/public/cairo-sections.txt      | 11 +++++++++
 doc/public/tmpl/cairo-quartz.sgml  | 49 ++++++++++++++++++++++++++++++++++++++
 doc/public/tmpl/cairo-surface.sgml |  1 +
 5 files changed, 62 insertions(+), 2 deletions(-)

commit c8c77f01f7429b43dba4840698497187ff4d5779
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 13:02:27 2008 -0800

    Fix typo in documentation

 src/cairo-quartz-image-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fa4b91fcac9b83cb66ac98dbcb395bd7b75c7560
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 12:56:31 2008 -0800

    Add missing reference images to make distcheck happily

 test/Makefile.am | 28 ++++++++++++++++++++++------
 1 file changed, 22 insertions(+), 6 deletions(-)

commit a95b22858fa5d65600faf5163966e18760a3cf35
Merge: c84ec5851 67d543716
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 28 12:30:13 2008 -0800

    Merge branch '24.8'

commit 67d543716e294f4af330c52dcc9597e16267425e
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 20:39:53 2008 -0800

    PS: Fix to never break the final ~> that terminates a base85 stream.
    
    This was recently broken in commit 40d5082c24819968a5ee5a8f72e3b9cd61cb6105
    which uses a base85-stream but without strings for encapsulating image
    data. The bug was that the protection for ~> was only being applied
    to the string encodings rather than all base85 streams.
    
    We got lucky recently that the 24.8 change just happened to put the ~>
    sequence on the line-wrap boundary so the test suite tripped up the
    bug. Otherwise, we could have missed this for quite some time.

 src/cairo-ps-surface.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit c84ec585123be1802b50665e192b80daf14fdd2b
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 16:24:10 2008 -0800

    Add some missing .gitignore entries

 test/.gitignore | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 1df0b001b5b3e1062fa3c3a9070391105fe3d4ba
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 15:08:18 2008 -0800

    Change cairo's fixed-point format from 16.16 to 24.8
    
    The additional 8 bits of integer allows device space to be 256
    times larger before applications need to start worrying about
    any issues with overflow. So this should help in many cases.
    And the loss of 8 bits of sub-pixel precision shouldn't cause
    any harm at all---16 was really much more than necessary.
    
    With this change the details of rasterization for several tests
    are changed slightly, (particularly on arcs, for example), so
    many reference images are updated here.
    
    NOTE: This change is currently breaking get-path-extents for
    ps/pdf/svg as well as push-group for ps. We do not yet know
    the reasons for these new failures.

 src/cairo-fixed-type-private.h               |   2 +-
 test/clip-operator-ref.png                   | Bin 8262 -> 8263 bytes
 test/clip-twice-ref.png                      | Bin 1191 -> 1362 bytes
 test/clip-twice-rgb24-ref.png                | Bin 1120 -> 1198 bytes
 test/copy-path-ps-argb32-ref.png             | Bin 442 -> 0 bytes
 test/copy-path-ps-ref.png                    | Bin 0 -> 474 bytes
 test/copy-path-ps-rgb24-ref.png              | Bin 440 -> 0 bytes
 test/linear-gradient-ps-ref.png              | Bin 718 -> 779 bytes
 test/mask-ref.png                            | Bin 8381 -> 8476 bytes
 test/mask-svg-argb32-ref.png                 | Bin 8389 -> 8527 bytes
 test/meta-surface-pattern-svg-argb32-ref.png | Bin 3896 -> 3924 bytes
 test/operator-clear-ps-argb32-ref.png        | Bin 1437 -> 1400 bytes
 test/operator-source-ref.png                 | Bin 4422 -> 4422 bytes
 test/push-group-ref.png                      | Bin 3005 -> 3126 bytes
 test/push-group-rgb24-ref.png                | Bin 2849 -> 2961 bytes
 test/random-intersections-ps-ref.png         | Bin 89253 -> 89253 bytes
 test/random-intersections-ref.png            | Bin 132210 -> 148722 bytes
 test/text-pattern-svg-argb32-ref.png         | Bin 1749 -> 1733 bytes
 test/text-rotate-ps-ref.png                  | Bin 6859 -> 6878 bytes
 test/trap-clip-ref.png                       | Bin 5723 -> 5772 bytes
 test/unantialiased-shapes-ref.png            | Bin 3968 -> 4459 bytes
 21 files changed, 1 insertion(+), 1 deletion(-)

commit 0532cb5c03bac394e22ac4200e8bebc3d959b21c
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 13:18:39 2008 -0800

    Remove reference images for text-zero-len
    
    This test isn't generating any image output, so it's silly to
    have a 60x60 reference image for that. Not only that, but the
    rgb24 cases have always been failing due to a missing rgb24-
    specific reference image, (but pdiff had been hiding that).

 test/Makefile.am           |   1 +
 test/text-zero-len-ref.png | Bin 130 -> 0 bytes
 test/text-zero-len.c       |   4 +---
 3 files changed, 2 insertions(+), 3 deletions(-)

commit 427a73ab31e2dce9d98820ba921b216176cde182
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 12:43:37 2008 -0800

    Add ps-specific reference images for two recently-added tests

 test/Makefile.am                  |   2 ++
 test/long-dashed-lines-ps-ref.png | Bin 0 -> 1516 bytes
 test/reflected-stroke-ps-ref.png  | Bin 0 -> 3898 bytes
 3 files changed, 2 insertions(+)

commit 676c869d794f824b6e624d0b9b5c960870102406
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 27 11:24:59 2008 -0800

    Add some new ps-specific reference images
    
    These are necessary now due to the recent change to use pdiff
    only when the differences are less than a particular threshold.

 test/Makefile.am                        |   8 ++++++++
 test/caps-joins-ps-ref.png              | Bin 0 -> 1459 bytes
 test/close-path-ps-ref.png              | Bin 0 -> 309 bytes
 test/infinite-join-ps-ref.png           | Bin 0 -> 218 bytes
 test/leaky-polygon-ps-ref.png           | Bin 0 -> 354 bytes
 test/rectilinear-miter-limit-ps-ref.png | Bin 0 -> 221 bytes
 test/self-copy-ps-ref.png               | Bin 0 -> 335 bytes
 test/skew-extreme-ps-ref.png            | Bin 0 -> 1048 bytes
 test/text-rotate-ps-ref.png             | Bin 0 -> 6859 bytes
 test/transforms-ps-ref.png              | Bin 0 -> 418 bytes
 10 files changed, 8 insertions(+)

commit 1889427e78f2501df78a42c5e75c696745b517a7
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Feb 27 12:35:56 2008 -0500

    Fix usage of rectangle_int16_t in ps surface, and rename types
    
    The rectangle_int16_t usage was causing failures on 24.8 (due to a wrong
    pointer used to get_extents); I removed all the specific int16/int32 typedefs
    to avoid this situation in the future.

 src/cairo-ps-surface.c    |  2 +-
 src/cairo-types-private.h | 47 +++++++++++++++++++++--------------------------
 2 files changed, 22 insertions(+), 27 deletions(-)

commit 4f7d3063520b987d3df3bcebfaeed9489b16b12d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 27 10:11:08 2008 +0000

    [cairo-paginated-surface] Fix enum compiler warning.
    
    Add a CAIRO_SURFACE_TYPE_QUARTZ_IMAGE to the switch to suppress a
    compiler warning.

 src/cairo-paginated-surface.c | 1 +
 1 file changed, 1 insertion(+)

commit cb5ea8abfdf2c92241d4dea8bb827648697fd8e9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 21 16:03:42 2008 +0000

    [cairo-image-surface] Compiler warnings and whitespace.
    
    Silence a couple of enum compiler warnings and tweak the whitespace.

 src/cairo-image-surface.c | 45 ++++++++++++++++++++++++---------------------
 1 file changed, 24 insertions(+), 21 deletions(-)

commit 22600e2393f2ec5ebe40213c49599167523ddf20
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 22 17:07:45 2008 +0000

    [cairo-gstate] Remove a couple of impossible guards.
    
    Delete a couple of superfluous gstate != NULL guards.

 src/cairo-gstate.c | 6 ------
 1 file changed, 6 deletions(-)

commit 37e597f1e553a98d06c5334aa95b918ed303e89e
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 22 17:03:51 2008 +0000

    [cairo-gstate] Propagate the error from _cairo_gstate_clone().
    
    Propagate the true status value back from the _cairo_gstate_init_copy()
    instead of assuming that is a NO_MEMORY and re-raising the error in the
    caller.

 src/cairo-gstate.c | 22 +++++++++++-----------
 1 file changed, 11 insertions(+), 11 deletions(-)

commit 127d7f43ea7043bba1d276d9721e80a702d9fd46
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 21 15:56:34 2008 +0000

    [cairo-path-bounds] _cairo_path_fixed_bounds() can fail...
    
    I was wrong in my assertion that the call to
    _cairo_path_fixed_interpret_flat() could not possibly fail with the
    given _cairo_path_bounder_* callbacks - as I had missed the implicit
    spline decomposition. (An interesting exercise would be to avoid the
    spline allocation...) As a result we do have to check and propagate the
    status return through the call stack.

 src/cairo-analysis-surface.c |  8 ++++++--
 src/cairo-gstate.c           | 12 +++++++++---
 src/cairo-path-bounds.c      | 10 +++++-----
 src/cairo.c                  | 10 +++++++---
 src/cairoint.h               |  4 ++--
 5 files changed, 29 insertions(+), 15 deletions(-)

commit 65a8a279430a08e6f28b1e0354e9f18fda1a0ad7
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 26 14:14:38 2008 +0000

    [test] Add reflected-stroke to exercise stroking with a reflected ctm.
    
    Parts of the stroker depend upon whether we have in effect a reflection
    matrix (one whose determinant < 0). This test incopororates the same
    drawing under the a couple of reflections to exercise stroking under
    matrices with both positive and negative determinants.

 test/.gitignore               |   1 +
 test/Makefile.am              |   2 +
 test/reflected-stroke-ref.png | Bin 0 -> 4802 bytes
 test/reflected-stroke.c       | 100 ++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 103 insertions(+)

commit 76f0613e5f1244557eab31945d7e7c757d987304
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 26 09:50:51 2008 +0000

    [test] Add long-dashed-lines to exercise _cairo_box_intersects_line_segment().
    
    Draw a few rectangles whose vertices are outside the bounds of the
    surface, but whose segments cross the surface. This exercises the new
    dashed stroker optimisation which tries to determine whether the line
    segment is visible.

 test/.gitignore                |   1 +
 test/Makefile.am               |   2 ++
 test/long-dashed-lines-ref.png | Bin 0 -> 2116 bytes
 test/long-dashed-lines.c       |  75 +++++++++++++++++++++++++++++++++++++++++
 4 files changed, 78 insertions(+)

commit cdeffc69d9daa931c3c4ffcbb9e093180da45fe5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 26 13:04:33 2008 +0000

    [cairo-quartz-surface] Make check fixup.
    
    A couple of minor corrections to satisfy make check.

 src/cairo-quartz-surface.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 40f4750f5ec53ca9ca6e3d621fefb2bd1687909e
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 26 23:17:04 2008 +1030

    Use PDF 're' operator for rectangle paths
    
    Modify cairo-pdf-operators.c to emit to 're' path operator when the
    path contains only a rectangle. This can only be done when the path is
    logically equivilent to the the path drawn by the 're'
    operator. Otherwise dashed strokes may start on the wrong line.
    
    ie the path must be equivalent to:
    
      cairo_move_to (cr, x, y);
      cairo_rel_line_to (cr, width, 0);
      cairo_rel_line_to (cr, 0, height);
      cairo_rel_line_to (cr, -width, 0);
      cairo_close_path (cr);
    
    which is also equivilent to cairo_rectangle().

 src/cairo-path-fixed.c    | 24 ++++++++++++++++++++++++
 src/cairo-pdf-operators.c | 36 +++++++++++++++++++++++++++++-------
 src/cairo-ps-surface.c    |  2 ++
 src/cairoint.h            |  4 ++++
 4 files changed, 59 insertions(+), 7 deletions(-)

commit 7acfee38b1ac6ef2292d754c7103bd65d58f72d8
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:44:04 2008 -0500

    [atsui] Make default font 'Helvetica'
    
    The previous default font was Monaco, which is a fixed-pitch font; Helvetica
    is more inline with the other platform defaults.

 src/cairoint.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9979f786acaf0ebba1bf97e40aeba66287a3c743
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:27:33 2008 -0500

    [test] update degenerate-pen test
    
    pdiff was hiding a rgb24 failure here, as the test was drawing using
    black ink on the default black background.  Instead, explicitly fill
    the surface with white first.

 test/degenerate-pen-ps-argb32-ref.png | Bin 795 -> 0 bytes
 test/degenerate-pen-ps-ref.png        | Bin 0 -> 865 bytes
 test/degenerate-pen-quartz-ref.png    | Bin 0 -> 1144 bytes
 test/degenerate-pen-ref.png           | Bin 788 -> 1139 bytes
 test/degenerate-pen.c                 |   4 ++++
 5 files changed, 4 insertions(+)

commit baec928a69b5b763b30766cddfb1473e4e05fc3c
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:36 2008 -0500

    [quartz] More mask fixes -- handle all types via fallback mask image

 src/cairo-quartz-surface.c     |  79 ++++++++++++++++++++++++++++++++---------
 test/mask-quartz-ref.png       | Bin 0 -> 10657 bytes
 test/mask-quartz-rgb24-ref.png | Bin 0 -> 8418 bytes
 3 files changed, 62 insertions(+), 17 deletions(-)

commit 3fcd0be52215e1d8a59560d6b0919fb3f53b7a28
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:35 2008 -0500

    Use pdiff only if the pixel difference is less than a limit

 test/buffer-diff.c | 24 +++++++++++++++++-------
 1 file changed, 17 insertions(+), 7 deletions(-)

commit 1dfb1bd45fbe08392e233af67f464b2776de9f19
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:28 2008 -0500

    [quartz] update test suite images for quartz

 test/dash-scale-quartz-ref.png                 | Bin 0 -> 8079 bytes
 test/leaky-dash-quartz-ref.png                 | Bin 0 -> 241 bytes
 test/line-width-scale-quartz-ref.png           | Bin 0 -> 6434 bytes
 test/mask-alpha-quartz-argb32-ref.png          | Bin 0 -> 641 bytes
 test/meta-surface-pattern-quartz-ref.png       | Bin 0 -> 4572 bytes
 test/meta-surface-pattern-quartz-rgb24-ref.png | Bin 0 -> 4063 bytes
 test/new-sub-path-quartz-ref.png               | Bin 386 -> 383 bytes
 test/over-above-source-quartz-ref.png          | Bin 0 -> 530 bytes
 test/over-above-source-quartz-rgb24-ref.png    | Bin 0 -> 456 bytes
 test/over-around-source-quartz-ref.png         | Bin 0 -> 612 bytes
 test/over-around-source-quartz-rgb24-ref.png   | Bin 0 -> 491 bytes
 test/over-between-source-quartz-ref.png        | Bin 0 -> 570 bytes
 test/over-between-source-quartz-rgb24-ref.png  | Bin 0 -> 467 bytes
 test/rotate-image-surface-paint-quartz-ref.png | Bin 0 -> 257 bytes
 test/trap-clip-quartz-ref.png                  | Bin 5814 -> 6171 bytes
 15 files changed, 0 insertions(+), 0 deletions(-)

commit b439e638087d6e76d14ca42cd59dba3915dcc8e8
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:25 2008 -0500

    [quartz] fix mask to correctly take CTM into account

 src/cairo-quartz-surface.c | 40 ++++++++--------------------------------
 1 file changed, 8 insertions(+), 32 deletions(-)

commit a4975ab1173957a293aad8ccac51d1e43cab86da
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:23 2008 -0500

    [quartz] Optimize path handling where possible

 src/cairo-path-fill.c      | 66 ++-----------------------------------
 src/cairo-path-fixed.c     | 81 ++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-quartz-surface.c | 11 +++++++
 src/cairoint.h             |  7 ++++
 4 files changed, 101 insertions(+), 64 deletions(-)

commit 63711b1d4a61f21db070f30b9c153d0923cc24bb
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 25 21:06:21 2008 -0500

    [quartz] Add quartz-image-surface type

 src/Makefile.am                  |   2 +-
 src/cairo-quartz-image-surface.c | 370 ++++++++++++++++++++++++++++++
 src/cairo-quartz-private.h       |  31 ++-
 src/cairo-quartz-surface.c       | 476 ++++++++++++++++++---------------------
 src/cairo-quartz.h               |   6 +
 src/cairo.h                      |   4 +-
 6 files changed, 634 insertions(+), 255 deletions(-)

commit ecb54b96967ae0d1b5ec3a4d0955f46dd68f2b8b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Feb 25 19:48:58 2008 -0500

    [test/get-path-extents] Don't use short-circuit && operators
    
    That causes some tests to be skipped if the preceding test failed.

 test/get-path-extents.c | 143 +++++++++++++++++++++---------------------------
 1 file changed, 62 insertions(+), 81 deletions(-)

commit be316b7cfae90878d05869329c85c9617019bbec
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Feb 25 19:36:22 2008 -0500

    [test]/get-path-extents] Use %g instead of %f to print doubles

 test/get-path-extents.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7c8c9cf334b8687ffe2d6f614e234bd1662689e6
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Mon Feb 25 21:50:37 2008 +1030

    PDF: Support OPERATOR_SOURCE when pattern is opaque

 src/cairo-pdf-surface.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 35295546ef63821c5eee5336ec73eef2e03a035d
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 22 22:06:25 2008 +1030

    Add mask pdf ref images
    
    The mask test pdf output is now correct. Poppler ref images
    are required due to minor gradient rendering differences.

 test/mask-pdf-argb32-ref.png | Bin 0 -> 7834 bytes
 test/mask-pdf-rgb24-ref.png  | Bin 0 -> 7383 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 1df969158c83b31acbcf0963913bc4d4a9d20730
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 22 21:59:47 2008 +1030

    Refresh clip-operator ps/pdf ref images
    
    Because the meta surface analysis fix increased the size of some of
    the fallback images.

 test/clip-operator-pdf-argb32-ref.png | Bin 9096 -> 11005 bytes
 test/clip-operator-ps-argb32-ref.png  | Bin 9062 -> 9084 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit eae259168fc4318f2a67f3107f953648e7ab925e
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 22 21:07:31 2008 +1030

    Using correct surface size and clip when analyzing meta surface patterns
    
    The surface size and clip needs to be saved before and restored after
    replaying meta surface patterns back to the analysis surface. The clip
    is reset and the correct surface size is set before replaying the meta
    surface.

 src/cairo-analysis-surface.c | 20 ++++++++++++++++++++
 1 file changed, 20 insertions(+)

commit 0db2c67cc5b29623070465f2cf6eafbff174ed30
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Thu Feb 21 20:51:20 2008 +1030

    PS: Replace gsave/grestore with q/Q

 src/cairo-ps-surface.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 187ace8024ffadc3ee0b69bbd99c52d189cb7be2
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 22 19:36:11 2008 +1030

    PS: Make debug code compile

 src/cairo-ps-surface.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 8f0ec1174ad3c7a59ecdcf7724b8e8b96801b3e0
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 21 08:05:27 2008 -0800

    Patch hole in fabric of time-space continuum

 NEWS | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 70bb2abed04ed25abccbb2d6a5bdc58136701b0a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Feb 20 20:54:01 2008 -0500

    [cairo-ft] Handle font sizes smaller than 1px correctly
    
    The FT_Set_Char_Size() docs say it replaces sizes smaller than 1.0 with 1.0.
    So, we can't use x_scale and y_scale values less than one.  The fix is easy thouh,
    cap them to 1.0 and let the FT transform do the scaling down.

 src/cairo-ft-font.c | 36 ++++++++++++++++++++++--------------
 1 file changed, 22 insertions(+), 14 deletions(-)

commit dcab5019d5d9cb70aed0f473642ee840b785c4af
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 17:35:48 2008 -0800

    Add poppler-specific reference image for radial-gradient
    
    This is justified by the previously mentioned bug on poppler
    gradients. Note that this test only passes with a patch
    to fix a bug in poppler (not yet upstream). Here it is:
    
            PATCH: Keep 'cairo_shape' and 'cairo' consistent
            https://bugs.freedesktop.org/show_bug.cgi?id=14593

 test/Makefile.am                 |   1 +
 test/README                      |   1 +
 test/radial-gradient-pdf-ref.png | Bin 0 -> 79490 bytes
 3 files changed, 2 insertions(+)

commit 70b683363f6e37d8952c8f857dd687022a02ada5
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Wed Feb 20 23:46:27 2008 +0100

    [SVG] Fix a8-mask test failure.
    
    For A8 and A1 masks, the embedded mask image doesn't have an alpha channel.
    In this case, the feColorMatrix should not be used, since it's goal is to
    discard the color channels and to only keep the alpha one (which is what
    we want when we have an ARGB32 mask image, since SVG uses all the channels
    for the mask operation, where cairo only use the alpha channel).

 src/cairo-svg-surface.c | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit c5d056aaebe51d2c3430807de559b0d8ab3431d5
Author: Emmanuel Pacaud <emmanuel.pacaud@free.fr>
Date:   Wed Feb 20 21:42:24 2008 +0100

    [SVG] Fix the extend-reflect-similar test failure.
    
    SVG doesn't support extend reflect for image pattern, and there isn't
    any trivial way to emulate this feature. So we use the image fallback
    for now. This fix also forces an image fallback for extend-reflect, but
    in the end, it generates more or less the same file (one big image for
    the pattern). No other test is forced to use an image fallback by this
    patch.

 src/cairo-svg-surface.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 1d236521a527d8b07962d1d671daff35134f4d31
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 10:00:41 2008 -0800

    Increment cairo version to 1.5.11 after the 1.5.10 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 83489f623f1239a731c5377d634ea8e9b782d448
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 10:00:31 2008 -0800

    SGML churn

 doc/public/tmpl/cairo-paths.sgml | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

commit 0f2ecb5ec65ff13c3aafbe57600c1906f3fe7978
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 08:24:32 2008 -0800

    Update REFERENCE_IMAGES for distcheck

 test/Makefile.am | 64 +++++++++++++++++++++++++++++++++++++++++---------------
 1 file changed, 47 insertions(+), 17 deletions(-)

commit ee62a5fad6a32a6997600caac8b292aef4e2fe54
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 08:08:52 2008 -0800

    Mention that cairo_get_current_point is void again

 NEWS | 4 ++++
 1 file changed, 4 insertions(+)

commit 118657136d3323f4769bee28ec2435a61540f0eb
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 08:06:39 2008 -0800

    Increment cairo version to 1.5.10 and libtool versioning to 17:0:15

 configure.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 5aacc54c430a982b51992d6fac186b955e478045
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 08:02:45 2008 -0800

    NEWS: Add notes for cairo 1.5.10

 NEWS | 99 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 94 insertions(+), 5 deletions(-)

commit f954db72dd33de837296ede353ad9823b0e32fcd
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 06:24:48 2008 -0800

    Add svg-specific reference image for mask-alpha
    
    There's no apparent bug here.

 test/mask-alpha-svg-argb32-ref.png | Bin 0 -> 615 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit c197c684a6b002ad8549d92f15d7f68b7c0068bd
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 05:58:42 2008 -0800

    Update ps-specific reference images for ghostscript 8.61
    
    I was wrong in the previous message where I said I had ghostscript 8.61
    installed. I do now, (and "gs --version" says the same thing), and
    here are the new reference images.

 test/clip-fill-rule-ps-argb32-ref.png          | Bin 322 -> 310 bytes
 test/clip-fill-rule-ps-rgb24-ref.png           | Bin 309 -> 302 bytes
 test/dash-caps-joins-ps-argb32-ref.png         | Bin 3854 -> 3870 bytes
 test/dash-caps-joins-ps-rgb24-ref.png          | Bin 3852 -> 3870 bytes
 test/dash-curve-ps-ref.png                     | Bin 27206 -> 27293 bytes
 test/dash-state-ps-argb32-ref.png              | Bin 8652 -> 0 bytes
 test/dash-state-ps-ref.png                     | Bin 0 -> 10219 bytes
 test/dash-state-ps-rgb24-ref.png               | Bin 8650 -> 0 bytes
 test/dash-zero-length-ps-argb32-ref.png        | Bin 319 -> 0 bytes
 test/dash-zero-length-ps-ref.png               | Bin 0 -> 319 bytes
 test/dash-zero-length-ps-rgb24-ref.png         | Bin 0 -> 304 bytes
 test/degenerate-pen-ps-argb32-ref.png          | Bin 771 -> 795 bytes
 test/font-matrix-translation-ps-argb32-ref.png | Bin 785 -> 749 bytes
 test/font-matrix-translation-ps-rgb24-ref.png  | Bin 783 -> 749 bytes
 test/ft-text-vertical-layout-type1-ps-ref.png  | Bin 1894 -> 1911 bytes
 test/ft-text-vertical-layout-type3-ps-ref.png  | Bin 1879 -> 1867 bytes
 test/glyph-cache-pressure-ps-ref.png           | Bin 1667 -> 1413 bytes
 test/gradient-alpha-ps-argb32-ref.png          | Bin 179 -> 189 bytes
 test/line-width-scale-ps-argb32-ref.png        | Bin 3903 -> 0 bytes
 test/line-width-scale-ps-ref.png               | Bin 0 -> 3911 bytes
 test/line-width-scale-ps-rgb24-ref.png         | Bin 3901 -> 0 bytes
 test/linear-gradient-ps-argb32-ref.png         | Bin 613 -> 0 bytes
 test/linear-gradient-ps-ref.png                | Bin 0 -> 718 bytes
 test/linear-gradient-ps-rgb24-ref.png          | Bin 613 -> 0 bytes
 test/linear-gradient-reflect-ps-ref.png        | Bin 315 -> 314 bytes
 test/meta-surface-pattern-ps-argb32-ref.png    | Bin 3246 -> 3257 bytes
 test/meta-surface-pattern-ps-rgb24-ref.png     | Bin 3823 -> 3873 bytes
 test/new-sub-path-ps-argb32-ref.png            | Bin 559 -> 556 bytes
 test/operator-clear-ps-argb32-ref.png          | Bin 1409 -> 1437 bytes
 test/operator-source-ps-argb32-ref.png         | Bin 4026 -> 3893 bytes
 test/operator-source-ps-rgb24-ref.png          | Bin 3366 -> 3241 bytes
 test/pixman-rotate-ps-argb32-ref.png           | Bin 411 -> 0 bytes
 test/pixman-rotate-ps-rgb24-ref.png            | Bin 392 -> 0 bytes
 test/random-intersections-ps-argb32-ref.png    | Bin 89733 -> 0 bytes
 test/random-intersections-ps-ref.png           | Bin 0 -> 89253 bytes
 test/random-intersections-ps-rgb24-ref.png     | Bin 89733 -> 0 bytes
 test/select-font-face-ps-ref.png               | Bin 1352 -> 1079 bytes
 test/show-text-current-point-ps-ref.png        | Bin 1475 -> 1454 bytes
 test/text-pattern-ps-argb32-ref.png            | Bin 998 -> 984 bytes
 test/text-pattern-ps-rgb24-ref.png             | Bin 969 -> 936 bytes
 test/text-rotate-ps-argb32-ref.png             | Bin 7156 -> 0 bytes
 test/text-rotate-ps-rgb24-ref.png              | Bin 7156 -> 0 bytes
 test/trap-clip-ps-argb32-ref.png               | Bin 5715 -> 5591 bytes
 test/trap-clip-ps-rgb24-ref.png                | Bin 5630 -> 5512 bytes
 44 files changed, 0 insertions(+), 0 deletions(-)

commit 8d2d4130146d16676c9ed6cf7d82d6aeaadf1c56
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 05:11:53 2008 -0800

    Expand the documentation of cairo/test/README
    
    Add notes on CAIRO_REF_DIR and the version requirements of
    poppler and ghostscript necessary for getting no failures.

 test/README | 99 +++++++++++++++++++++++++++++++++++++++++++++++++++++--------
 1 file changed, 87 insertions(+), 12 deletions(-)

commit 4d42f569007f23e4cf9713c14f8c3dc640cf0f2c
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 04:22:58 2008 -0800

    Update ps-specific reference images
    
    Presumably these are due to ghostscript version churn. I don't
    know what version was used in the past, but we're going to be
    more careful about documenting versions now.
    
    The ghostscript package I used here advertises itself as "8.61"
    and "gs --version" reports 8.15.3.

 test/ft-text-vertical-layout-type1-ps-argb32-ref.png | Bin 1879 -> 0 bytes
 test/ft-text-vertical-layout-type1-ps-ref.png        | Bin 0 -> 1894 bytes
 test/ft-text-vertical-layout-type3-ps-argb32-ref.png | Bin 1882 -> 0 bytes
 test/ft-text-vertical-layout-type3-ps-ref.png        | Bin 0 -> 1879 bytes
 test/text-pattern-ps-rgb24-ref.png                   | Bin 969 -> 969 bytes
 5 files changed, 0 insertions(+), 0 deletions(-)

commit 78b270601ce54545a0c68075a60a3b85a2f37adb
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 03:49:16 2008 -0800

    Add poppler-specific reference image for source-clip-scale
    
    This one doesn't have any associated poppler bug report. The
    rendering by poppler is totally reasonable, and not problematic
    at all with respect to what the test is actually testing for.

 test/source-clip-scale-pdf-ref.png | Bin 0 -> 113 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 64b7489a50808bd660a47615d0775842c77dd0f2
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 03:47:34 2008 -0800

    Add poppler-specific reference image for push-group
    
    This is justified by the following new bug report:
    
            Incorrect clipping of group object (regression?)
            https://bugs.freedesktop.org/show_bug.cgi?id=14580

 test/README                       |   5 +++++
 test/push-group-pdf-ref.png       | Bin 0 -> 2694 bytes
 test/push-group-pdf-rgb24-ref.png | Bin 0 -> 2611 bytes
 3 files changed, 5 insertions(+)

commit 7aaa3e67c5016357e28476b10d768101e1e5bd41
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 03:38:07 2008 -0800

    Add poppler-specific reference images for tests needing EXTEND_PAD
    
    This is justified by the following new bug report:
    
            Poppler should paint images with CAIRO_EXTEND_PAD
            https://bugs.freedesktop.org/show_bug.cgi?id=14578
    
    The four affected tests are:
    
            paint-source-alpha
            paint-with-alpha
            rotate-image-surface-paint
            scale-source-surface-paint

 test/README                                       |   9 +++++++--
 test/paint-source-alpha-pdf-ref.png               | Bin 0 -> 473 bytes
 test/paint-with-alpha-pdf-ref.png                 | Bin 0 -> 466 bytes
 test/rotate-image-surface-paint-pdf-rgb24-ref.png | Bin 0 -> 207 bytes
 test/scale-source-surface-paint-pdf-rgb24-ref.png | Bin 0 -> 198 bytes
 5 files changed, 7 insertions(+), 2 deletions(-)

commit fdd046edccf283bfedb59733516f6110cc96ea82
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 03:23:38 2008 -0800

    Add poppler-specific reference image for text-pattern
    
    This is justified with the following new bug report:
    
            Poppler renders patterned text as black
            https://bugs.freedesktop.org/show_bug.cgi?id=14577

 test/README                          |   6 ++++++
 test/text-pattern-pdf-argb32-ref.png | Bin 0 -> 1823 bytes
 test/text-pattern-pdf-rgb24-ref.png  | Bin 0 -> 508 bytes
 3 files changed, 6 insertions(+)

commit 43302f0408d92138ac12afcd855d44c430074859
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 03:15:17 2008 -0800

    Re-enable pdf tests with gradients and add poppler-based reference images
    
    This freezes the current (buggy) poppler result in the test suite
    so that we will notice any future regressions.

 boilerplate/cairo-boilerplate-pdf.c             |  42 ---------------------
 test/README                                     |  47 ++++++++++++++++++++++++
 test/gradient-alpha-pdf-argb32-ref.png          | Bin 0 -> 126 bytes
 test/gradient-alpha-pdf-rgb24-ref.png           | Bin 0 -> 121 bytes
 test/gradient-alpha.c                           |   3 +-
 test/linear-gradient-pdf-ref.png                | Bin 0 -> 935 bytes
 test/linear-gradient-reflect-pdf-argb32-ref.png | Bin 0 -> 248 bytes
 test/linear-gradient-reflect-pdf-rgb24-ref.png  | Bin 0 -> 248 bytes
 test/linear-gradient.c                          |   3 +-
 test/text-pattern.c                             |   3 +-
 test/trap-clip-pdf-argb32-ref.png               | Bin 0 -> 5809 bytes
 test/trap-clip-pdf-rgb24-ref.png                | Bin 0 -> 5768 bytes
 test/trap-clip.c                                |   3 +-
 13 files changed, 51 insertions(+), 50 deletions(-)

commit 635fed77676f2446cbedfcf52a85f96e32c3a241
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 02:24:28 2008 -0800

    Re-enable some pdf tests now that poppler has knockout support
    
    We had several pdf tests disabled waiting for this bug fix:
    
            Poppler does not correctly handle knockout groups
            https://bugs.freedesktop.org/show_bug.cgi?id=12185
    
    That's in place for poppler now, so we're turning the tests
    back on. Some of the affected tests now pass perfectly:
    
            over-above-source
            over-around-source
            over-below-source
            over-between-source
    
    Some just needed new reference images:
    
            operator-clear
            clip-operator-pdf-argb32
    
    The remaining tests still fail, but none of the failures can
    obviously be ascribed to just poppler problems:
    
            clip-operator-pdf-rgb24
            operator-source
            unbounded-operator
    
    The first two have some serious problems, while in the case
    of unbounded-operator the problem is extremely minor (a white
    grid appears in the background where the reference image is
    all black).

 boilerplate/cairo-boilerplate-pdf.c    |  13 -------------
 test/clip-operator-pdf-argb32-ref.png  | Bin 0 -> 9096 bytes
 test/operator-clear-pdf-argb32-ref.png | Bin 0 -> 1438 bytes
 test/operator-clear-pdf-rgb24-ref.png  | Bin 0 -> 1170 bytes
 4 files changed, 13 deletions(-)

commit 98189d860e2c4219f994dd19fb199fcf4b457852
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 01:43:51 2008 -0800

    svg: Add support for flattening SOURCE painting when there's nothing beneath it
    
    This avoids unnecessary rasterization in many cases when using
    cairo_surface_create_similar with an SVG surface. Because of that
    it eliminates test-suite failures for the -similar cases where we
    have svg-specific reference images. Namely:
    
            font-matrix-translation, ft-text-vertical-layout-type1,
            ft-text-vertical-layout-type3, mask, meta-surface-pattern,
            paint-source-alpha, paint-with-alpha, rotate-image-surface-paint,
            scale-source-surface-paint, source-clip-scale, text-pattern,
            text-rotate
    
    In all of these cases the test suite was kindly noticing that we
    weren't getting the same 'native' SVG output that was desired.

 src/cairo-svg-surface.c | 15 +++++++++++----
 1 file changed, 11 insertions(+), 4 deletions(-)

commit e7c6e291a64391004ae7bafc4d69830af5b0c8b1
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 01:43:22 2008 -0800

    Add svg-specific reference images for meta-surface-pattern test

 test/meta-surface-pattern-svg-argb32-ref.png | Bin 0 -> 3896 bytes
 test/meta-surface-pattern-svg-rgb24-ref.png  | Bin 0 -> 4593 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit a1867412210db667a02e7b656729e2cf6a64a2d7
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 20 01:38:59 2008 -0800

    cairo-svg: Make operation_supported depend on analyze_operation instead of the other way around.
    
    This prepares for analyze_operation to be able to return more than
    just two values, (which will allow the svg backend to take advantage
    of CAIRO_INT_STATUS_FLATTEN_TRANSPARENCY).

 src/cairo-svg-surface.c | 27 +++++++++++++++------------
 1 file changed, 15 insertions(+), 12 deletions(-)

commit 8f11c4583f58f97c348aafcd71db059ac7791fe7
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Feb 18 17:32:35 2008 -0800

    Revert "[meta-surface] Adjust tolerance when replaying to surfaces with device scale"
    
    This reverts commit 7f21bfb0a8265095d68bb5ff6afae7553683a776.
    
    We don't yet have consensus on whether this is a good change or not.
    So for now, we're favoring the existing behavior until we can work
    that out.

 src/cairo-meta-surface.c | 11 +++++------
 1 file changed, 5 insertions(+), 6 deletions(-)

commit 1747718406b3450bc8869f0e050f9a18b3036030
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 14 12:27:47 2008 -0800

    Add a spline to the degenerate-pen test case
    
    This was triggering an infinite loop (with 24.8 fixed-point) just before
    the previous fix.
    
    NOTE: I usually put bug demonstrations just before the fixes, but this
    one was quite harsh---not only was cairo looping infinitely, but it
    was appending to an array on each iteration---so not kind at all.

 test/degenerate-pen-ps-argb32-ref.png | Bin 374 -> 771 bytes
 test/degenerate-pen-ref.png           | Bin 278 -> 788 bytes
 test/degenerate-pen.c                 |   3 +++
 3 files changed, 3 insertions(+)

commit d6d81c92b501b32be6c48d134683ebd51f63c134
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 16 13:27:02 2008 -0800

    Eliminate a potential infinite loop in spline stroking
    
    Sometimes > rather than >= can make a bug difference. The infinite loop
    was noticed here:
    
            Infinite loop when scaling very small values using 24.8
            http://bugs.freedesktop.org/show_bug.cgi?id=14280
    
    Note that that particular test case only exposes the infinite
    loop when using 24.8 instead of 16.16 fixed-point values by
    setting CAIRO_FIXED_FRAC_BITS to 8.

 src/cairo-pen.c | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit 770b058c9e53c6d0e3a3f600cd5a9631eee39dff
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Feb 16 13:17:49 2008 -0800

    Remove _cairo_slope_[counter_]clockwise
    
    These two functions were hiding away some important details
    about strictness of inequalities. Also, the callers differ
    on the strictness they need. Everything is cleaner and more
    flexible by making the callers just call _cairo_slope_compare
    directly.

 src/cairo-path-stroke.c |  2 +-
 src/cairo-pen.c         | 30 ++++++++++++++++--------------
 src/cairo-slope.c       | 23 -----------------------
 src/cairoint.h          |  6 ------
 4 files changed, 17 insertions(+), 44 deletions(-)

commit 2d22d698d32575fd883d2be072c041709254c86d
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Feb 14 11:50:26 2008 -0800

    Make _cairo_slope_compare return a non-zero result for slopes that differ by pi
    
    This was an initial attempt to fix the infinite loop bug
    described here:
    
            Infinite loop when scaling very small values using 24.8
            http://bugs.freedesktop.org/show_bug.cgi?id=14280
    
    This doesn't actually fix that bug, but having a more robust
    comparison function can only be a good thing.

 src/cairo-slope.c | 30 ++++++++++++++++++++++++++++--
 1 file changed, 28 insertions(+), 2 deletions(-)

commit 9292c0a1b509ecea8415cdbc21415d9ce7615e04
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 20 10:54:14 2008 +0000

    [gitignore] Ignore cairo-no-features.h
    
    Add the autogenerated header to the ignore list.

 src/.gitignore | 1 +
 1 file changed, 1 insertion(+)

commit e6a8768a0446b9e537bb77bd309ad5719fe74451
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 20 10:53:15 2008 +0000

    [cairo-scaled-font-subsets] Fix memleak on failure to reserve .notdef glyph.
    
    Remember to destroy the sub_font if we fail to reserve the .notdef glyph
    during construction.
    
    Whilst in the vicinity, adjust the function prototype to remove
    duplicated calls to _cairo_error().

 src/cairo-scaled-font-subsets.c | 57 ++++++++++++++++++++++-------------------
 1 file changed, 30 insertions(+), 27 deletions(-)

commit e208f31236af6b2012d725696485f96fe4acd863
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 19 15:14:37 2008 +0000

    [cairo-surface] Check surface status on internal paths as well.
    
    Return any error status on the surface to the caller.

 src/cairo-surface.c | 50 +++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 49 insertions(+), 1 deletion(-)

commit 1d59daecfe1078ba2ad56f80b35c934312dc4f6b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 19 15:13:53 2008 +0000

    [cairo-pdf-operators] Cleanup word_wrap_stream
    
    Ensure that the stream is destroyed on the error paths.

 src/cairo-pdf-operators.c | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

commit aac5650beebb40068767a7d3ffedf634a3da5002
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 19 14:39:13 2008 +0000

    [pdf-operators] Missing private markup.
    
    Fixup make check by adding the required cairo_private markup.

 src/cairo-pdf-operators-private.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit eaaa1415a9becb8f11ddde4094fcf0aec6d1458f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Feb 20 21:05:23 2008 +1030

    Change PDF newline characters from \r\n to \n
    
    The PDF backend has always used "\r\n" for the newline character.
    There was no particular reason for this choice. PDF allows "\n", "\r",
    or "\r\n" as the end of line marker.
    
    Since the PS backend (which uses "\n") has started sharing
    cairo-pdf-operators.c with the PDF backend, the PS output has been
    getting mixed "\n" and "\r\n" newlines.
    
    Fix this by changing the PDF backend to use "\n".

 src/cairo-pdf-operators.c |  40 +--
 src/cairo-pdf-surface.c   | 878 +++++++++++++++++++++++-----------------------
 2 files changed, 459 insertions(+), 459 deletions(-)

commit 24c319fbae9ea4a43bf4e1fdf94d069b4ad78904
Author: Bertram Felgenhauer <int-e@gmx.de>
Date:   Sat Feb 16 09:22:01 2008 +0100

    [perf] add tests for magnified and minified image sources.
    With this change, cairo's performance testsuite will catch performance
    regressions in pixman's fbFetchTransformed path.

 perf/cairo-perf-cover.c | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

commit 21049a9a5eb7ba0873771428bde0db8f8b1ece08
Author: Antoine Azar <cairo@antoineazar.com>
Date:   Mon Feb 18 23:57:38 2008 -0500

    Added cairo-misc.c to makefile

 src/Makefile.win32 | 1 +
 1 file changed, 1 insertion(+)

commit f2d21e73827d81da559ee4cd046bfb02dfd66a83
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 18 17:18:51 2008 -0800

    [stroker] fix _compute_normalized_device_slope to return correct sign
    
    The optimization to avoid sqrt() for horizontal/vertical lines in
    _compute_normalized_device_slope was causing us to return a negative
    magnitude with a positive slope for left-to-right and bottom-to-top
    lines, instead of always returning a positive magnitude and a slope
    with an appropriate sign.

 src/cairo-path-stroke.c | 18 ++++++++++++++----
 1 file changed, 14 insertions(+), 4 deletions(-)

commit 8fb624dbf2c660fbbf6d6964f7876656e1b62e41
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 17 19:49:39 2008 +1030

    Use correct prefix for _cairo_pdf_operators_stroke
    
    s/operator/operators/

 src/cairo-pdf-operators-private.h | 10 +++++-----
 src/cairo-pdf-operators.c         | 10 +++++-----
 src/cairo-pdf-surface.c           | 20 ++++++++++----------
 src/cairo-ps-surface.c            | 10 +++++-----
 4 files changed, 25 insertions(+), 25 deletions(-)

commit d2a1576941e46fb71eda8b27bd3df4de691df6ff
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 17 19:48:01 2008 +1030

    PDF/PS: Fix mismatched save restore when using fill-stroke

 src/cairo-pdf-surface.c | 11 +++++++++--
 1 file changed, 9 insertions(+), 2 deletions(-)

commit 3a05b5d2d5989386e1500ffcf8738ca89ef8457d
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 17 19:45:45 2008 +1030

    PDF/PS: No need to use save/restore for solid colors

 src/cairo-pdf-surface-private.h | 1 +
 src/cairo-pdf-surface.c         | 7 +++++--
 2 files changed, 6 insertions(+), 2 deletions(-)

commit c7204adcf3ff6614aae75c4c1c5ef0fc5269d834
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Feb 17 02:32:00 2008 -0500

    [cairo-misc.c] Add misc functions to this file
    
    Anything functions that doesn't group with other functions enough to
    justify its own file should go here now.

 src/Makefile.am    |   1 +
 src/cairo-gstate.c |  79 -----------
 src/cairo-misc.c   | 407 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo.c        | 287 -------------------------------------
 4 files changed, 408 insertions(+), 366 deletions(-)

commit a1360322c4e2867d7060a7f65bf0d96d9af36174
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 17 17:16:53 2008 +1030

    PS: Remove unused code

 src/cairo-ps-surface.c | 9 ---------
 1 file changed, 9 deletions(-)

commit 2dfe32a0ff9272ade481796f0f25fd83863c7600
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 17 16:45:15 2008 +1030

    Implement PDF fill-stroke

 src/cairo-meta-surface.c          | 15 ++++++-
 src/cairo-pdf-operators-private.h |  8 ++++
 src/cairo-pdf-operators.c         | 51 +++++++++++++++++++++-
 src/cairo-pdf-surface.c           | 92 +++++++++++++++++++++++++++++++++++++++
 4 files changed, 164 insertions(+), 2 deletions(-)

commit 1e7fa4b9f5c478bcb7c49667192f239c2bd1d03e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Feb 16 22:47:31 2008 -0500

    [cairo-pdf-operators] Pass matrix by reference, not by value

 src/cairo-pdf-operators-private.h |  4 ++--
 src/cairo-pdf-operators.c         |  8 ++++----
 src/cairo-pdf-surface.c           | 12 ++++++------
 src/cairo-ps-surface.c            |  9 +++++----
 4 files changed, 17 insertions(+), 16 deletions(-)

commit 357f2334f0bd518815c80905e451b6ac1ba43553
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 16 20:37:16 2008 +1030

    PDF: Allow word_wrap_stream to split hex strings

 src/cairo-pdf-operators.c | 50 +++++++++++++++++++++++++++++++++++++++++------
 1 file changed, 44 insertions(+), 6 deletions(-)

commit 204a27aadb2390b62bd75857d8736b34870f79b1
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 16 20:35:42 2008 +1030

    PDF: Word wrap _cairo_pdf_operators_show_glyphs output

 src/cairo-pdf-operators.c | 38 ++++++++++++++++++++++++--------------
 1 file changed, 24 insertions(+), 14 deletions(-)

commit bcb0395288128da7dd8f24c503b8badacc806720
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 15 15:56:29 2008 -0500

    [docs] Fix typo

 src/cairo-font-options.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 536e1963b774038d9afc7fbf63303e118b0250a2
Author: Shailendra Jain <shailen.n.jain@gmail.com>
Date:   Fri Feb 15 13:21:29 2008 +0000

    Compile fix for AIX.
    
    Minor correction for a build failure on AIX:
    "mozilla/gfx/cairo/cairo/src/cairo-gstate.c", line 45.43: 1506-294 (S)
    Syntax error in expression on #if directive.
    
    (Fixes https://bugzilla.mozilla.org/show_bug.cgi?id=415867.)

 src/cairo-gstate.c    | 2 +-
 src/cairo-matrix.c    | 2 +-
 test/invalid-matrix.c | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 31a67c5f22eb2cbb94878d47be19b32ff319c5b3
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 15 13:16:58 2008 +0000

    [pdf] Minor make check fix.
    
    Add a missing '%' in the documentation.

 src/cairo-pdf-operators.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 9e9fda047879f0336c2627483c78499af8ef5458
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Feb 12 11:16:37 2008 +0000

    [test/bitmap-font] Destroy the font options after use.
    
    Fix the leak of the font options.

 test/bitmap-font.c | 2 ++
 1 file changed, 2 insertions(+)

commit 92970ec83687435e75e60110cb7434670515ae57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 17:00:30 2008 +0000

    [test/invalid-matrix] Test detection of infinities.
    
    Feed infinities into the API and check that we correctly return
    INVALID_MATRIX.

 test/invalid-matrix.c | 123 +++++++++++++++++++++++++++++++++++++++++++++++++-
 1 file changed, 122 insertions(+), 1 deletion(-)

commit 012f68e043d3594fa6cb5235eafb1ca1bfe2d099
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 16:48:24 2008 +0000

    [test/invalid-matrix] Check scale(0,0)
    
    Test that INVALID_MATRIX is returned if the user calls cairo_scale(0,0)
    or a variant thereof.

 test/invalid-matrix.c | 16 ++++++++++++++++
 1 file changed, 16 insertions(+)

commit eb7488e1e67b872d29d1bd459bb7994ad3789576
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 16:45:18 2008 +0000

    [test/invalid-matrix] Promote incorrect status warning to an error.
    
    As the last warning for an incorrect status has been resolved, throw an
    error if we regress and no longer report an INVALID_MATRIX under testing.

 test/invalid-matrix.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit fc732c3aaa53d8abcea46ad28da696ad08d09b63
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 16:17:34 2008 +0000

    [cairo-scaled-font] Create error objects on demand.
    
    In order to correctly report the error back to the user during the
    creation of a scaled font, we need to support a nil object per error.
    Instead of statically allocating all possible errors, lazily allocate
    the nil object the first time we need to report a particular error.
    
    This fixes the misreporting of an INVALID_MATRIX or NULL_POINTER that
    are common user errors during the construction of a scaled font.

 src/cairo-debug.c              |  2 ++
 src/cairo-mutex-list-private.h |  1 +
 src/cairo-scaled-font.c        | 65 +++++++++++++++++++++++++++++++++++++-----
 src/cairo.c                    | 10 ++-----
 src/cairo.h                    |  2 +-
 src/cairoint.h                 | 15 +++++++++-
 test/font-options.c            |  2 +-
 7 files changed, 79 insertions(+), 18 deletions(-)

commit 38fcc015a5106e5007035c22355da863b3bc9def
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 16:14:40 2008 +0000

    [cairo-ft-font] Propagate error detected during determination of scale factors.
    
    Ensure that if an invalid matrix is detected when creating the toy font,
    the error is propagated to the caller.

 src/cairo-ft-font.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit ad265cc9f26a20f2336747d69b28bc6ca0d91f4b
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 14:58:21 2008 +0000

    [cairo-font-options] Disallow use of NULL font-options.
    
    Partial revert of commit 0086db893cba90dc73824d77c661d2965ad48112.
    
    This is a follow to the earlier commit that allowed creation of scaled
    fonts using a NULL font options (by interpreting the NULL as meaning
    use the default options) to reflect the comments made by Behdad
    (http://lists.cairographics.org/archives/cairo/2008-January/012714.html).
    
    The intent is that the public font options getter/setter API has similar
    defensive behaviour to that of the core objects - i.e. do not overwrite
    the nil object and if the object is in error then return the default
    value. For the indirect use of a NULL/nil font options (e.g. creation of
    scaled fonts), then an error should be returned rather than crashing.

 src/cairo-font-face.c    |  8 +++-----
 src/cairo-font-options.c | 36 +++++++++++++---------------------
 src/cairo-ft-font.c      |  8 +++-----
 src/cairo-scaled-font.c  | 13 ++++--------
 src/cairo-win32-font.c   |  4 ++--
 src/cairo.c              | 10 ++++------
 test/font-options.c      | 51 +++++++++++++++++++++++++++---------------------
 7 files changed, 59 insertions(+), 71 deletions(-)

commit 790eaef71cbd30e1994c9499ab553f2ef5e5d620
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Mon Feb 11 10:31:33 2008 +0000

    [boilerplage] Add getopts to the boilerplate library.
    
    Remember to compile the _cairo_getopts() function into the boilerplate
    convenience library for cairo-perf.

 boilerplate/Makefile.am | 14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit fe93038ef343c769b38b9e7f15c1be415e6bcdd9
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Feb 8 08:36:34 2008 +0000

    [test/font-options] Check for HAVE_FCFINI
    
    Only pull in the fontconfig headers if we actually use FcFini().

 test/font-options.c | 2 ++
 1 file changed, 2 insertions(+)

commit 2eb03b8cf2b2c0520d018127b377071a8a63799d
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 7 17:07:43 2008 +0000

    [cairo-ps-surface] Tidy return from _analyze_image_transparency().
    
    _analyze_image_transparency() only returned SUCCESS, so use the return
    parameter to pass back the transparency type instead of using an out
    parameter.

 src/cairo-ps-surface.c | 37 +++++++++++++------------------------
 1 file changed, 13 insertions(+), 24 deletions(-)

commit bc83e028b8d12223164263a9f9cfc822ed40f8c8
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Feb 7 11:47:11 2008 +0000

    [cairo-output-stream] Add format(printf) markup.
    
    Add CAIRO_PRINTF_FORMAT attribute to the printf-esque output stream
    functions, and fixup the one warning caught by the compiler.

 src/cairo-output-stream-private.h | 6 ++++--
 src/cairo-pdf-surface.c           | 4 ++--
 2 files changed, 6 insertions(+), 4 deletions(-)

commit 4430157841d4b55061c6af58576cfe6ec66fcfe5
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Feb 6 11:37:13 2008 +0000

    [test] Summarise the tests failures per backend.
    
    After the summary, show the total number of failures per backend.

 test/Makefile.am | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit af88d4d9ae66152ac885531bfc73a47eb78d1d03
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 30 15:20:50 2008 +0000

    [test/a8-mask] Fix memleak.
    
    Destroy the auxiallary surfaces and contexts.

 test/a8-mask.c | 14 ++++++++------
 1 file changed, 8 insertions(+), 6 deletions(-)

commit a3f071aee707e66e637587f1e9ae327b21243a60
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Wed Jan 30 15:19:49 2008 +0000

    [cairo-ft-font] Tidy usage of cairo_error().
    
    Remove a redundant use of cairo_error(NO_MEMORY).

 src/cairo-ft-font.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit a4c960a93cf5f37819b933d19f92e17e6c047c66
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 18 17:14:17 2008 +0000

    [test] Add tests using each backend as a source.
    
    Inspired by bug 7362 (painting a glitz surface onto an xlib surface
    crashes cairo) and the lack of coverage for
    _cairo_paginated_surface_acquire_source_image(), these tests attempt
    to use each backend as a source surface for all the other backends.
    For example, this checks that one can construct a PS file ready for
    printing and then copy that surface to an image/xlib for previewing.

 test/.gitignore                   |   6 ++
 test/Makefile.am                  |  19 +++-
 test/glitz-surface-source-ref.png | Bin 0 -> 268 bytes
 test/glitz-surface-source.c       | 196 ++++++++++++++++++++++++++++++++++++++
 test/image-surface-source-ref.png | Bin 0 -> 268 bytes
 test/image-surface-source.c       |  35 +++++++
 test/pdf-surface-source-ref.png   | Bin 0 -> 268 bytes
 test/pdf-surface-source.c         |  41 ++++++++
 test/ps-surface-source-ref.png    | Bin 0 -> 268 bytes
 test/ps-surface-source.c          |  41 ++++++++
 test/surface-source.c             |  93 ++++++++++++++++++
 test/svg-surface-source-ref.png   | Bin 0 -> 268 bytes
 test/svg-surface-source.c         |  41 ++++++++
 test/xlib-surface-source-ref.png  | Bin 0 -> 268 bytes
 test/xlib-surface-source.c        |  76 +++++++++++++++
 15 files changed, 544 insertions(+), 4 deletions(-)

commit f59f22eecba7cbf2151e01533ba936ca94d25056
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 29 09:29:10 2008 +0000

    [check] Only build documents during make check if we have GTK_DOC
    
    Check that gtk-doc has been enabled before running attempting to build
    the docs during make check.

 doc/public/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit e5f0253b67801ad79eb881e189b9835aea0fcf57
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 29 09:07:14 2008 +0000

    [cairo-surface] Hide the compiler warnings.
    
    Assign the return value from _cairo_surface_set_error() to hide the
    compiler warnings.

 src/cairo-surface.c | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

commit 53c1ed25abb7e8e22b24aa64fcd29d210c6b7903
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 29 08:52:28 2008 +0000

    [test/a1-sample-image] Fix the memleak.
    
    Destroy the surface after use.

 test/a1-image-sample.c | 2 ++
 1 file changed, 2 insertions(+)

commit 5efc88e9108df2331772cc22dc52ef0a9cc93869
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Tue Jan 29 08:50:25 2008 +0000

    [xmalloc] Hide valgrind warning.
    
    Allocate the string to the next integer boundary to hide a valgrind
    warning.

 boilerplate/xmalloc.c | 27 +++++++++++++++++++--------
 1 file changed, 19 insertions(+), 8 deletions(-)

commit 1faf208093a8cce77d2f7d6b248bc1eb1bd19a8a
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 18 14:41:03 2008 +0000

    [cairo-png] Improve error return for invalid parameters.
    
    Only translate an UNSUPPORTED error into a SURFACE_TYPE_MISMATCH, all
    others can be returned to the user unadulterated.
    
    PNG doesn't support width==0 or height==0 and generates an error
    whilst writing - which without further information is assumed to be
    a NO_MEMORY error. So check the image size at the start and return a
    WRITE_ERROR for a zero sized image.

 src/cairo-png.c | 24 +++++++++++++-----------
 1 file changed, 13 insertions(+), 11 deletions(-)

commit d0cc1d929119d2e05578a60af3b873af1d7f6b13
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Fri Jan 18 14:34:41 2008 +0000

    [cairo-pdf-surface] Minor code tidy.
    
    Remove code duplication.

 src/cairo-pdf-surface.c | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit d7ce0582f1eb86b2af5964820378b75297822dd1
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 17 23:18:46 2008 +0000

    [test/font-options] Check the defaults values.
    
    Exercise the getters by checking that a fresh cairo_font_options_t has
    the default values.

 test/font-options.c | 24 ++++++++++++++++++++----
 1 file changed, 20 insertions(+), 4 deletions(-)

commit f40f24e272cf05a7a727217ae7a35844bf95f5d2
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 17 23:05:53 2008 +0000

    [test/invalid] Test cairo_translate() and friends for NaN safety.
    
    Pass NaNs to cairo_translate() and friends and check that they raise
    an INVALID_MATRIX error.

 test/invalid-matrix.c | 37 +++++++++++++++++++++++++++++++++++++
 1 file changed, 37 insertions(+)

commit 896da0305a09e53518d6d1af6f58bbfaf3ddc89c
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 15 23:54:55 2008 +1030

    Win32-printing: Fix meta surface patterns
    
    Ensure the win32-printing surface has the same fixes for meta surface
    patterns with more than one level of push/pop group that PS/PDF
    received in 060f384310e887f7f431a98e847b8a36fc303a0c

 src/cairo-win32-printing-surface.c | 28 ++++++++++++++++------------
 1 file changed, 16 insertions(+), 12 deletions(-)

commit fbde0fb872a3af78236f4cbc8024d4df245de9c8
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Feb 15 08:17:25 2008 +1030

    Update PS ref images

 test/degenerate-pen-ps-argb32-ref.png       | Bin 390 -> 374 bytes
 test/extend-reflect-ps-ref.png              | Bin 0 -> 153322 bytes
 test/extend-reflect-similar-ps-ref.png      | Bin 0 -> 153322 bytes
 test/glyph-cache-pressure-ps-ref.png        | Bin 0 -> 1667 bytes
 test/meta-surface-pattern-ps-argb32-ref.png | Bin 0 -> 3246 bytes
 test/meta-surface-pattern-ps-rgb24-ref.png  | Bin 0 -> 3823 bytes
 test/random-intersections-ps-argb32-ref.png | Bin 89416 -> 89733 bytes
 test/random-intersections-ps-rgb24-ref.png  | Bin 89414 -> 89733 bytes
 test/select-font-face-ps-ref.png            | Bin 0 -> 1352 bytes
 test/show-text-current-point-ps-ref.png     | Bin 0 -> 1475 bytes
 test/text-pattern-ps-argb32-ref.png         | Bin 997 -> 998 bytes
 test/text-rotate-ps-argb32-ref.png          | Bin 7198 -> 7156 bytes
 test/text-rotate-ps-rgb24-ref.png           | Bin 7196 -> 7156 bytes
 test/trap-clip-ps-argb32-ref.png            | Bin 5700 -> 5715 bytes
 test/trap-clip-ps-rgb24-ref.png             | Bin 5616 -> 5630 bytes
 15 files changed, 0 insertions(+), 0 deletions(-)

commit 40d5082c24819968a5ee5a8f72e3b9cd61cb6105
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 10 14:53:17 2008 +1030

    PS: Use currentfile as the image data source
    
    When the emitted image is not inside a PS procedure we can use the
    currentfile operator as the datasource instead of an array of strings.
    This avoids having to read to entire image data into printer memory
    before the image can be decoded. This improves the performance and
    reduces the chance of running out of memory on printers with limited
    memory.

 src/cairo-ps-surface-private.h |   1 +
 src/cairo-ps-surface.c         | 268 +++++++++++++++++++++++++----------------
 2 files changed, 168 insertions(+), 101 deletions(-)

commit fe334bb476bb1d7496b197b47ac60167e3fb10bd
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 10 14:52:39 2008 +1030

    PS: Use InterleaveType 2 for image and mask
    
    To be able to use the currentfile operator we need to combine the
    image data and mask data into the one data source. InterleaveType 2
    scan line interleaves the image and data.

 src/cairo-ps-surface.c | 129 ++++++++++++++++++-------------------------------
 1 file changed, 47 insertions(+), 82 deletions(-)

commit b053aaba80e1118ddd7f9c695f6491458f4f5794
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 22:46:01 2008 +1030

    PS: Don't use patterns for fill surface extend none
    
    _ps_surface_fill() can also avoid using PS patterns for EXTEND_NONE
    surface patterns. A clip path is set around the fill path then the
    surface is painted.

 src/cairo-ps-surface.c | 38 ++++++++++++++++++++++++++++++--------
 1 file changed, 30 insertions(+), 8 deletions(-)

commit 2324a48c95d88ae0b6a066bfc9b6722f42945efa
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 22:35:06 2008 +1030

    Update rotate-image-surface-paint ps ref image

 test/rotate-image-surface-paint-ps-argb32-ref.png | Bin 276 -> 0 bytes
 test/rotate-image-surface-paint-ps-ref.png        | Bin 0 -> 275 bytes
 test/rotate-image-surface-paint-ps-rgb24-ref.png  | Bin 274 -> 0 bytes
 3 files changed, 0 insertions(+), 0 deletions(-)

commit 67374af22fe60c27517dd3bef2c8f3cc2f683b12
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 22:31:58 2008 +1030

    PS: Don't use patterns for paint surface extend none
    
    This is the first of four patches intended to fix the bug reported in
    
    http://lists.cairographics.org/archives/cairo/2007-December/012226.html
    
    Previously the PS backend would draw all cairo patterns (except solid
    colors) by emitting a PS pattern. As PS does not support non repeating
    patterns, the PS backend would set a large repeat step to ensure that
    only one copy of the pattern is on the page.
    
    Some printers with limited memory are unable to print large images
    inside a pattern. This was probably because when using patterns the
    printer tries to keep the uncompressed image in memory so it can tile
    the pattern.
    
    When painting surface patterns with the extend mode EXTEND_NONE we do
    not need to use PS patterns. The image or meta surface commands can be
    emitted directly.

 src/cairo-ps-surface-private.h |   2 +
 src/cairo-ps-surface.c         | 234 ++++++++++++++++++++++++++++-------------
 2 files changed, 162 insertions(+), 74 deletions(-)

commit 6f9d71c10bf3e38c88378950037d1c81a2413617
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Thu Feb 7 00:28:19 2008 +1030

    Make PS backend use cairo-pdf-operators.c
    
    Changes include:
    - Replace PS prolog with new prolog that emulates PDF operators
    - Remove the [1 0 0 -1 0 height] ctm on each page. PS and PDF surfaces
      now both transform all output to PS/PDF coordinates.
    - Invert images to match PDF images where (0,0) is top left
    - emit_surface_pattern now uses the same transform as PDF
    - move the special dash handling into cairo-pdf-operators.c

 src/cairo-pdf-operators.c      |  82 ++++-
 src/cairo-ps-surface-private.h |   4 +
 src/cairo-ps-surface.c         | 767 ++++++++---------------------------------
 3 files changed, 219 insertions(+), 634 deletions(-)

commit 49f755ed2d517adabcdbe9f3834ff18b220dfa7f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Jan 30 20:42:28 2008 +1100

    PS: Remove the Type 3 outline glyph code
    
    This code is never used because outline glyphs that go through the
    fallback path are always embedded with Type 1 fallback. The only fonts
    that are embedded as Type 3 are bitmap fonts.

 src/cairo-ps-surface.c | 54 +++++---------------------------------------------
 1 file changed, 5 insertions(+), 49 deletions(-)

commit 0c6a362122657d5c9804fa7f45c3404aef052688
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Jan 30 20:38:17 2008 +1100

    pdf-operators: only one path matrix is required
    
    The PDF emit path orginally had two matrix transforms in the path
    struct. One for strokes and one for fill/clip. As only one transform
    at a time is ever used this can be simplified.

 src/cairo-pdf-operators.c | 41 ++++++++---------------------------------
 1 file changed, 8 insertions(+), 33 deletions(-)

commit 5639643efe12bee4252e8cb433d343999e34ec32
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Jan 30 20:16:08 2008 +1100

    Add PS linecap path workarounds to pdf_operators
    
    So that pdf_operators can be used by the PS backend. PDF also needs
    this workaround.

 src/cairo-pdf-operators.c | 123 ++++++++++++++++++++++++++++++++--------------
 1 file changed, 86 insertions(+), 37 deletions(-)

commit 0987fdee24d60573249a7fa3acc15e67454bd8b3
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Wed Jan 30 17:22:52 2008 +1100

    Add word_wrap stream to pdf-operators
    
    The word_wrap stream in ps-surface will be removed in a later commit.

 src/cairo-pdf-operators.c | 114 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 114 insertions(+)

commit d05f08bceebe832844ab97a5660af4fa1452697d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Feb 12 15:44:21 2008 -0500

    [configure.in] Make PS/PDF/SVG default enabled
    
    Previously they were default auto-detected.  We really want people
    have to go out of their way to not build them, hence the change.

 configure.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit fd3181c7bfdb468557d8c845a016b19c5a897955
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 12 20:22:38 2008 +1030

    PDF: Remove stale comments

 src/cairo-pdf-surface.c | 23 -----------------------
 1 file changed, 23 deletions(-)

commit bdb857a78b41d926b1c239cf988539842a72130b
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 12 20:19:03 2008 +1030

    PDF: Fix uninitialized variable in previous commit

 src/cairo-pdf-surface.c | 1 +
 1 file changed, 1 insertion(+)

commit ba6788fc968477cfae6ed76414dd91b21671d028
Author: Kristian Høgsberg <krh@redhat.com>
Date:   Mon Feb 11 13:44:48 2008 -0500

    [pdf] Use compressed PDF stream instead of compress_dup()
    
    The deflate stream has bounded (constant) memory overhead, whereas
    compress_dup() allocates memory proportional to the uncompressed data.
    
    This replaces compress_dup() usage with a compressed PDF stream for
    emitting images, alpha masks and font subsets, and eliminates the
    compress_dup() function.

 src/cairo-pdf-surface.c | 204 +++++++++++++-----------------------------------
 1 file changed, 55 insertions(+), 149 deletions(-)

commit e68584d3a16da7db30bc53a42fa8367c8356bd7e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Feb 8 17:36:59 2008 -0500

    [xlib] Move multiple CAIRO_MUTEX_INITIALIZE into one place they all end up anyway

 src/cairo-xlib-surface.c | 8 ++------
 1 file changed, 2 insertions(+), 6 deletions(-)

commit 0626cac6dba91d0ee20458858275745b7c6a1bfd
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Fri Feb 8 15:09:19 2008 +0100

    [os2] fix typo in comment

 src/cairo-os2-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b4fe25d9afff5d5b0ebaa315ad0e42f36853d5d1
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Fri Feb 8 15:04:49 2008 +0100

    [os2] only call FcInit/Fini when compiled with FT font backend

 src/cairo-os2-surface.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 5e9cdcca00a490f3a36b4229f5353d795ca53a5d
Author: Antoine Azar <cairo@antoineazar.com>
Date:   Thu Feb 7 17:09:41 2008 -0500

    Fixed rounding function call

 test/get-path-extents.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 80e11a85a95c5f2c814eef90a8e6ab60c8835104
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Feb 7 14:36:39 2008 -0800

    [pdf] restore alpha_size back to correct bit size

 src/cairo-pdf-surface.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 95db215cc15d228fcb38bc43d2d918fccec0a9cd
Author: Azar@.(none) <Azar@.(none)>
Date:   Fri Feb 1 18:45:59 2008 -0800

    Some fixes and improvements to the Win32 build

 Makefile.win32                         |  32 ++++-
 boilerplate/Makefile.win32             |  25 +++-
 boilerplate/cairo-boilerplate-getopt.c | 250 +++++++++++++++++++++++++++++++++
 boilerplate/cairo-boilerplate-getopt.h |  63 +++++++++
 boilerplate/cairo-boilerplate.h        |   4 +
 perf/Makefile.win32                    |  54 ++++++-
 perf/cairo-perf.c                      |   7 +-
 perf/cairo-perf.h                      |   2 +-
 perf/world-map.c                       |   2 +
 src/Makefile.win32                     |  36 +++--
 test/Makefile.win32                    |  25 +++-
 test/font-matrix-translation.c         |   2 +-
 test/pdiff/Makefile.win32              |   3 +
 13 files changed, 470 insertions(+), 35 deletions(-)

commit 7800cfd7de347bb8c54fc36ed886018a2d9ec503
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Feb 6 17:00:29 2008 -0800

    Add several Makefile.win32 files to EXTRA_DIST
    
    Otherwise, these files were being omitted from the tar files.

 Makefile.am             | 2 ++
 boilerplate/Makefile.am | 2 ++
 perf/Makefile.am        | 2 ++
 src/Makefile.am         | 2 ++
 test/Makefile.am        | 2 ++
 5 files changed, 10 insertions(+)

commit ac743e25fa7f8bd720219a5c909fe8bbd20b11b2
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Jan 31 16:13:44 2008 +1100

    cairo_xlib_surface_create_similar: Pass the original drawable to XCreatePixmap
    
    Previously we were passing the root window of the same screen.
    Letting the X server know the actual Drawable for which we're
    trying to be similar allows the X server to be more efficient.

 src/cairo-xlib-surface.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit cb9f9086a1c8ad312cfc5314fc8e352a6046d75e
Merge: c11b036b7 a9b0e54d3
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Thu Feb 7 00:07:20 2008 +0100

    Merge branch 'master' of ssh://pmw@git.freedesktop.org/git/cairo

commit c11b036b75f3c71ff57ff4578b388bf5e35b2057
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Thu Feb 7 00:03:33 2008 +0100

    [os2] Improve documentation
    
    Move the API documentation for the OS/2 backend from the .h file to the .c file and use the correct format.

 src/cairo-os2-surface.c | 139 ++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairo-os2.h         | 115 ---------------------------------------
 2 files changed, 139 insertions(+), 115 deletions(-)

commit a9b0e54d386811dc750b5e676a0dfd84c32f4625
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Feb 6 13:52:33 2008 -0800

    Avoid buffer overflow in ps/pdf surface
    
    A few places weren't using _cairo_malloc_*; fixed.

 src/cairo-pdf-surface.c | 22 ++++++++++++++++------
 src/cairo-ps-surface.c  |  4 ++--
 2 files changed, 18 insertions(+), 8 deletions(-)

commit bf1f7f70b61b5bb657b2531dab63c541ac8fb59d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Feb 6 13:01:52 2008 -0800

    Do correct calculation of pen dimensions for stroke optimization

 src/cairo-path-stroke.c  | 33 +++++++++++++--------------------
 src/cairo-rectangle.c    |  2 +-
 src/cairo-stroke-style.c | 17 +++++++++++++++++
 src/cairoint.h           | 11 ++++++++++-
 4 files changed, 41 insertions(+), 22 deletions(-)

commit e104fcab1c8c8d9a7a7962a1dbea0c87867c8f9a
Author: Alp Toker <alp@atoker.com>
Date:   Thu Jan 31 01:33:50 2008 +0000

    Introduce cairo_has_current_point()
    
    cairo_has_current_point() can be used to determine whether a current
    point is defined. We introduce this new symbol with a boolean return
    value to avoid the versioning ambiguity of modifying
    cairo_get_current_point(). This way we also don't have to map what
    should be a routine operation to an error condition as was previously
    proposed.

 doc/public/cairo-sections.txt |  1 +
 src/cairo.c                   | 25 +++++++++++++++++++++++--
 src/cairo.h                   |  3 +++
 3 files changed, 27 insertions(+), 2 deletions(-)

commit 1f0c3d06895ebcbfbae252e6b7298da0b64b37a9
Author: Alp Toker <alp@atoker.com>
Date:   Thu Jan 31 00:54:52 2008 +0000

    Revert "Change cairo_get_current_point() to return cairo_status_t instead of void"
    
    This reverts commit b3eea75d1f7b56c2046b5387a5eb186d8f154184.
    
    Reverted in favour of an alternative approach.
    
    Conflicts:
    
            src/cairo.c

 src/cairo.c | 22 ++++------------------
 src/cairo.h |  2 +-
 2 files changed, 5 insertions(+), 19 deletions(-)

commit 4c005f7ce385f3f8b161cffac11bb9766f4ef9a9
Author: Azar@.(none) <Azar@.(none)>
Date:   Fri Feb 1 14:29:24 2008 -0800

    replaced round with _cairo_lround. Round doesn't compile on Win32

 test/get-path-extents.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1d93e148766ded8f3105277f944849f6297974fb
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 5 16:14:51 2008 -0800

    Followup patch to dashed stroke optimization
    
    Make sure that we don't test lines that start or end inside the box,
    since our algorithm will find intersections on the wrong ends on the
    line, and not count them.

 src/cairo-rectangle.c | 10 ++++++++--
 1 file changed, 8 insertions(+), 2 deletions(-)

commit 7b788ce7cace4fd24c568248c22b4ec6c88b563b
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 5 15:04:38 2008 -0800

    Update test ref images that changed with stroking changes

 test/dash-scale-ref.png | Bin 7908 -> 8035 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 4471e58c12c20723f1ddac3d0284239be6eb27a8
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Mon Feb 4 03:55:55 2008 -0800

    Optimize dashed strokes, part 2
    
    Pass down the bounding box to the stroker, and avoid doing expensive
    calculations for dash segments that are outside the box.

 src/cairo-path-stroke.c | 122 ++++++++++++++++++++++++++++++++----------------
 src/cairo-rectangle.c   |  94 +++++++++++++++++++++++++++++++++++++
 src/cairo-traps.c       |   8 ++++
 src/cairoint.h          |  10 ++++
 4 files changed, 195 insertions(+), 39 deletions(-)

commit afbd82671fe5ebebe5d58bef3d372312be1c5aeb
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Feb 2 23:48:16 2008 -0800

    Optimize stroker by hoisting some calculations out of loops
    
    sqrt and a few other floating-point operations were being done
    repeatedly within a loop; those are now precalculated and passed
    down where needed.

 src/cairo-path-stroke.c | 142 +++++++++++++++++++++++++++++-------------------
 1 file changed, 87 insertions(+), 55 deletions(-)

commit bda0baa255801dbc21b63b364eff32de98dd6c7f
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 5 15:04:15 2008 -0800

    Fix text-zero-len on ATSUI to not infinite loop

 src/cairo-atsui-font.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit 03256d0f2be15e7ba57bc041f8cdfc1c3e718660
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Feb 5 15:04:11 2008 -0800

    Remove get-xrender-format from list of tests to be run on all platforms

 test/Makefile.am | 1 -
 1 file changed, 1 deletion(-)

commit 6140776b4e7d5787467606fbe8a961dbee6bd9fb
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 00:22:26 2008 +1030

    Update operator-source ps ref images

 test/operator-source-ps-argb32-ref.png | Bin 4053 -> 4026 bytes
 test/operator-source-ps-rgb24-ref.png  | Bin 2567 -> 3366 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit dee6e27537a26e93266c0a2d2071ad8d4ed2c9ee
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 00:12:48 2008 +1030

    Add dash-curve ps ref image

 test/dash-curve-ps-ref.png | Bin 0 -> 27206 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 2b0da0503baba111085a23e5e5e5feb8788d6650
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Feb 5 00:02:17 2008 +1030

    Ensure PS/PDF miter is >= 1.0
    
    The PS Language Reference requires the PS miter to be >= 1.
    
    The PDF Reference does not specify miter limits however acroread fails
    to display pages when the miter is < 1. Older versions of ghostscript
    crash when the PDF miter is < 1.

 src/cairo-pdf-operators.c | 2 +-
 src/cairo-ps-surface.c    | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 381fcf01d71d6c83183f9764507ebbafd783d18a
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 20:05:41 2008 +1030

    Update over-around-source ps ref image

 test/over-around-source-ps-argb32-ref.png | Bin 637 -> 632 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 9dda017af9bffeda59756cb3b15028ae83ed19ef
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 19:53:35 2008 +1030

    Update gradient-alpha ps ref images

 test/gradient-alpha-ps-argb32-ref.png | Bin 187 -> 179 bytes
 test/gradient-alpha-ps-rgb24-ref.png  | Bin 184 -> 179 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 3f943a98f69b90b066217b19c47851ce03e50551
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 19:49:23 2008 +1030

    Add linear-gradient-reflect ps ref image

 test/linear-gradient-reflect-ps-ref.png | Bin 0 -> 315 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit a74e6692341daeff9ab266b3b29fcc8b8e917d88
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 19:34:53 2008 +1030

    PS: Implement reflected surface patterns
    
    The image/meta-pattern is written once. A PS pattern twice the size of
    the cairo pattern is created and the surface drawn four times in a
    reflect pattern inside the PS pattern.
    
    This fixes the extend-reflect and extend-reflect-similar PS test
    failures.

 src/cairo-ps-surface.c | 41 +++++++++++++++++++++++++++++++++--------
 1 file changed, 33 insertions(+), 8 deletions(-)

commit 7c5bc5fde819014f62ebb9bac86d4529f056956d
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 18:58:02 2008 +1030

    Add operator-clear ps ref image

 test/operator-clear-ps-argb32-ref.png | Bin 0 -> 1409 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 06b2d009ba50a2908fd9c93ff3e467f511b233cf
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 18:50:14 2008 +1030

    Update clip-operator ps ref image

 test/clip-operator-ps-argb32-ref.png | Bin 8594 -> 9062 bytes
 1 file changed, 0 insertions(+), 0 deletions(-)

commit 13663d1d500a6c2254097011e66199d6dd81c62d
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Feb 3 17:10:56 2008 +1030

    PS: Implement linear gradient repeat and reflect

 src/cairo-ps-surface.c | 250 ++++++++++++++++++++++++++++++++++++++-----------
 1 file changed, 196 insertions(+), 54 deletions(-)

commit 92a2e851df6668f60c63165466d2ee85dd600f47
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 2 23:00:30 2008 +1030

    Update operator-source PS ref images

 test/operator-source-ps-argb32-ref.png | Bin 3885 -> 4053 bytes
 test/operator-source-ps-rgb24-ref.png  | Bin 3548 -> 2567 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 367e50137eb1b2b3952a87c580eed08a79fd211f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Feb 2 20:59:56 2008 +1030

    PDF: Use correct surface size when emitting patterns
    
    Store the surface size in each pattern and smask group and use this
    size when the pattern/group is emitted. This is required as a pattern
    or group may be used from a meta surface with a different size to the
    PDF surface. However the pattern or group is emitted after the the meta
    surface content has been emitted and the surface size has been
    restored to the the page size.
    
    This fixes the following pdf test failures:
      extend-reflect-similar
      extend-repeat-similar
      mask

 src/cairo-pdf-surface-private.h |  4 ++++
 src/cairo-pdf-surface.c         | 53 ++++++++++++++++++++++++++++++++++++-----
 2 files changed, 51 insertions(+), 6 deletions(-)

commit d08d5c421a45c4e5f30b308823e90a86f1ec2052
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 05:35:50 2008 -0800

    Increment cairo version to 1.5.9 after the 1.5.8 snapshot

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4ccb8cb29546432858e778e1b88cada1327f6f45
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 05:16:26 2008 -0800

    Add some more reference images to REFERENCE_IMAGES

 test/Makefile.am | 3 +++
 1 file changed, 3 insertions(+)

commit b31a7a904f8413c34970beabce6fecf6e1fdc925
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 05:13:53 2008 -0800

    Increment cairo version to 1.5.8 and libtool version to 16:0:14

 configure.in | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ca10920cc9f3a673e2199112541d5a1472423c47
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 05:07:20 2008 -0800

    Add a1-image-sample and a1-traps-sample reference images to the dist list

 test/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 2fee01e2d40715defe9143456101533c1f1aafcf
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 04:54:39 2008 -0800

    check-doc-syntax.sh: Fix for non-srcdir builds (such as make distcheck)

 src/check-doc-syntax.sh | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit 78022f3aa16cf8a629aec4595c5a542ca68a78cc
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 04:54:05 2008 -0800

    Add doc/public test scripts to EXTRA_DIST
    
    This prevents failures of make distcheck

 doc/public/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit d49b1220b2feeca82050de05c9c01012e8420acb
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 04:52:23 2008 -0800

    Remove extend-pad-similar test case
    
    This seems redundant with the recent testing of all test cases
    against similar surfaces. Plus, it hasn't had a reference image
    anyway which was causing problems with the recent extra checks
    for missing reference images.

 test/Makefile.am          |   3 --
 test/extend-pad-similar.c | 105 ----------------------------------------------
 2 files changed, 108 deletions(-)

commit 7d2fda54f9bf6ae48cf8048b4836dea7f20cccee
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 30 04:23:19 2008 -0800

    NEWS: Add notes for the 1.5.8 snapshot

 NEWS | 103 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 103 insertions(+)

commit 3b0adf4f5ac78e3f19b4e19267da2aa1b3c7d57b
Author: Jeff Muizelaar <jeff@infidigm.net>
Date:   Tue Jan 29 09:07:54 2008 -0800

    Use ADD instead of IN for clipping.
    
    ADD is already special-cased by pixman, so using it instead avoids hitting
    the slower general path.

 src/cairo-clip.c | 34 ++++++++++++++++++++++++++++++++--
 1 file changed, 32 insertions(+), 2 deletions(-)

commit fa6aedf2d68941bf8532bf487d5412cfc508e0a9
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 29 09:01:47 2008 -0800

    Fix typo in printf arguments in error message

 test/font-matrix-translation.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e2bb36fe08546e6461fcbd40f5f3f81e5efc7686
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 29 08:41:21 2008 -0800

    wAdd proper error propagation to _cairo_matrix_compute_scale_factors
    
    Before there was just an assert statement here that the
    determinant of the matrix was not infinite. That was bogus
    since a user-provided can end up here. So instead, do the
    correct error propagation of any CAIRO_STATUS_INVALID_MATRIX
    error as necessary.
    
    This eliminates the current failure of the invalid-matrix
    test case.

 src/cairo-atsui-font.c  | 56 ++++++++++++++++++++++++++++++++++++-------------
 src/cairo-ft-font.c     | 20 ++++++++++++------
 src/cairo-matrix.c      |  7 +++++--
 src/cairo-scaled-font.c | 13 ++++++++----
 src/cairo-win32-font.c  | 20 +++++++++++-------
 src/cairoint.h          |  4 ++--
 6 files changed, 83 insertions(+), 37 deletions(-)

commit 849322235764f570a4a3a1217960d096d16165cf
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 29 05:40:39 2008 -0800

    Initialize return values for cairo_*_extents in case of error
    
    Previously we left the return values alone, which set the
    user up for a nasty trap, (using potentially uninitialized
    values with no indication that there was an error). So now
    we initialize these values to 0.0 if the cairo_t is in error.
    
    The fixed functions include:
    
            cairo_path_extents
            cairo_stroke_extents
            cairo_fill_extents
            cairo_clip_extents
            cairo_font_extents

 src/cairo.c | 54 ++++++++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 50 insertions(+), 4 deletions(-)

commit 6bdba4b4be5e66ffa61e164f8098b76d848e8f32
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 29 05:27:10 2008 -0800

    Add missing libcairo_font_subset_sources to fix the build

 src/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 3d82056cee0ba960ebb61877fec8aa646e60e990
Author: Nis Martensen <nis.martensen@web.de>
Date:   Tue Jan 29 05:32:24 2008 -0500

    Fix typos

 src/cairo.h             | 4 ++--
 src/check-doc-syntax.sh | 4 ++--
 2 files changed, 4 insertions(+), 4 deletions(-)

commit b28f4f57f21ac4091c9457873abe1465ec3f7fed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 04:32:39 2008 -0500

    [src/Makefile.am] Reorganize
    
    Main goal was to be able to pass list of all cairo sources, enabled or
    not, to check-doc-syntax.sh such that it doesn't check *.h, *.c, *.cpp
    because that can be annoying when bisecting.

 src/Makefile.am         | 352 ++++++++++++++++++++++++++----------------------
 src/check-doc-syntax.sh |   5 +-
 2 files changed, 195 insertions(+), 162 deletions(-)

commit 41a57007939a3e206647fda1b6e5a554ca125c5f
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Tue Jan 29 20:27:06 2008 +1100

    Fix undefined macro that was preventing the tests from compiling

 test/pattern-getters.c | 28 ++++++++++++++--------------
 1 file changed, 14 insertions(+), 14 deletions(-)

commit cfce362375963502c4d29089b369d8e5ce2b7dcb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 01:27:47 2008 -0500

    [cairo_operator_t] Mark DestAtop unbounded and document boundedness

 src/cairo.h | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit f9b90e475ed6009e58e5f11ac713f9ea639a6900
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 01:20:03 2008 -0500

    [doc] Fix cairo_operator_t docs to make Carl (and Keith) happy

 src/cairo.h | 17 ++++++++++++-----
 1 file changed, 12 insertions(+), 5 deletions(-)

commit 9ee7a48b33f11a42b0ffd12a9192a328e35233f3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 00:50:48 2008 -0500

    [Makefile.am] Minor wording change

 Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 013781137ff4940d0b9e04b656c20af37bbd5333
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 00:42:51 2008 -0500

    [cairo-image-surface.c] Cleanup stride checking and improve docs

 src/cairo-image-surface.c | 16 ++++++++--------
 1 file changed, 8 insertions(+), 8 deletions(-)

commit 8e3250b8564a346c61e926a6aa61f18ae3f60c93
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 00:36:38 2008 -0500

    [Makefile.am] Remove ROADMAP and TODO from dist files

 Makefile.am | 4 +---
 1 file changed, 1 insertion(+), 3 deletions(-)

commit 81e4cc3bd7d1fec659a19f8b37253aaebe12c99b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 00:36:16 2008 -0500

    [cairo_image_surface_create_for_data] Document stride error status

 src/cairo-image-surface.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 6153a3b620641b1fb7b64a050a168482d2a42f2c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 29 00:34:00 2008 -0500

    [doc] Run check-doc-syntax.sh for SGML docs too

 doc/public/Makefile.am         |  4 ++--
 doc/public/check-doc-syntax.sh | 11 +++++++++++
 src/check-doc-syntax.sh        | 33 ++++++++++++++++++++++++---------
 3 files changed, 37 insertions(+), 11 deletions(-)

commit 3f7d301786ce345cc4221f434bda6751e9b97ad1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:56:23 2008 -0500

    [src/check-doc-syntax.sh] Skip test if GNU grep is not available

 src/check-doc-syntax.sh | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 247e1011995b0241526262cc36eb34c7e5edd47c
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 21:24:56 2008 -0800

    Fix bitmap-font test by using near-equality for double comparison

 test/bitmap-font.c     | 11 ++++++-----
 test/cairo-test.h      |  2 ++
 test/pattern-getters.c |  4 +---
 3 files changed, 9 insertions(+), 8 deletions(-)

commit 468caac068d3d25507d901f069e3e55731a27ae9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:30:09 2008 -0500

    [configure.in] Minor change to cairo-features.h comments to make tests pass

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b4c7a0dc6e996e47390ae544f82024afbb7859ed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:27:10 2008 -0500

    [doc] Document CAIRO_HAS_* macros.  We now finally have real 100% coverage.

 doc/public/Makefile.am                  | 2 ++
 doc/public/cairo-sections.txt           | 9 +++++++++
 doc/public/tmpl/cairo-ft.sgml           | 8 ++++++++
 doc/public/tmpl/cairo-pdf.sgml          | 8 ++++++++
 doc/public/tmpl/cairo-png.sgml          | 9 +++++++++
 doc/public/tmpl/cairo-ps.sgml           | 8 ++++++++
 doc/public/tmpl/cairo-svg.sgml          | 8 ++++++++
 doc/public/tmpl/cairo-win32-fonts.sgml  | 8 ++++++++
 doc/public/tmpl/cairo-win32.sgml        | 8 ++++++++
 doc/public/tmpl/cairo-xlib-xrender.sgml | 8 ++++++++
 doc/public/tmpl/cairo-xlib.sgml         | 8 ++++++++
 11 files changed, 84 insertions(+)

commit 47e0ecbea51cae73a85db277972b80eff0c4b9f6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:26:35 2008 -0500

    [configure.in] Generate a cairo-no-features.h with macros for disabled supported backends
    to trick gtk-doc with it.

 configure.in         | 33 ++++++++++++++++++++++++++++++++-
 src/Makefile.am      |  6 +++---
 src/check-headers.sh |  2 +-
 3 files changed, 36 insertions(+), 5 deletions(-)

commit 9d8990b6bdec8e574e37346c363b3a850a246452
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:23:00 2008 -0500

    [doc] Remove excess paranthesis

 src/cairo-xlib-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6e495e94886dfa80f11f675a4b7fa3a767671cc0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:10:28 2008 -0500

    [doc] More syntax fixes

 doc/public/tmpl/cairo-version.sgml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a00d71968285fc8c49903c1c84835a8be32cfbd3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 23:05:00 2008 -0500

    [configure.in] Add commented-out #undef's for disable stable backends in cairo-features.h

 configure.in | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 6a089247a180cbc85e222520d2d93914434027be
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 22:45:06 2008 -0500

    [doc] Rename cairo-font.sgml to cairo-font-face.sgml

 doc/public/cairo-docs.xml                                 | 2 +-
 doc/public/cairo-sections.txt                             | 2 +-
 doc/public/tmpl/{cairo-font.sgml => cairo-font-face.sgml} | 0
 3 files changed, 2 insertions(+), 2 deletions(-)

commit 1d17a7f7811b15c72a4091663e01a448f538bc68
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 22:42:46 2008 -0500

    [doc] Document the surface type of win32-printing surface being different

 doc/public/tmpl/cairo-win32.sgml | 11 ++++++++++-
 1 file changed, 10 insertions(+), 1 deletion(-)

commit a55f65b5d29060a7f8033ceea211252431d20b77
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 22:25:37 2008 -0500

    [doc] Fix typo

 src/cairo-pattern.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 52cc603db1a805a0b3a8d7eba3171cd2785f10a7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 22:10:20 2008 -0500

    [doc] Stricter syntax check for type names, update test

 src/cairo-array.c                       |  2 +-
 src/cairo-cache-private.h               |  2 +-
 src/cairo-font-face.c                   |  4 ++--
 src/cairo-ft-font.c                     |  4 ++--
 src/cairo-image-surface.c               |  2 +-
 src/cairo-paginated-private.h           |  8 ++++----
 src/cairo-ps-surface.c                  |  2 +-
 src/cairo-ps.h                          |  2 +-
 src/cairo-region-private.h              |  2 +-
 src/cairo-scaled-font-subsets-private.h | 16 ++++++++--------
 src/cairo-scaled-font.c                 |  2 +-
 src/cairo-svg.h                         |  2 +-
 src/cairo-types-private.h               |  2 +-
 src/cairo-win32-font.c                  |  2 +-
 src/cairo.c                             |  2 +-
 src/cairo.h                             | 24 ++++++++++++------------
 src/cairoint.h                          |  2 +-
 src/check-doc-syntax.sh                 |  9 +++++----
 18 files changed, 45 insertions(+), 44 deletions(-)

commit b790c5a6bcdd890c16d21753407188ed200ce445
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:53:44 2008 -0500

    [doc] Replace 'NOTE' by 'Note' and add it to test

 src/cairo-bentley-ottmann.c       | 2 +-
 src/cairo-cache.c                 | 4 ++--
 src/cairo-ft-font.c               | 4 ++--
 src/cairo-lzw.c                   | 4 ++--
 src/cairo-output-stream-private.h | 2 +-
 src/cairo-paginated-private.h     | 4 ++--
 src/cairo-path.c                  | 2 +-
 src/cairo-pen.c                   | 4 ++--
 src/cairo-scaled-font.c           | 4 ++--
 src/cairo-slope.c                 | 2 +-
 src/cairo-surface.c               | 4 ++--
 src/cairo-win32-surface.c         | 4 ++--
 src/cairo-xcb-surface.c           | 4 ++--
 src/cairo-xlib-surface.c          | 4 ++--
 src/cairo.c                       | 4 ++--
 src/check-doc-syntax.sh           | 7 +++++++
 16 files changed, 33 insertions(+), 26 deletions(-)

commit f0633f4449c39a8f78c582790fb5dc85899b5d82
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:49:57 2008 -0500

    [doc] Make sure all function names in docs are followed by ()

 src/cairo-array.c                       |  2 +-
 src/cairo-base85-stream.c               |  3 +--
 src/cairo-beos-surface.cpp              |  2 +-
 src/cairo-cache-private.h               |  4 ++--
 src/cairo-debug.c                       |  4 ++--
 src/cairo-deflate-stream.c              |  3 +--
 src/cairo-ft-font.c                     |  4 ++--
 src/cairo-image-surface.c               |  4 ++--
 src/cairo-output-stream-private.h       |  3 +--
 src/cairo-output-stream.c               |  3 +--
 src/cairo-paginated-private.h           |  2 +-
 src/cairo-path-fixed-private.h          |  2 +-
 src/cairo-path.c                        |  6 +++---
 src/cairo-pdf-surface.c                 |  4 ++--
 src/cairo-ps-surface.c                  |  6 +++---
 src/cairo-quartz-surface.c              |  2 +-
 src/cairo-scaled-font-subsets-private.h |  2 +-
 src/cairo-scaled-font.c                 |  8 ++++----
 src/cairo-surface.c                     |  6 +++---
 src/cairo-svg-surface.c                 |  4 ++--
 src/cairo-traps.c                       |  2 +-
 src/cairo-types-private.h               |  4 ++--
 src/cairo-unicode.c                     |  3 +--
 src/cairo.c                             | 30 ++++++++++++++----------------
 src/cairo.h                             | 22 +++++++++++-----------
 src/cairoint.h                          |  8 ++++----
 26 files changed, 68 insertions(+), 75 deletions(-)

commit 9ba8f6b1b0a4fbf2407e0dbd767f043c6920344c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:49:26 2008 -0500

    [src/check-doc-syntax.sh] Check for various doc syntax consistency rules

 src/Makefile.am         |  2 +-
 src/check-doc-syntax.sh | 36 ++++++++++++++++++++++++++++++++++++
 2 files changed, 37 insertions(+), 1 deletion(-)

commit e15fcdd74734e922183afd4732ec4ba090f313c9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:48:23 2008 -0500

    [doc] Improve syntax

 doc/public/tmpl/cairo-font.sgml         |  7 +++++--
 doc/public/tmpl/cairo-matrix.sgml       |  2 +-
 doc/public/tmpl/cairo-pattern.sgml      | 12 +++++++++---
 doc/public/tmpl/cairo-status.sgml       |  5 +++--
 doc/public/tmpl/cairo-surface.sgml      |  8 +++++++-
 doc/public/tmpl/cairo-xcb-xrender.sgml  |  3 ++-
 doc/public/tmpl/cairo-xcb.sgml          |  3 ++-
 doc/public/tmpl/cairo-xlib-xrender.sgml |  3 ++-
 doc/public/tmpl/cairo-xlib.sgml         |  3 ++-
 9 files changed, 33 insertions(+), 13 deletions(-)

commit 587508528c4a318649ecb347b96fbc89a40175ea
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:12:16 2008 -0500

    [doc] Minor improvement

 doc/public/tmpl/cairo-beos.sgml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fd5dfedbb75593539eeda92013042ce5423a65c4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:02:44 2008 -0500

    [doc/public/check-doc-coverage.sh] Test that doc coverage is 100%
    
    Yay!

 doc/public/Makefile.am           |  2 ++
 doc/public/check-doc-coverage.sh | 43 ++++++++++++++++++++++++++++++++++++++++
 2 files changed, 45 insertions(+)

commit c133ee5acc7c97fcd43d61f5aad160ca96c47941
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 21:00:21 2008 -0500

    [doc] Improve docs for new API

 src/cairo-image-surface.c |  8 ++++----
 src/cairo-xlib-surface.c  | 20 +++++++++++++-------
 2 files changed, 17 insertions(+), 11 deletions(-)

commit 0d898f2badf41d3b0ae5ee88943c44cf49690f5d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:49:44 2008 -0500

    [doc] Make sure all type names in docs are prefixed by #

 src/cairo-array.c                       |  2 +-
 src/cairo-bentley-ottmann.c             |  4 ++--
 src/cairo-cache-private.h               |  4 ++--
 src/cairo-cache.c                       |  2 +-
 src/cairo-fixed-type-private.h          |  2 +-
 src/cairo-font-face.c                   | 12 ++++++------
 src/cairo-font-options.c                |  2 +-
 src/cairo-ft-font.c                     | 12 ++++++------
 src/cairo-gstate.c                      |  8 ++++----
 src/cairo-hash.c                        |  2 +-
 src/cairo-image-surface.c               |  4 ++--
 src/cairo-matrix.c                      | 10 +++++-----
 src/cairo-mutex-type-private.h          |  6 +++---
 src/cairo-pattern.c                     | 10 +++++-----
 src/cairo-pdf-surface.c                 |  2 +-
 src/cairo-png.c                         |  2 +-
 src/cairo-ps-surface.c                  | 12 ++++++------
 src/cairo-quartz-surface.c              |  2 +-
 src/cairo-rectangle.c                   |  8 ++++----
 src/cairo-region.c                      |  2 +-
 src/cairo-scaled-font-subsets-private.h |  8 ++++----
 src/cairo-scaled-font.c                 |  8 ++++----
 src/cairo-traps.c                       |  2 +-
 src/cairo-types-private.h               |  2 +-
 src/cairo-win32-surface.c               |  2 +-
 src/cairo-xlib-surface.c                |  4 ++--
 src/cairo.c                             |  4 ++--
 src/cairo.h                             | 16 ++++++++--------
 src/cairoint.h                          |  4 ++--
 29 files changed, 79 insertions(+), 79 deletions(-)

commit 9ecde82d35ead4975ce110bb2012264e3ca9d2e1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:48:48 2008 -0500

    [doc] Make sure all macro names in docs are prefixed by %

 src/cairo-array.c                       |  6 ++---
 src/cairo-bentley-ottmann.c             |  8 +++----
 src/cairo-cache.c                       |  6 ++---
 src/cairo-deprecated.h                  |  2 +-
 src/cairo-directfb.h                    |  4 ++--
 src/cairo-fixed-type-private.h          |  2 +-
 src/cairo-freelist-private.h            |  4 ++--
 src/cairo-ft-font.c                     |  6 ++---
 src/cairo-gstate.c                      | 14 +++++------
 src/cairo-hash.c                        | 36 ++++++++++++++--------------
 src/cairo-image-surface.c               |  4 ++--
 src/cairo-lzw.c                         | 14 +++++------
 src/cairo-meta-surface.c                |  6 ++---
 src/cairo-mutex-private.h               |  4 ++--
 src/cairo-mutex-type-private.h          | 24 +++++++++----------
 src/cairo-os2.h                         |  6 ++---
 src/cairo-output-stream-private.h       |  6 ++---
 src/cairo-paginated-private.h           |  4 ++--
 src/cairo-path-fill.c                   |  2 +-
 src/cairo-path.c                        | 12 +++++-----
 src/cairo-pattern.c                     |  2 +-
 src/cairo-pdf-surface.c                 |  2 +-
 src/cairo-png.c                         | 10 ++++----
 src/cairo-ps-surface.c                  | 12 +++++-----
 src/cairo-scaled-font-subsets-private.h | 42 ++++++++++++++++-----------------
 src/cairo-scaled-font.c                 |  4 ++--
 src/cairo-surface-fallback.c            |  6 ++---
 src/cairo-surface.c                     | 10 ++++----
 src/cairo-svg-surface.c                 |  4 ++--
 src/cairo-types-private.h               |  4 ++--
 src/cairo-win32-font.c                  |  4 ++--
 src/cairo-win32-surface.c               | 10 ++++----
 src/cairo-xcb-surface.c                 |  2 +-
 src/cairo-xlib-surface.c                |  4 ++--
 src/cairo.c                             | 26 ++++++++++----------
 src/cairo.h                             | 10 ++++----
 src/cairoint.h                          |  6 ++---
 src/test-fallback-surface.c             |  4 ++--
 38 files changed, 166 insertions(+), 166 deletions(-)

commit 099c3c2602b59fbf9424044caa1fec7eb92f71df
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:32:35 2008 -0500

    [doc] Another enum nick expansion

 src/cairo-scaled-font.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 72feed5b54e1aa725c3c5238b21946b6250503fe
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:16:01 2008 -0500

    [doc] Update templates for recently added APIs

 doc/public/cairo-sections.txt           |  2 ++
 doc/public/tmpl/cairo-image.sgml        | 10 ++++++++++
 doc/public/tmpl/cairo-paths.sgml        |  2 +-
 doc/public/tmpl/cairo-status.sgml       |  1 +
 doc/public/tmpl/cairo-xlib-xrender.sgml |  9 +++++++++
 5 files changed, 23 insertions(+), 1 deletion(-)

commit b7d43d235c01480b5a5a34db6fea8a3d86161d91
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 20:14:52 2008 -0500

    [src/check-*] Shut make up

 src/check-def.sh | 4 ++--
 src/check-plt.sh | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit dd7ce762946ec03fc115310c7e295b3327d7e805
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 19:54:27 2008 -0500

    [doc] Expand a couple nicks to full enum names

 src/cairo.h | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c624ff46541b311c226ad7a026db3495b59dee41
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 19:45:10 2008 -0500

    [cairo_operator_t] Improve docs

 src/cairo.h | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit f1271babcd4df1140019b258ca0af0d7da0d1328
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 19:37:46 2008 -0500

    [doc] Add Long_Description and some See_Also for all chapters

 doc/public/tmpl/cairo-atsui.sgml        |  6 ++++--
 doc/public/tmpl/cairo-beos.sgml         |  7 +++++--
 doc/public/tmpl/cairo-font-options.sgml | 11 ++++++++---
 doc/public/tmpl/cairo-font.sgml         | 12 ++++++++++--
 doc/public/tmpl/cairo-ft.sgml           |  7 +++++--
 doc/public/tmpl/cairo-glitz.sgml        |  7 +++++--
 doc/public/tmpl/cairo-image.sgml        | 15 ++++++++-------
 doc/public/tmpl/cairo-matrix.sgml       |  5 +++--
 doc/public/tmpl/cairo-paths.sgml        |  4 +++-
 doc/public/tmpl/cairo-pattern.sgml      | 13 +++++++++----
 doc/public/tmpl/cairo-pdf.sgml          |  7 +++++--
 doc/public/tmpl/cairo-png.sgml          |  7 +++++--
 doc/public/tmpl/cairo-ps.sgml           |  7 +++++--
 doc/public/tmpl/cairo-quartz.sgml       |  7 +++++--
 doc/public/tmpl/cairo-scaled-font.sgml  | 13 +++++++++----
 doc/public/tmpl/cairo-status.sgml       | 19 ++++++++++++++++--
 doc/public/tmpl/cairo-surface.sgml      |  8 ++++++--
 doc/public/tmpl/cairo-svg.sgml          |  7 +++++--
 doc/public/tmpl/cairo-text.sgml         | 34 ++++++++++++++++++++++++++++++---
 doc/public/tmpl/cairo-transforms.sgml   | 10 ++++++++--
 doc/public/tmpl/cairo-types.sgml        |  4 ++--
 doc/public/tmpl/cairo-win32-fonts.sgml  |  7 +++++--
 doc/public/tmpl/cairo-win32.sgml        |  7 +++++--
 doc/public/tmpl/cairo-xcb-xrender.sgml  | 10 ++++++++--
 doc/public/tmpl/cairo-xcb.sgml          |  8 +++++++-
 doc/public/tmpl/cairo-xlib-xrender.sgml | 12 +++++++++---
 doc/public/tmpl/cairo-xlib.sgml         |  8 +++++++-
 doc/public/tmpl/cairo.sgml              |  4 +++-
 28 files changed, 202 insertions(+), 64 deletions(-)

commit 73b184fb9c41f26365c99dbb5f81aa5166632722
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 19:19:27 2008 -0500

    [src] Fix gtk-doc warnings

 src/cairo-scaled-font.c | 2 +-
 src/cairo-surface.c     | 2 +-
 src/cairo.c             | 6 +++---
 3 files changed, 5 insertions(+), 5 deletions(-)

commit 8709b943c6f0025c65081b23ea24ce606150cf49
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 16:15:28 2008 -0800

    Fix some documentation typos

 src/cairo.h | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit e48d7ca802acba300aee99def0eb01727fe2f58a
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 16:11:39 2008 -0800

    Add example to documentation of cairo_pattern_set_filter
    
    It's helpful to let the reade know about cairo_get_source here.

 src/cairo-pattern.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit cd26fa266b51ffd91aa9f2c60dd353c53729291e
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 16:10:10 2008 -0800

    Add documentation for cairo_filter_t

 src/cairo.h | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 7c00269e00332974c3a2843272f84960a90b9fb7
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Jan 27 12:36:19 2008 -0800

    Add pdf-specific reference images for meta-surface-pattern
    
    This test has been "failing" ever since we had native
    replay of metasurfaces to pdf. But looking at the results,
    they are actually superior to the image-backend reference
    images.

 test/meta-surface-pattern-pdf-ref.png       | Bin 0 -> 4111 bytes
 test/meta-surface-pattern-pdf-rgb24-ref.png | Bin 0 -> 4009 bytes
 2 files changed, 0 insertions(+), 0 deletions(-)

commit 9cd198d200e4470d3451581b9e672a87d5d91719
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 15:37:22 2008 -0800

    Test the no-Render-extension-available case in get-xrender-format

 test/get-xrender-format.c | 13 ++++++++++++-
 1 file changed, 12 insertions(+), 1 deletion(-)

commit d7fd3bd536465881446686305622d31fdc6fd48f
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Jan 27 12:14:51 2008 -0800

    Add get-xrender-format test to test cairo_xlib_surface_get_xrender_format

 test/.gitignore           |   1 +
 test/Makefile.am          |   5 +++
 test/get-xrender-format.c | 104 ++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 110 insertions(+)

commit cc94dce25085fef936b7cb36cf9fc41569668eba
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 15:26:15 2008 -0800

    Return NULL from cairo_xlib_surface_get_xrender_format without an error
    
    The NULL return value will only happen if the X Render extension
    is not available. We've already got that NULL return value
    documented, so it's not an error if the user asks for it. In
    particular, it's definitely not a surface-type mismatch.

 src/cairo-xlib-surface.c | 6 +-----
 1 file changed, 1 insertion(+), 5 deletions(-)

commit 3c018a6e5abe099fa916f45ecf0c8e9dd5771fae
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Jan 27 12:13:13 2008 -0800

    Add new API cairo_xlib_surface_get_render_format

 src/cairo-xlib-surface.c | 27 +++++++++++++++++++++++++++
 src/cairo-xlib-xrender.h |  3 +++
 2 files changed, 30 insertions(+)

commit 88811540722d891b987efa6fa8edcbab7e10feeb
Author: Carl Worth <cworth@cworth.org>
Date:   Sun Jan 27 11:12:14 2008 -0800

    Add missing cairo_private (for _pixman_format_to_masks)

 src/cairoint.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3841cc0932ac77540c306c1c70a6171d7d00cf3e
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 15:12:38 2008 -0800

    Clarify the documentation of stride within cairo_image_surface_create_for_data

 src/cairo-image-surface.c | 23 +++++++++++++++--------
 1 file changed, 15 insertions(+), 8 deletions(-)

commit 13a5624277adf7e87f66d674ce8073013b53bece
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 28 14:29:36 2008 -0800

    Rename cairo_image_surface_stride_for_width to cairo_format_stride_for_width
    
    Thanks for Behdad for the suggested name improvement. Also, make
    it more clear that the stride passed to cairo_image_surface_create_for_data
    should come from calling cairo_format_stride_for_width with the
    same width.

 src/cairo-image-surface.c | 21 +++++++++++----------
 src/cairo.h               |  4 ++--
 test/a8-mask.c            | 11 ++++++-----
 3 files changed, 19 insertions(+), 17 deletions(-)

commit dc67de3d8b6154b74a243cd7b63e45f343520256
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 26 23:12:14 2008 -0800

    Add cairo_image_surface_stride_for_width
    
    Document this function as a required call to get the correct
    stride value before calling cairo_image_surface_create_for_data.
    This means that previously-failing calls with non-multiple-of-4
    stride values are now documented as errors. Also, we now have
    the possibility of moving to more stringent alignment constraints,
    (one can imagine doing 64-bit or 128-bit boundaries for example).

 src/cairo-image-surface.c |  60 +++++++++++++++++----
 src/cairo-surface.c       |   3 ++
 src/cairo.c               |   4 +-
 src/cairo.h               |   8 ++-
 test/Makefile.am          |   4 --
 test/a8-mask.c            | 132 ++++++++++++++++++++++++++++++++++++++++------
 6 files changed, 179 insertions(+), 32 deletions(-)

commit b151cb0709364bed03e4918b79f26ef3243948ca
Author: Carl Worth <cworth@cworth.org>
Date:   Sat Jan 26 16:42:26 2008 -0800

    Rename cairo_format_width to cairo_format_bits_per_pixel and correct its logic

 src/cairo-image-surface.c | 6 +++---
 src/cairo-scaled-font.c   | 3 ++-
 src/cairoint.h            | 4 ++--
 3 files changed, 7 insertions(+), 6 deletions(-)

commit 538ace5b51c968a81ea1d4c8d7538f0a227661c6
Author: Nis Martensen <nis.martensen@web.de>
Date:   Sat Jan 26 19:11:26 2008 +0100

    re-indent xml after removal of structuring level

 doc/public/cairo-docs.xml | 76 +++++++++++++++++++++++------------------------
 1 file changed, 38 insertions(+), 38 deletions(-)

commit 642e1af892353d55edd6ebe71720fb541c9deb22
Author: Nis Martensen <nis.martensen@web.de>
Date:   Sat Jan 26 19:05:16 2008 +0100

    remove empty tutorial stub and one level of structuring

 doc/public/cairo-docs.xml | 6 ------
 1 file changed, 6 deletions(-)

commit be93e61d70f4e32069448b79cca7eacab6035c6c
Author: Nis Martensen <nis.martensen@web.de>
Date:   Sat Jan 26 18:44:32 2008 +0100

    Add index of new symbols in 1.6

 doc/public/cairo-docs.xml | 3 +++
 1 file changed, 3 insertions(+)

commit 0874834ec4606c5ff960588077d5310927d560ba
Author: Nis Martensen <nis.martensen@web.de>
Date:   Sat Jan 26 16:59:21 2008 +0100

    Describe cairo_operator_t, add link to operators/ wiki page

 src/cairo.h | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit b18bc660c6d5d5018b4cfaf0eaf0278669cac1ac
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Jan 28 02:33:58 2008 -0500

    [test/font-matrix-translation] Fix function signature

 test/font-matrix-translation.c | 13 ++++++++++---
 1 file changed, 10 insertions(+), 3 deletions(-)

commit 936edecb35b94213997fdb172f0256c658f416aa
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sun Jan 27 16:52:39 2008 -0800

    [quartz] only use DrawTiledImage if transformed image is integer aligned
    
    This Quartz API seems to only tile at integer coordinates; if the source image is
    scaled to anything less than integer-aligned, seams appear between tiles.  Detect
    this and fall back to slower but more general CGPattern path.

 src/cairo-quartz-surface.c | 144 ++++++++++++++++++++++++---------------------
 1 file changed, 77 insertions(+), 67 deletions(-)

commit 182b02240192c03b1fae5367573962d527f8aad4
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Sat Jan 26 10:57:20 2008 -0800

    [win32] Fix initial clip region test
    
    I misread the docs; GetClipBox's return value doesn't necessarily correspond to
    GetClipRgn's region type.

 src/cairo-win32-surface.c | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 0e737632905e61f4d76b6b2c4e5908d75a5cddda
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 27 02:19:47 2008 -0500

    [src] Fix make check

 src/cairo-quartz-surface.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b3eea75d1f7b56c2046b5387a5eb186d8f154184
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Jan 26 13:56:08 2008 -0500

    Change cairo_get_current_point() to return cairo_status_t instead of void
    
    So we can return CAIRO_STATUS_NO_CURRENT_POINT.  Previously it wasn't easy
    to fetch that information.

 src/cairo.c | 22 ++++++++++++++++++----
 src/cairo.h |  2 +-
 2 files changed, 19 insertions(+), 5 deletions(-)

commit 79383841520af3a7de3018befca37be6a037f9ba
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 19:48:36 2008 -0500

    [doc] Update list of private header files

 doc/public/Headers.mk | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 58f6aed93d137b77a2550bcace16f8d5573d45ef
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 19:47:07 2008 -0500

    [doc] Update for recent API changes

 doc/public/tmpl/cairo-paths.sgml   | 2 ++
 doc/public/tmpl/cairo-status.sgml  | 1 +
 doc/public/tmpl/cairo-surface.sgml | 2 --
 3 files changed, 3 insertions(+), 2 deletions(-)

commit 45e7ba356d308f67f674a20484a55d41fe922d13
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 19:46:43 2008 -0500

    [cairo-pdf-operators] Reformat typedef to not confuse gtk-doc

 src/cairo-pdf-operators-private.h | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit 756420a780e870bed6f174ca7f3f14421d1ff7d2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 19:38:27 2008 -0500

    [cairo_surface_show/copy_page()] Make them return void, like cairo_show/copy_page() do

 src/cairo-gstate.c            |  6 ++++--
 src/cairo-paginated-surface.c | 12 ++++++++----
 src/cairo-surface.c           | 33 ++++++++++++++++++---------------
 src/cairo-svg-surface.c       |  5 +++--
 src/cairo.h                   |  4 ++--
 5 files changed, 35 insertions(+), 25 deletions(-)

commit c4ec5539ca7380dccf1a2f797e536c7273b5c2b5
Author: Nis Martensen <nis.martensen@web.de>
Date:   Fri Jan 25 19:13:13 2008 -0500

    [cairo-surface] Fix doc typo

 src/cairo-surface.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ab188f2e90b49fc4e07f04dc512f9fb9864efa0b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 17:44:26 2008 -0500

    [cairo-ft] Disable embedded bitmaps if hinting style NONE is requested

 src/cairo-ft-font.c | 11 ++++++++---
 1 file changed, 8 insertions(+), 3 deletions(-)

commit 2df9944a8ac48cb43845e56c5483bf77dafda584
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 17:12:34 2008 -0500

    [.gitignore] Add check-has-hidden-symbols.i

 src/.gitignore | 1 +
 1 file changed, 1 insertion(+)

commit 3d2144b6af07ca44b6fbf1c96080b7e2b7c0285c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 17:06:11 2008 -0500

    [cairo-ft] Fix font metrics computation for bitmap fonts and no metrics-hinting
    
    Preivously we were returning NAN font metrics.  Fixed now.  Makes bitmap-font
    test pass again.

 src/cairo-ft-font.c | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit c621d8d7191bfa8c1bca533bf9d53d514d01f529
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Fri Jan 25 15:01:44 2008 -0800

    [ps] Pad image mask lines out to full lines
    
    The PostScript backend was generating image masks with packed mask
    bits, when PS seems to expect each line of the mask to be padded out
    to 8 bytes.
    
    Ref: https://bugzilla.mozilla.org/show_bug.cgi?id=407360

 src/cairo-ps-surface.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit bae496df11247a1e4aff8b0df3356701f8a11792
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 08:03:32 2008 -0500

    [test/bitmap-font] Test under all combinations of hinting, test font metrics too
    
    This is now failing as we compute NAN font metrics for bitmap-only fonts under
    disabled metrics hinting.  A very infamous bug excercised with PangoCairo's PDF
    output.

 test/bitmap-font.c | 102 ++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 94 insertions(+), 8 deletions(-)

commit 20c8531243c2f2ee220bd1f234cdba6fc3d6d4c7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 07:14:07 2008 -0500

    [test/text-zero-len] Test text and font extents for font size 0

 test/text-zero-len.c | 52 ++++++++++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 50 insertions(+), 2 deletions(-)

commit 83bd590760629b61898ed403e273046545f26767
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 07:02:25 2008 -0500

    [test] Test that cairo_text_extents() and cairo_scaled_font_text_extents() match
    in results.

 test/font-matrix-translation.c | 31 ++++++++++++++++++++++++++++++-
 1 file changed, 30 insertions(+), 1 deletion(-)

commit 4c432b09557f52fa35be981743272b33baca6232
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 04:16:44 2008 -0500

    [cairo-scaled-font] Fix bug in glyphs bounding box computation
    
    In 02970ac8cf27bc9d42cf27848a97019d9dd13b6d Vlad introduced the following
    innocent-looking change:
    
    -    short min_x = INT16_MAX, max_x = INT16_MIN;
    -    short min_y = INT16_MAX, max_y = INT16_MIN;
    +    cairo_point_int_t min = { CAIRO_RECT_INT_MIN, CAIRO_RECT_INT_MIN };
    +    cairo_point_int_t max = { CAIRO_RECT_INT_MAX, CAIRO_RECT_INT_MAX };
    
    Well, read it carefully... yeah.  That caused each show glyph operation
    upload a mask the size of the surface.  With evince/poppler and certain
    PDF files that each glyph is rendered in its own cairo_show_glyphs()
    call, that meant a 20x slowdown in rendering a page of PDF.
    
    If still wondering what's wrong with that change, here is the answer:
    
    -    cairo_point_int_t min = { CAIRO_RECT_INT_MIN, CAIRO_RECT_INT_MIN };
    -    cairo_point_int_t max = { CAIRO_RECT_INT_MAX, CAIRO_RECT_INT_MAX };
    +    cairo_point_int_t min = { CAIRO_RECT_INT_MAX, CAIRO_RECT_INT_MAX };
    +    cairo_point_int_t max = { CAIRO_RECT_INT_MIN, CAIRO_RECT_INT_MIN };
    
    Yay for git-bisect.

 src/cairo-scaled-font.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8983208f456c6f570698df46174faa0208d6de5f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 01:00:21 2008 -0500

    [configure.in] Require pixman >= 0.9.6
    
    I was experiencing very weird rendering problems and crashes in evince with
    pixman 0.9.4.  Upgrading to pixman 0.9.6 fixed the all.  Lets just require it.

 configure.in | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5dfe47a3f14ee8597395dc53ff57fd429e9804cd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Jan 25 00:35:11 2008 -0500

    [cairo-scaled-font] Unbreak it after my recent commit
    
    Sigh.

 src/cairo-scaled-font.c | 41 +++++++++++++++++++----------------------
 1 file changed, 19 insertions(+), 22 deletions(-)

commit efd3a965244305a069ec231b7ec28cff8d6c67c8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 23:35:06 2008 -0500

    [cairo-scaled-font] Don't err on font size 0, really
    
    First, seems like we were rejecting degenerate font matrix right away
    at the constructor.  Don't do that.
    
    Next, PS/PDF were inverting the font scale matrix, assuming that it's
    invertible.  We now keep the inverse too, so they can use it.  For the
    case of a size 0 font, both the scale matrix and its invert are set to
    0,0,0,0.  That's safe, even if slightly inconsistent.

 src/cairo-pdf-surface.c         |  5 +----
 src/cairo-ps-surface.c          |  5 +----
 src/cairo-scaled-font-private.h |  1 +
 src/cairo-scaled-font.c         | 19 ++++++++-----------
 4 files changed, 11 insertions(+), 19 deletions(-)

commit 45f269e33020d8d7cf247926712b9c64c1fb8959
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 22:39:28 2008 -0500

    [cairo-scaled-font] Oops, return err if not handling it

 src/cairo-scaled-font.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 6d0dc3e0760e6bc6b0eceab48674410b4e865287
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Jan 24 22:24:23 2008 -0500

    [cairo-scaled-font] Don't err on font size 0

 src/cairo-scaled-font.c | 18 ++++++++++++++++--
 1 file changed, 16 insertions(+), 2 deletions(-)

commit ea9afecc9aaa87c2df14dc9126c75ac0e3e5b13f
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 24 11:48:02 2008 -0800

    [quartz] Do dynamic symbol lookups for 10.4/10.5 optimization symbols
    
    The gcc-__attribute-__ based weak linking was causing all sorts of problems;
    do dlsym lookups at runtime instead.

 src/cairo-quartz-surface.c | 39 ++++++++++++++++++++++++++++-----------
 1 file changed, 28 insertions(+), 11 deletions(-)

commit 287de2ce5883daa4238c534e0d4890cb640d7fb7
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Wed Jan 23 21:30:42 2008 -0800

    [quartz] Clean up unused APIs a bit
    
    The data parameter from get_image was never really used; get rid of it and clean up
    callers.  Also get rid of a chunk of dead code in release_dest_image.

 src/cairo-quartz-surface.c | 76 ++++++++--------------------------------------
 1 file changed, 13 insertions(+), 63 deletions(-)

commit b96c6c26c2d6b0b5f79ee569ece602338c4146b2
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 24 11:04:26 2008 -0800

    [win32] Print non-black/white text correctly in show_glyphs

 src/cairo-win32-printing-surface.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 8e7c0db8018b258fc367da1e5502e9e13bad098c
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Thu Jan 24 11:01:55 2008 -0800

    [win32] Better tracking of initial clip
    
    There were a few corner cases that the win32 surface was failing
    at when there was an initial clip set; the win32-printing surface
    had more serious problems when painting meta surface patterns.
    This cleans up the initial DC clip tracking for both surfaces.

 src/cairo-win32-printing-surface.c |  69 +++++-------
 src/cairo-win32-private.h          |  23 +++-
 src/cairo-win32-surface.c          | 221 +++++++++++++++++++++++++------------
 3 files changed, 197 insertions(+), 116 deletions(-)

commit c05e3b08b4cfa820a18e33b5012a6138b931788f
Author: Carl Worth <cworth@cworth.org>
Date:   Thu Jan 24 09:51:58 2008 -0800

    Remove ROADMAP and TODO, mentioning their URLs in README
    
    We're maintaining these as part of cairo's website now,
    rather than as part of the source code.

 README  |  18 ++++----
 ROADMAP | 149 ----------------------------------------------------------------
 TODO    | 111 -----------------------------------------------
 3 files changed, 8 insertions(+), 270 deletions(-)

commit 21823842775988c0b58e3868dce053544ed246e2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 15:06:52 2008 -0500

    [test] Minor fix for check-ref-dups rule

 test/Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit e7c0a69dcb627abb677f84473a9e3857b2d89a69
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Jan 23 14:57:42 2008 -0500

    [test] Also check for reference images listed in Makefile.am but missing
    in git, and if this is not a git checkout, in source directory.

 test/Makefile.am | 36 +++++++++++++++++++++++++++---------
 1 file changed, 27 insertions(+), 9 deletions(-)

commit 188765c8e857c88a66656a454a3dbd27c32170f7
Author: Bertram Felgenhauer <int-e@gmx.de>
Date:   Wed Jan 23 19:22:18 2008 +0100

    improve comments for the pixman transformation anchoring math.

 src/cairo-matrix.c | 14 +++++++++++++-
 1 file changed, 13 insertions(+), 1 deletion(-)

commit b6c723644302c43b7aae098338092e578fe2f007
Author: Bertram Felgenhauer <int-e@gmx.de>
Date:   Wed Jan 23 18:09:20 2008 +0100

    update reference images for some non-aa testcases

 test/rectangle-rounding-error-ref.png   | Bin 298 -> 231 bytes
 test/rotate-image-surface-paint-ref.png | Bin 232 -> 209 bytes
 test/unantialiased-shapes-ref.png       | Bin 4449 -> 3968 bytes
 3 files changed, 0 insertions(+), 0 deletions(-)

commit 5a0b15d2c9b5e9ef3aed1f01e8ea28a3f2c36216
Author: Bertram Felgenhauer <int-e@gmx.de>
Date:   Wed Jan 23 18:02:02 2008 +0100

    anchor pattern transformations at the pattern origin
    This keeps the rounding errors due to the conversion to 16.16 fixed point
    numbers small and improves cairo's translation invariance.

 src/cairo-matrix.c | 23 +++++++++++++++++++++++
 1 file changed, 23 insertions(+)

commit 431e846c03b39495ac57834a8b65b7499472ef1b
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Jan 22 16:30:37 2008 -0800

    cairo_point_int32_t is really int32_t, not int16_t
    
    Oops.

 src/cairo-types-private.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 02970ac8cf27bc9d42cf27848a97019d9dd13b6d
Author: Vladimir Vukicevic <vladimir@pobox.com>
Date:   Tue Jan 22 15:32:11 2008 -0800

    Fix usage of cairo_rectangle_int16_t leading to memory corruption
    
    cairo_rectangle_int16_t was being used in a number of places instead
    of cairo_rectangle_int_t, which led to memory corruption when cairo was
    using a fixed point format with a bigger space than 16.16 (such as 24.8).

 src/cairo-analysis-surface.c |  3 +++
 src/cairo-pdf-surface.c      |  6 +++---
 src/cairo-scaled-font.c      | 24 ++++++++++++------------
 src/cairo-surface-fallback.c |  9 ++-------
 src/cairo-win32-private.h    |  2 +-
 src/cairo-xcb-surface.c      |  4 ++--
 src/cairo-xlib-surface.c     |  4 ++--
 src/cairoint.h               |  2 +-
 8 files changed, 26 insertions(+), 28 deletions(-)

commit 1109ccfb4e5b078581a3b4a7e2d152681fa863ec
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 17:44:47 2008 -0500

    [ROADMAP] Add item: Make cairo-ft respect FC_FT_FACE pattern element

 ROADMAP | 2 ++
 1 file changed, 2 insertions(+)

commit 5024650d4d8d4fa890a531d9e54fed7beef8e2c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 12:45:50 2008 -0500

    [test] Only summarize check results for the tests tested!

 test/Makefile.am | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 18181f12ae6c412fea984484355ff8bc1dfccb54
Author: Carl Worth <cworth@cworth.org>
Date:   Tue Jan 22 06:25:19 2008 -0800

    Make Carl return from his time-traveling expedition

 test/rectilinear-miter-limit.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 95f3b425e6fb31b364b08e53e072fac4f5ed0733
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 01:03:02 2008 -0500

    [cairo-path-stroke] Use M_SQRT2 for constant value

 src/cairo-path-stroke.c | 8 ++++----
 src/cairoint.h          | 4 ++++
 2 files changed, 8 insertions(+), 4 deletions(-)

commit 1931ce1b3d491afe4f23670c82e428f95eb25e6d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Jan 22 00:36:25 2008 -0500

    [cairo-operator] Remove unused cairo-operator.c

 src/Makefile.am      |   1 -
 src/cairo-operator.c | 119 ---------------------------------------------------
 src/cairoint.h       |   7 ---
 3 files changed, 127 deletions(-)

commit 47cf7ed769891b00abf96d14de6e79c0fa893cf9
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 16:45:41 2008 -0800

    Test and document that fill rule has no effect on cairo_path_extents

 src/cairo.c             |  4 ++--
 test/get-path-extents.c | 49 +++++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 51 insertions(+), 2 deletions(-)

commit 1ca186f51134e7d5969937760b068caba0070d31
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 16:34:24 2008 -0800

    Disable rectilinear stroke optimization for small miter limit values
    
    This fixes the bug that was causing the recently added
    rectilinear-miter-limit test case to fail. It passes
    quite happily now.

 src/cairo-path-stroke.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 32efcc94627e8890969c4b36a78c831ced6f8d62
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 16:32:48 2008 -0800

    Add new rectilinear-miter-limit test to demonstrate bug
    
    We're failing to respect the miter limit in the rectilinear
    stroke optimization code.

 test/.gitignore                      |   1 +
 test/Makefile.am                     |   2 +
 test/rectilinear-miter-limit-ref.png | Bin 0 -> 177 bytes
 test/rectilinear-miter-limit.c       |  80 +++++++++++++++++++++++++++++++++++
 4 files changed, 83 insertions(+)

commit 326342962daa694d876c03194e8a6c1b13f9a8d2
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 15:20:07 2008 -0800

    Rename trailing_move_to_point to move_to_point
    
    And prefer TRUE and FALSE literals over 1 and 0.

 src/cairo-path-bounds.c | 24 +++++++++++++-----------
 1 file changed, 13 insertions(+), 11 deletions(-)

commit c480eedbb58dd03dd4b9b87b3985758ffbce7113
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 14:56:21 2008 -0800

    Test and document extents of degenerate "dots"
    
    It's a common idiom to stroke degenerate sub-paths made with
    cairo_move_to(x,y);cairo_rel_line_to(0,0) to draw dots. Test
    that we get the desired extents from cairo_fill_extents,
    cairo_stroke_extents, and cairo_path_extents for these cases.
    
    Also document that the cairo_path_extents result is equivalent
    to the limit of stroking with CAIRO_LINE_CAP_ROUND, (so that
    these "dot" points are included), as the line width
    approaches 0.0 .

 src/cairo.c             |  6 +++---
 test/get-path-extents.c | 28 ++++++++++++++++++++++++++++
 2 files changed, 31 insertions(+), 3 deletions(-)

commit 55e0dddf0408046ea0ded419ebe45099a4eb563e
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 14:45:06 2008 -0800

    Add cairo_path_extents testing to several cases missing it
    
    With these degenerate shapes, cairo_path_extents still returns
    a zero-area rectangle, but with a non-zero offset.

 test/get-path-extents.c | 12 ++++++++----
 1 file changed, 8 insertions(+), 4 deletions(-)

commit 63df3a82a3a4a035edf89152995a324449616059
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 13:47:05 2008 -0800

    Fix cairo_path_extents to ignore lone cairo_move_to points.
    
    Update the documentation as well.

 src/cairo-path-bounds.c | 11 ++++++++++-
 src/cairo.c             | 40 +++++++++++++++++++++++++---------------
 2 files changed, 35 insertions(+), 16 deletions(-)

commit c15cab8b6855540436e457465c4766812c6def55
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 13:34:53 2008 -0800

    Correct near-pangram to be an actual pangram
    
    This wasn't affecting the test quality at all, but it did annoy
    me to see this mistake.

 test/get-path-extents.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ed695bdb9b1e4500f796c7f07a7cc2f3832b2a39
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 13:33:46 2008 -0800

    Define repeated string literal once

 test/get-path-extents.c | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 80df194b77a4caac1d58132341f034596e500bda
Author: Carl Worth <cworth@cworth.org>
Date:   Mon Jan 21 12:14:49 2008 -0800

    Clarify documentation of cairo_{fill,stroke,path}_extents
    
    Mostly just adding more cross-references between the documentation
    of these three similar functions.

 src/cairo.c | 36 +++++++++++++++++++++++++-----------
 1 file changed, 25 insertions(+), 11 deletions(-)

commit eba04b7fbcc7fdbf075ad1372208908634459178
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sun Jan 20 03:22:12 2008 +0000

    [path] use new interpret_flat infrastructure for path_populate
    
    refactor to reduce duplication of flattening code.

 src/cairo-path.c | 50 +++++++++++++-------------------------------------
 1 file changed, 13 insertions(+), 37 deletions(-)

commit 3270ae6a65105787942da8309fa874ee65bc79fe
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sun Jan 20 03:21:41 2008 +0000

    [path] Use new interpret_flat infrastructure for path_count.
    
    Refactor to reduce duplication of path flattening code.

 src/cairo-path-bounds.c |  6 -----
 src/cairo-path.c        | 62 ++++++++++++++-----------------------------------
 2 files changed, 18 insertions(+), 50 deletions(-)

commit 4177208be63caa3128eaf07428f3d4617fcd18e0
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Fri Nov 16 22:43:43 2007 +0000

    [cairo] Add cairo_path_extents()
    
    This new function gets the extents of the current path, whether
    or not they would be inked by a 'fill'. It differs from
    cairo_fill_extents() when the area enclosed by the path is 0.
    
    Includes documentation and updated test.

 doc/public/cairo-sections.txt    |  1 +
 doc/public/tmpl/cairo-paths.sgml | 10 ++++++++++
 src/cairo-gstate.c               | 11 +++++++++++
 src/cairo.c                      | 30 ++++++++++++++++++++++++++++++
 src/cairo.h                      |  5 +++++
 src/cairoint.h                   |  7 +++++++
 test/get-path-extents.c          | 33 +++++++++++++++++++++++----------
 7 files changed, 87 insertions(+), 10 deletions(-)

commit d923457c0f40c9b34ee75d4d47b9bd0c3edfe669
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Jan 19 22:31:49 2008 +0000

    [path-fixed] make _cairo_path_fixed_bounds use _cairo_path_fixed_interpret_flat
    
    _cairo_path_fixed_bounds can use the new _interpret_flat mechanism; this
    results in tighter bounds; previously the bounds followed the control
    points of the beziers, whereas now they are the bounds of the curve.

 src/cairo-analysis-surface.c |  2 +-
 src/cairo-path-bounds.c      | 39 ++++++++++++++-------------------------
 src/cairoint.h               |  3 ++-
 3 files changed, 17 insertions(+), 27 deletions(-)

commit 1471b3f00acddecdfc2617a62ab0e584f319dc1c
Author: Brian Ewins <Brian.Ewins@gmail.com>
Date:   Sat Jan 19 22:31:10 2008 +0000

    [path-fixed] add _cairo_path_fixed_interpret_flat
    
    _cairo_path_fixed_interpret_flat flattens the path as it
    interprets it, meaning that a curve_to callback is not
    required.

 src/cairo-path-fixed.c | 99 ++++++++++++++++++++++++++++++++++++++++++++++++++
 src/cairoint.h         |  9 +++++
 2 files changed, 108 insertions(+)

commit 3339c32b0aa44c4bae6e534f90d26aa342e3d717
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 02:56:26 2008 -0500

    [cairoint.h] Move MSC inline macros into cairo-compiler-private.h
    where they belong

 src/cairo-compiler-private.h | 10 ++++++++++
 src/cairoint.h               | 11 -----------
 2 files changed, 10 insertions(+), 11 deletions(-)

commit ac17ce0f89b494a404756c8d24b21a7fb354218e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Jan 20 02:54:16 2008 -0500

    [cairo-fixed/wideint-private.h] Split out typedefs from prototypes
    such that the type definitions can be used from boilerplate without exposing
    the prototypes.

 src/Makefile.am                  |   2 +
 src/cairo-fixed-private.h        |  34 +---------
 src/cairo-fixed-type-private.h   |  70 +++++++++++++++++++++
 src/cairo-types-private.h        |   2 +-
 src/cairo-wideint-private.h      |  71 +--------------------
 src/cairo-wideint-type-private.h | 130 +++++++++++++++++++++++++++++++++++++++
 src/cairoint.h                   |   1 +
 7 files changed, 208 insertions(+), 102 deletions(-)

commit f072d815d40e6fd44369424b68d54cea22da3a26
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Sat Jan 19 20:48:39 2008 -0500

    [cairo-ft] Fix typo in comment

 src/cairo-ft-font.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 0fb800ff2258d4642a2188a7f219db9620450bc2
Author: Peter Weilbacher <mozilla@weilbacher.org>
Date:   Sat Jan 19 20:47:59 2008 -0500

    [cairo-ft] Add FC_PIXEL_SIZE as double, not int

 src/cairo-ft-font.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8887fb35936bb48acadc19a0c71d1b81ec8b481d
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Jan 20 01:14:19 2008 +1030

    Fix PS/PDF Type 1 font embedding when glyph 0 is used
    
    cairo-scaled-fonts-subsets.c reserves position 0 in each subset for
    glyph 0 (.notdef) as the font embedding of each font type requires
    .notdef as the first glyph. For some reason this was done by reserving
    the position then inserting glyph 0 in the collect function instead of
    just adding the glyph to the hash table when the subset is
    created. The problem this caused was that when an application called
    show_glyphs() with glyph 0, the glyph was added to the hash table
    (because it was not already there) resulting in two .notdef glyphs in
    the subset. This resulted in breakage in the Type 1 subsetting where
    the second .notdef was not emitted and all subsequent glyphs were
    moved up one place resulting in incorrect font encoding in the PS/PDF
    output.
    
    Fix this by adding .notdef to the subset hash table when the subset is
    created.
    
    This fixes #13841.

 src/cairo-scaled-font-subsets.c | 36 +++++++++++++++++++-----------------
 1 file changed, 19 insertions(+), 17 deletions(-)

commit 574bdd01fd5df8f378c901de5cd9b24bd720ad37
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sun Jan 20 00:26:09 2008 +1030

    Type1-subset: Add newline to the end of the font
    
    as some fonts do not have a newline at the end of the last line

 src/cairo-type1-subset.c | 3 +++
 1 file changed, 3 insertions(+)

commit ec272fbd0980e8124d87ff5c17a5b751876fc9e2
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Sat Jan 19 12:46:24 2008 +1030

    Fix PDF extend-reflect test failure
    
    Previously, when emitting image patterns the PDF backend used
    _cairo_pattern_acquire_surface to get the image. For reflected images
    this would return an image containing four images in a reflect
    pattern.  When drawn in a PDF pattern (which only does repeating
    patterns) this would create the reflected pattern in PDF.
    
    For some reason _cairo_pattern_acquire_surface is no longer returning
    a reflected image pattern.
    
    This is fixed by only using _cairo_surface_acquire_source_image to get
    the image and using the same code as is used for reflected
    meta-surface patterns to created a reflected pattern by drawing four
    transformed copies of the image inside the PDF patten.
    
    This is the better way to implement reflected images as we are no
    longer embedding an image four times larger than the original.

 src/cairo-pdf-surface.c | 67 +++++++++++++++++++++++--------------------------
 1 file changed, 32 insertions(+), 35 deletions(-)

commit 50d0767c8bf4c738b86e10be09d5c4fd7e14a05f
Author: Carl Worth <cworth@cworth.org>
Date:   Fri Jan 18 12:41:57 2008 -0800

    Add a1-image-sample and a1-traps-sample tests
    
    Both of these currently fail due to bugs in the way pixman does
    its sampling.

 test/.gitignore              |   2 ++
 test/Makefile.am             |   2 ++
 test/a1-image-sample-ref.png | Bin 0 -> 148 bytes
 test/a1-image-sample.c       |  83 +++++++++++++++++++++++++++++++++++++++++++
 test/a1-traps-sample-ref.png | Bin 0 -> 148 bytes
 test/a1-traps-sample.c       |  72 +++++++++++++++++++++++++++++++++++++
 test/cairo-test.c            |   2 ++
 7 files changed, 161 insertions(+)

commit c11790fded69ed476e7740ed86e4a66bf878d2d3
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 16 16:32:36 2008 -0800

    Quiet a warning about switch without some cairo_surface_type_t enum values

 src/cairo-paginated-surface.c | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 1d6c2d578fa717906ba8fd0a897c52033179e938
Author: Carl Worth <cworth@cworth.org>
Date:   Wed Jan 16 16:19:40 2008 -0800

    Remove some gratuitous assert statements
    
    Calling assert immediately after assigning a literal value is
    very bad form.

 src/cairo-image-surface.c | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit eabd28a655f8ddc73ff71583bb658db796e932cd
Author: Adrian Johnson <ajohnson@redneon.com>
Date:   Fri Jan 18 21:53:04 2008 +1030

    win32-printing: define GRADIENT_FILL_RECT_H  bug #14107
    
    Older versions of mingw do not define this.

 src/cairo-win32-printing-surface.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 0086db893cba90dc73824d77c661d2965ad48112
Author: Chris Wilson <chris@chris-wilson.co.uk>
Date:   Thu Jan 17 22:31:05 2008 +0000

    [cairo-font-options] Treat NULL as a default cairo_font_options_t
    
    Interpret a NULL cairo_font_options_t as the default values - i.e
    as if it were a fresh pointer returned by cairo_font_options_create().

 src/cairo-font-face.c    |  8 +++--
 src/cairo-font-options.c | 51 ++++++++++++++++++++++-----
 src/cairo-ft-font.c      | 16 +++++----
 src/cairo-gstate.c       |  2 +-
 src/cairo-scaled-font.c  | 18 ++++++----
